<?php
/**
 * $Id: export.php 7311 2011-08-19 11:18:02Z shitz $
 * $LastChangedDate: 2011-08-19 17:18:02 +0600 (Fri, 19 Aug 2011) $
 * $LastChangedBy: shitz $
 * MightyRegistration by Mighty Extensions
 * a component for Joomla! 1.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mightyextensions.com/
 * @copyright Copyright (C) 2006 - 2011 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport('joomla.application.component.model');

class JUserModelExport extends JModel
{

	var $_id = null;
	var $_data = null;

	function __construct()
	{
		global $mainframe, $option;
		parent::__construct();
		if(JRequest::getVar('layout') != 'xlstable'){
			$limit		  = $mainframe->getUserStateFromRequest( 'global.list.limit', 'limit', $mainframe->getCfg('list_limit'), 'int' );
			$limitstart	= $mainframe->getUserStateFromRequest( $option.'.export.limitstart', 'limitstart', 0, 'int' );

			$this->setState('limit',      $limit);
			$this->setState('limitstart', $limitstart);
		}
	}

	/*function &getPost()
	 {
	 print_r($_REQUEST);exit;
	 }*/

	function &getData()
	{
		// Load the weblink data
		if ($this->_id != 0)
		{
			$this->_loadData();
			// Initialize some variables
			$user = &JFactory::getUser();
			// Check to see if the category is published
			if (!$this->_data->cat_pub) {
				JError::raiseError( 404, JText::_("Resource Not Found: Category of this filed is not exist.") );
				return;
			}

			// Check whether category access level allows access
			if ($this->_data->cat_access > $user->get('aid', 0) || $this->_data->access > $user->get('aid', 0)) {
				JError::raiseError( 403, JText::_('ALERTNOTAUTH') );
				return;
			}
		}
		else  $this->_initData();

		return $this->_data;
	}
	function getExportableFieldList()
	{
		$include_type_list = array( "select", "checkbox","mult_select", "radio", "date", "calendar", "phone", "text", "textarea" );
		$include_type_list = " f.type IN('" . implode( "','", $include_type_list ) . "') ";

		$query = "SELECT f. * , f.id as field_id, c.title as cat_title"
		. "\n       FROM #__juser_extended_fields AS f"
		. "\n  LEFT JOIN #__categories            AS c ON c.id = f.catid"
		. "\n      WHERE 1 AND " . $include_type_list
		. "\n   ORDER BY c.ordering, f.ordering"
		;

		$this->_db->setQuery($query);
		$reportable_field_list = $this->_db->loadObjectList();
		return $reportable_field_list;
	}
	function getFieldValues()
	{
		$field = JRequest::getVar('_field_');

		$query = "SELECT f.params"
		. "\n       FROM #__juser_extended_fields AS f"
		. "\n      WHERE 1 AND f.id = ".$field->field_id
		;
		$this->_db->setQuery($query);
		$params_str = $this->_db->loadResult();

		$params = new JParameter( $params_str );

		$field_value_list = $params->get('values');
		if($field_value_list){
			$field_value_list = explode( "\n", str_replace( "\r", "", $field_value_list ) );

			sort($field_value_list);
		} else {
			return array();
		}
		return $field_value_list;
	}

	function getUserForExport()
	{
		$post = JRequest::get('post');
		$output_field_list = $this->fieldListSubquery( $post );

		$where_conditions  = '';
		$where_conditions .= $this->registerDateCondition( $post );
		$where_conditions .= $this->activeCondition( $post );
		if($GLOBALS['is_jcs_exist'] && count(JRequest::getVar('jcssubscr'))){
			$subscriptions = JRequest::getVar('jcssubscr');
			$subscr_state = JRequest::getVar('jcssubscr_state');
			$where_conditions .= $this->subscriptionCondition($subscriptions, $subscr_state);
			$subs_subquery= $this->subscriptionsSubquery($subscriptions);
			if ($subs_subquery)
			{
				$output_field_list.=", $subs_subquery";
			}
		}

		$having_conditions = $this->fieldHavingConditions( $post );

		$ordering          = $this->_buildFieldOrderBy();
        if (JU_REGISTRATION_FORM_LAST_NAME_ENABLE)
		{
            $select_flname = "IF(LOCATE('\n', u.name) > 0, LEFT(u.name, LOCATE('\n', u.name)), u.name) AS first_name, IF(LOCATE('\n', u.name) > 0, SUBSTRING(u.name, (LOCATE('\n', u.name) + 1)), NULL) AS last_name,";
        }
		else
		{
			$select_flname = null;
		}
		$query = "SELECT $select_flname u.*, ".$output_field_list
		. "\n       FROM #__users AS u"
		. "\n      WHERE 1 ".$where_conditions
		. "\n     HAVING 1 ".$having_conditions
		. "\n ". $ordering;
		;
		/*print "<pre>";
		 print str_replace("#__", "jos_",$query);
		 print "</pre>";
		 exit;*/
		//print'<pre><font color="#00bb00">'; print str_replace( '#__', 'jos_', print_r($query,1) ); print'</font></pre>';exit;
		$this->_db->setQuery($query, $this->getState('limitstart'), $this->getState('limit'));
		$userlist = $this->_db->loadObjectList();

		//var_dump($userlist);exit;
		return $userlist;
	}

	function getTotal()
	{
		$post = JRequest::get('hash');

		$output_field_list = $this->fieldListSubquery( $post );

		$where_conditions  = '';
		$where_conditions .= $this->registerDateCondition( $post );
		$where_conditions .= $this->activeCondition( $post );
		$jcs_join = "";
		$jcs_where = "";

		if($GLOBALS['is_jcs_exist'] && count(JRequest::getVar('jcssubscr'))){
			$subscriptions = JRequest::getVar('jcssubscr');
			$subscr_state = JRequest::getVar('jcssubscr_state');
			$where_conditions .= $this->subscriptionCondition($subscriptions, $subscr_state);
			$subs_subquery= $this->subscriptionsSubquery($subscriptions);
			if ($subs_subquery)
			{
				$output_field_list.=", $subs_subquery";
			}
		}

		$having_conditions = $this->fieldHavingConditions( $post );

		$query = "SELECT *, ".$output_field_list
		. "\n       FROM #__users AS u"
		. "\n      WHERE 1 ".$where_conditions
		. "\n     HAVING 1 ".$having_conditions
		;
		
		//some functional improvment to total in pagination
		$select_core = implode(',', $post['core_fields_include']);
		$select_ext = implode(',', $post['extended_fields_include']);
		isset($select_ext)? $select_ext = ','.$select_ext: $select_ext = null;
		$query2 = "SELECT {$select_core}{$select_ext}"
		."\n       FROM #__users AS u";

		$this->_db->setQuery($query);
		/*print "<pre>";
		echo $this->_db->_sql;
		print "</pre>";
		exit;*/
		$userlist = $this->_db->loadObjectList();

		return count($userlist);
	}

	function _buildFieldOrderBy()
	{
		global $mainframe, $option;

		$filter_order		  = $mainframe->getUserStateFromRequest( $option.'.export.filter_order',		'filter_order',		'u.registerDate',	'cmd' );
		$filter_order_Dir	  = $mainframe->getUserStateFromRequest( $option.'.export.filter_order_Dir',	'filter_order_Dir',	'',				'word' );
		/*if ($filter_order == 'a.ordering'){
			$orderby 	= ' ORDER BY category, a.ordering '.$filter_order_Dir;
			} else {*/
		$orderby 	= ' ORDER BY '.$filter_order.' '.$filter_order_Dir.' , u.registerDate ';
		/*}*/
		return $orderby;
	}

	function subscriptionCondition($ids, $state)
	{
		switch ($state) {
			case 1:
				$state = 'extime < NOW() OR published = 0 OR (access_count >= access_limit AND access_limit > 0)';
			break;
			case 2:
				$state = 1;
			break;
			default:
				$state = 'extime >= NOW() AND published = 1 AND (access_count < access_limit OR access_limit = 0)';
			break;
		}
		$selected = count($ids);
		if ($selected)
		{

			$subscriptions = $ids;
			if (in_array(0, $subscriptions))
			{
				$result = " AND u.id NOT IN (SELECT user_id FROM #__jcs_user_subscr) ";
			}
			else
			{
			$result .= " AND (  SELECT count(id)"
					."\n  FROM #__jcs_user_subscr"
					."\n WHERE user_id = u.id AND subscription_id in (".implode(', ',$subscriptions).") AND $state) > 0";
			}
			return $result;
		}
		return "";
	}

	function fieldHavingConditions( &$post )
	{
		$result = array();
		if (count(@$post['value_filter'])<1){$post['value_filter']=array();}
		foreach(@$post['value_filter'] as $key => $field){
			switch(@$field['type']){
				case 'date':
				case 'calendar':
					if(isset($field['condition']['date_from']) && $field['condition']['date_from']){
						$result[] = "field_".$key." >= '".$field['condition']['date_from']."'";
					}
					if(isset($field['condition']['date_to']) && $field['condition']['date_to']){
						$result[] = "field_".$key." <= '".$field['condition']['date_to']."'";
					}
					break;
				case'text':
				case'textarea':
					if(isset($field['condition']) && $field['condition']){
						$result[] = "field_".$key." like '%".$field['condition']."%'";
					}
					break;
				case'radio':
				case'select':
					if(isset($field['condition']) && count( $field['condition'] )){
						$result[] = "('".implode("' =  field_$key OR '", $field['condition'])."' =  field_$key)";
					}
					break;
				case 'mult_select':
				case 'checkbox':
					if(isset($field['condition']) && count( $field['condition'] )){
						$result[] =  "( concat('\n',field_$key,'\n') like '%\n".implode("\n%' OR concat('\n',field_$key,'\n') like '%\n", $field['condition'])."\n%' )";
					}
					break;
				case 'phone':
					$sub_result = array();
					if(isset($field['condition']['country']) && $field['condition']['country']){
						$sub_result[] = "^".$field['condition']['country']."\n(.*)\n(.*)\n(.*)$";
					}
					if(isset($field['condition']['city']) && $field['condition']['city']){
						$sub_result[] = "^(.*)\n".$field['condition']['city']."\n(.*)\n(.*)$";
					}
					if(isset($field['condition']['phone']) && $field['condition']['phone']){
						$sub_result[] = "^(.*)\n(.*)\n".$field['condition']['phone']."\n(.*)$";
					}
					if(isset($field['condition']['extention']) && $field['condition']['extention']){
						$sub_result[] = "^(.*)\n(.*)\n(.*)\n".$field['condition']['extention']."$";
					}

					if(count($sub_result)){
						$result[] = " (field_".$key." REGEXP '".implode("' OR field_".$key." REGEXP '",$sub_result)."')";
					}
					break;
			}
		}
		$result = implode(" AND ", $result);

		if($result){
			$result = ' AND '.$result;
		}

		return $result;
	}

	function fieldListSubquery( & $post )
	{

		$fields = $this->getExportableFieldList();

		foreach($fields  as $field){
			$result[] = ' ( SELECT fvalue FROM #__juser_extended_data WHERE field_id = '.$field->field_id.' AND user_id = u.id) as field_'.$field->field_id.' ';
		}
		return implode( ', ', $result);
	}

	function subscriptionsSubquery($ids = array())
	{
		if (count($ids))
		{
			$sql = "  (SELECT GROUP_CONCAT(DISTINCT(subscr.name) SEPARATOR ', ') FROM #__jcs_plans subscr INNER JOIN #__jcs_user_subscr AS usrsubsrc ON usrsubsrc.subscription_id = subscr.id WHERE usrsubsrc.user_id = u.id ) AS subscriptions ";
			return $sql;
		}
		return "";
	}

	function registerDateCondition( & $post )
	{
		$result  = "";

		if(!empty($post['date_from'])){
			$result .= " AND u.registerDate >= '".$post['date_from']."' ";
		}
		if(!empty($post['date_to'])){
			$result .= " AND u.registerDate <= '".$post['date_to']."' ";
		}

		return $result;
	}

	function activeCondition( & $post )
	{
		$result  = "";

		switch((@$post['active_filter'])){
			case'active':
				$result .= " AND u.block = 0 ";
				break;
			case'blocked':
				$result .= " AND u.block = 1 ";
				break;
			case'both':
				$result .= "";
				break;
			default:
				break;
		}

		return $result;
	}

	function getfieldShowList()
	{
		$include_fields = " f.id IN('" . implode( "','", JRequest::getVar('extended_fields_include', array()) ) . "') ";

		$query = "SELECT f. * , f.id as field_id, c.title as cat_title"
		. "\n       FROM #__juser_extended_fields AS f"
		. "\n  LEFT JOIN #__categories            AS c ON c.id = f.catid"
		. "\n      WHERE 1 AND " . $include_fields
		. "\n   ORDER BY c.ordering, f.ordering"
		;
		$this->_db->setQuery($query);
		$fields = $this->_db->loadObjectList();
		return $fields;
	}

	function getPagination()
	{
		// Lets load the content if it doesn't already exist
		if (empty($this->_pagination))
		{
			jimport('joomla.html.pagination');
			$this->_pagination = new JPagination( $this->getTotal(), $this->getState('limitstart'), $this->getState('limit') );
		}
		return $this->_pagination;
	}
}
?>