<?php
/**
 * $Id: field.php 7311 2011-08-19 11:18:02Z shitz $
 * $LastChangedDate: 2011-08-19 17:18:02 +0600 (Fri, 19 Aug 2011) $
 * $LastChangedBy: shitz $
 * MightyRegistration by Mighty Extensions
 * a component for Joomla! 1.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mightyextensions.com/
 * @copyright Copyright (C) 2006 - 2011 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport('joomla.application.component.model');

class JUserModelField extends JModel
{

	var $_id = null;
	var $_data = null;

	function __construct()
	{
		parent::__construct();

		$array = JRequest::getVar('cid', array(0), '', 'array');
		$this->setId((int)$array[0]);
	}

	function setId($id)
	{
		// Set field id and wipe data
		$this->_id		= $id;
		$this->_data	= null;
	}

	function &getData()
	{
		// Load the weblink data
		if ($this->_id != 0)
		{
		  $this->_loadData();
			// Initialize some variables
			$user = &JFactory::getUser();
			// Check to see if the category is published
			if (!$this->_data->cat_pub) {
				JError::raiseError( 404, JText::_("Resource Not Found: Category of this filed is not exist.") );
				return;
			}

			// Check whether category access level allows access
			if ($this->_data->cat_access > $user->get('aid', 0) || $this->_data->access > $user->get('aid', 0)) {
				JError::raiseError( 403, JText::_('ALERTNOTAUTH') );
				return;
			}
		}
		else  $this->_initData();

		return $this->_data;
	}

	function isCheckedOut( $uid=0 )
	{
		if ($this->_loadData())
		{
			if ($uid) {
				return ($this->_data->checked_out && $this->_data->checked_out != $uid);
			} else {
				return $this->_data->checked_out;
			}
		}
	}

	function checkin()
	{
		if ($this->_id)
		{
			$field = & $this->getTable('fields');
			if(! $field->checkin($this->_id)) {
				$this->setError($this->_db->getErrorMsg());
				return false;
			}
		}
		return false;
	}

	function checkout($uid = null)
	{
		if ($this->_id)
		{
			// Make sure we have a user id to checkout the article with
			if (is_null($uid)) {
				$user	=& JFactory::getUser();
				$uid	= $user->get('id');
			}
			// Lets get to it and checkout the thing...
			$field = & $this->getTable('fields');
			if(!$field->checkout($uid, $this->_id)) {
				$this->setError($this->_db->getErrorMsg());
				return false;
			}

			return true;
		}
		return false;
	}

	function store( & $data )
	{
	  $oldField = $this->getData();

		$row =& $this->getTable('fields');

		// Bind the form fields to the Field table
		if (!$row->bind($data)) {
			$this->setError($this->_db->getErrorMsg());
			return false;
		}

		$this->getPlaceForNewOrdering( $row );

		$row->ordering++;

		if (!$row->store()) {
			$this->setError($this->_db->getErrorMsg());
			return false;
		}
    $this->deletePlaceForOldOrdering( $oldField );
    $data['id'] = $row->id;
		return true;
	}

  function getPlaceForNewOrdering(& $newField )
  {
    $db			= & JFactory::getDBO();
    if ($newField->ordering){
	    $query = "UPDATE `#__juser_extended_fields`"
	          ."\n   SET `ordering` = `ordering`+1"
	          ."\n WHERE `ordering` > ".$newField->ordering." AND `catid` = ".$newField->catid;
    }
    else{
	    $query = "UPDATE `#__juser_extended_fields`"
	          ."\n   SET `ordering` = 1"
	          ."\n WHERE `catid` = ".$newField->catid;    	
    }
		$db->setQuery( $query );
		$db->query();

  }
  function deletePlaceForOldOrdering( & $oldField )
  {
    $db			= & JFactory::getDBO();
    if($oldField->id){
  		$query = "UPDATE `#__juser_extended_fields`"
            ."\n   SET `ordering` = `ordering`-1"
            ."\n WHERE `ordering` > ".$oldField->ordering." AND `catid` = ".$oldField->catid;
  		$db->setQuery( $query );
  		$db->query();
		}
  }

	function delete($cid = array())
	{
		$result = false;

		if (count( $cid )){
			JArrayHelper::toInteger($cid);
			$cids = implode( ',', $cid );
			$query = 'DELETE FROM #__juser_extended_fields'
				. ' WHERE id IN ( '.$cids.' )';
			$this->_db->setQuery( $query );
			if(!$this->_db->query()) {
				$this->setError($this->_db->getErrorMsg());
				return false;
			}
		}
		return true;
	}

	/**
	 * Method to (un)publish a weblink
	 *
	 * @access	public
	 * @return	boolean	True on success
	 * @since	1.5
	 */
	function publish($cid = array(), $publish = 1)
	{
		$user 	=& JFactory::getUser();

		if (count( $cid ))
		{
			JArrayHelper::toInteger($cid);
			$cids = implode( ',', $cid );

			$query = 'UPDATE #__juser_extended_fields'
				. ' SET published = '.(int) $publish
				. ' WHERE id IN ( '.$cids.' )'
				. ' AND ( checked_out = 0 OR ( checked_out = '.(int) $user->get('id').' ) )'
			;
			$this->_db->setQuery( $query );
			if (!$this->_db->query()) {
				$this->setError($this->_db->getErrorMsg());
				return false;
			}
		}

		return true;
	}

	/**
	 * Method to move a weblink
	 *
	 * @access	public
	 * @return	boolean	True on success
	 * @since	1.5
	 */
	function move($direction)
	{
		$row =& $this->getTable('fields');
		if (!$row->load($this->_id)) {
			$this->setError($this->_db->getErrorMsg());
			return false;
		}

		if (!$row->move( $direction, ' catid = '.(int) $row->catid.' AND published >= 0 ' )) {
			$this->setError($this->_db->getErrorMsg());
			return false;
		}

		return true;
	}

	/**
	 * Method to move a weblink
	 *
	 * @access	public
	 * @return	boolean	True on success
	 * @since	1.5
	 */
	function saveorder($cid = array(), $order)
	{
		$row =& $this->getTable('fields');
		$groupings = array();

		// update ordering values
		for( $i=0; $i < count($cid); $i++ )
		{
			$row->load( (int) $cid[$i] );
			// track categories
			$groupings[] = $row->catid;

			if ($row->ordering != $order[$i])
			{
				$row->ordering = $order[$i];
				if (!$row->store()) {
					$this->setError($this->_db->getErrorMsg());
					return false;
				}
			}
		}

		// execute updateOrder for each parent group
		$groupings = array_unique( $groupings );
		foreach ($groupings as $group){
			$row->reorder('catid = '.(int) $group);
		}

		return true;
	}

  function changeAccess( $uid, $access )
  {
    $field = $this->getTable('fields');
  	$field->load( $uid );
  	$field->access = $access;

  	if ( !$field->check() ) {
  		return $field->getError();
  	}
  	if ( !$field->store() ) {
  		return $field->getError();
  	}
  }

	function _loadData()
	{
		// Lets load the content if it doesn't already exist
		if (empty($this->_data))
		{
			$query = 'SELECT f.*, cc.title AS category,'.
					' cc.published AS cat_pub, cc.access AS cat_access'.
					' FROM #__juser_extended_fields AS f' .
					' LEFT JOIN #__categories AS cc ON cc.id = f.catid' .
					' WHERE f.id = '.(int) $this->_id;
			$this->_db->setQuery($query);
			$this->_data = $this->_db->loadObject();
			return (boolean) $this->_data;
		}
		return true;
	}

	function _initData()
	{
		// Lets load the content if it doesn't already exist
		if (empty($this->_data))
		{
  		$Field->id               = 0;
      $Field->title            = null;
      $Field->alias            = null;
      $Field->type             = null;
      $Field->access           = 0;
      $Field->ordering         = 0;
      $Field->published        = 0;
      $Field->description      = null;
      $Field->catid            = 0;
      $Field->checked_out      = 0;
      $Field->checked_out_time = '0000-00-00 00:00:00';
      $Field->params           = null;
      $Field->cat_pub          = 1;

			$this->_data					   = $Field;

			return (boolean) $this->_data;
		}
		return true;
	}
}
?>
