<?php
/**
 * $Id: report.php 7311 2011-08-19 11:18:02Z shitz $
 * $LastChangedDate: 2011-08-19 17:18:02 +0600 (Fri, 19 Aug 2011) $
 * $LastChangedBy: shitz $
 * MightyRegistration by Mighty Extensions
 * a component for Joomla! 1.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mightyextensions.com/
 * @copyright Copyright (C) 2006 - 2011 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/
defined('_JEXEC') or die('Restricted access');

jimport('joomla.application.component.model');

class JUserModelReport extends JModel
{
	var $_id = null;
	var $_core_data = null;
	var $_extended_data = null;

	function __construct()
	{
	  $this->_db = & JFactory::getDBO();

	  $this->initReportableFiledList();

	  parent::__construct();

		$array = JRequest::getVar('cid', array(0), '', 'array');
		$this->_id    = (int)$array[0];
		$this->_data	= null;
	}

	function &getReportTableData()
	{
	  $field = JRequest::getVar('_field_');

	  $date_range->date_from = JRequest::getVar('date_from');
	  $date_range->date_to   = JRequest::getVar('date_to');
	  $field_id = $field->id;

		$field->statistic = $this->{'get'.ucfirst($field->type).'Statistic'}( $field, $date_range );

		return $field;
	}

	function &getField()
	{
	  $date_range->date_from = JRequest::getVar('date_from');
	  $date_range->date_to   = JRequest::getVar('date_to');
	  $field_id = JRequest::getVar('field_id');
	  $query = "SELECT f. * , f.id as field_id, c.title as cat_title"
    . "\n       FROM #__juser_extended_fields AS f"
   	. "\n  LEFT JOIN #__categories            AS c ON c.id = f.catid"
   	. "\n      WHERE f.id = ".$field_id
    . "\n   ORDER BY c.ordering, f.ordering"
    ;

    $this->_db->setQuery($query);
		$field = $this->_db->loadObject();

		$field->statistic = $this->{'get'.ucfirst($field->type).'Statistic'}( $field, $date_range );

		return $field;
	}

	function getRadioStatistic($field, $date_range)
	{
	  $limit_value = JRequest::getVar('limit_value', 'yes') == 'no' ? false : true;
	  $query = "SELECT count(d.id) as `y_value`, d.fvalue as `x_value`"
    . "\n       FROM #__juser_extended_fields AS f"
   	. "\n  LEFT JOIN #__juser_extended_data   AS d ON f.id = d.field_id"
   	. "\n  LEFT JOIN #__users                 AS u ON u.id = d.user_id"
   	. "\n      WHERE f.id = ".$field->field_id." AND u.registerDate >= '".$date_range->date_from."' AND u.registerDate <= '".$date_range->date_to."'"
   	. "\n   GROUP BY d.fvalue"
    . "\n   ORDER BY `y_value`  desc"
    . ($limit_value ? "\n      LIMIT 0, 25" : "")
    ;
    $this->_db->setQuery($query);
		$statistic = $this->_db->loadAssocList();

		$query = "SELECT count(d.id)"
    . "\n       FROM #__juser_extended_fields AS f"
   	. "\n  LEFT JOIN #__juser_extended_data   AS d ON f.id = d.field_id"
   	. "\n  LEFT JOIN #__users                 AS u ON u.id = d.user_id"
   	. "\n      WHERE f.id = ".$field->field_id." AND u.registerDate >= '".$date_range->date_from."' AND u.registerDate <= '".$date_range->date_to."'"

    ;
    //print'<pre>';print_r($this->_db);exit;
    $this->_db->setQuery( $query );
		$total = $this->_db->loadResult();

		$total_selected = 0;
		foreach( $statistic as $value ){
		  $total_selected += $value['y_value'];
		}
		$other = $total - $total_selected;
		if( $other > 0 ){
		  $statistic[] = array( "y_value" => $other, "x_value" => JText::_("Other"));
		}


		//print'<pre>';print_r($statistic);print'</pre>'; exit;
    return $statistic;

	}

	function getSelectStatistic($field, $date_range)
	{
    return $this->getRadioStatistic($field, $date_range);
	}

	function getTextStatistic($field, $date_range)
	{
    return $this->getRadioStatistic($field, $date_range);
	}
	
	function getMult_selectStatistic($field, $date_range)
	{
	  $statistic_  = array();
	  $statistic  = array();
	  $limit_value = JRequest::getVar('limit_value', 'yes') == 'no' ? false : true;

    $query = "SELECT d.fvalue"
    . "\n       FROM #__juser_extended_fields AS f"
   	. "\n  LEFT JOIN #__juser_extended_data   AS d ON f.id = d.field_id"
   	. "\n  LEFT JOIN #__categories            AS c ON c.id = f.catid"
   	. "\n  LEFT JOIN #__users                 AS u ON u.id = d.user_id"
   	. "\n      WHERE f.id = ".$field->field_id." AND u.registerDate >= '".$date_range->date_from."' AND u.registerDate <= '".$date_range->date_to."'"
    ;
    $this->_db->setQuery($query);
		$values = $this->_db->loadAssocList();

		foreach($values as $value){
		  $subvalues = explode( "\n", str_replace( "\r", "", $value['fvalue'] ));
		  foreach($subvalues as $subvalue){
		    if(!isset($statistic_[$subvalue])){
		      $statistic_[$subvalue] = 0;
		    }
		    $statistic_[$subvalue]++;
		  }
		}

		arsort($statistic_);

		$i=0;
		foreach($statistic_ as $key => $value){
		  if(!isset($statistic[$i])){
		    $statistic[$i] = 0;
		  }
		  $statistic[$i] = array( "y_value" => $value, "x_value" => $key);
		  $i++;
		}

		$other     = array_sum (array_slice ($statistic, 25));

		if($limit_value){
		  $statistic = array_slice ($statistic, 0, 25);
		}

		if( $other > 0 ){
		  $statistic[] = array( "y_value" => $other, "x_value" => JText::_("Other"));
		}

		//print'<pre>';print_r($statistic);print'</pre>'; exit;
    return $statistic;
	}

	function getCheckboxStatistic($field, $date_range)
	{
	  $statistic_  = array();
	  $statistic  = array();
	  $limit_value = JRequest::getVar('limit_value', 'yes') == 'no' ? false : true;

    $query = "SELECT d.fvalue"
    . "\n       FROM #__juser_extended_fields AS f"
   	. "\n  LEFT JOIN #__juser_extended_data   AS d ON f.id = d.field_id"
   	. "\n  LEFT JOIN #__categories            AS c ON c.id = f.catid"
   	. "\n  LEFT JOIN #__users                 AS u ON u.id = d.user_id"
   	. "\n      WHERE f.id = ".$field->field_id." AND u.registerDate >= '".$date_range->date_from."' AND u.registerDate <= '".$date_range->date_to."'"
    ;
    $this->_db->setQuery($query);
		$values = $this->_db->loadAssocList();

		foreach($values as $value){
		  $subvalues = explode( "\n", str_replace( "\r", "", $value['fvalue'] ));
		  foreach($subvalues as $subvalue){
		    if(!isset($statistic_[$subvalue])){
		      $statistic_[$subvalue] = 0;
		    }
		    $statistic_[$subvalue]++;
		  }
		}

		arsort($statistic_);

		$i=0;
		foreach($statistic_ as $key => $value){
		  if(!isset($statistic[$i])){
		    $statistic[$i] = 0;
		  }
		  $statistic[$i] = array( "y_value" => $value, "x_value" => $key);
		  $i++;
		}

		$other     = array_sum (array_slice ($statistic, 25));

		if($limit_value){
		  $statistic = array_slice ($statistic, 0, 25);
		}

		if( $other > 0 ){
		  $statistic[] = array( "y_value" => $other, "x_value" => JText::_("Other"));
		}

		//print'<pre>';print_r($statistic);print'</pre>'; exit;
    return $statistic;
	}

	function getCalendarStatistic($field, $date_range){
	  $statistic = $this->getDateStatistic($field, $date_range);
	  return $statistic;
	}


	function getDateStatistic($field, $date_range){

	  $mode = JRequest::getVar('mode', 'table');

	  $query = "SELECT (TO_DAYS(max(d.fvalue)) - TO_DAYS(min(d.fvalue))) as date_range"
    . "\n       FROM #__juser_extended_fields AS f"
   	. "\n  LEFT JOIN #__juser_extended_data   AS d ON f.id = d.field_id"
   	. "\n  LEFT JOIN #__categories            AS c ON c.id = f.catid"
   	. "\n  LEFT JOIN #__users                 AS u ON u.id = d.user_id"
   	. "\n      WHERE f.id = ".$field->field_id." AND d.fvalue <> '--' AND u.registerDate >= '".$date_range->date_from."' AND u.registerDate <= '".$date_range->date_to."'"
    ;
    $this->_db->setQuery($query);
		$range = $this->_db->loadResult();

		$query = "SELECT count(d.id) as `y_value`, UNIX_TIMESTAMP(d.fvalue) as `x_value`"
    . "\n       FROM #__juser_extended_fields AS f"
   	. "\n  LEFT JOIN #__juser_extended_data   AS d ON f.id = d.field_id"
   	. "\n  LEFT JOIN #__users                 AS u ON u.id = d.user_id"
   	. "\n      WHERE f.id = ".$field->field_id." AND d.fvalue <> '--' AND u.registerDate >= '".$date_range->date_from."' AND u.registerDate <= '".$date_range->date_to."'"
   	. "\n   GROUP BY d.fvalue"
    . "\n   ORDER BY `x_value` "
    . ($mode == 'table' ? "\n      LIMIT 0, 25" : "")
    ;
    $this->_db->setQuery($query);
		$statistic_ = $this->_db->loadAssocList();

		if(isset($statistic_[0]['x_value'])){
		  $last_value = $statistic_[0]['x_value']-60*60*24*10;
		}
		foreach($statistic_ as $value){
		  if( ( $last_value + 60*60*24 ) < $value["x_value"] ){
		    while( $last_value + 60*60*24  < $value["x_value"] ){
		      $last_value += 60*60*24;
		      $date = new JDate($last_value);
		      $statistic[] = array( "y_value" => 0, "x_value" => $date->toFormat('%m-%d-%Y'));
		    }
		  }
		  $date = new JDate($value["x_value"]);
		  $statistic[] = array( "y_value" => $value["y_value"], "x_value" => $date->toFormat('%m-%d-%Y'));
		  $last_value = $value["x_value"];
		}
		if( !isset($statistic) ){
		  $statistic = array();
		}
		//print'<pre>';print_r($statistic);print'</pre>'; exit;
		return $statistic;
	}

	function initReportableFiledList()
	{
	  $include_type_list = array("select","checkbox","mult_select","radio","date","calendar","text");
	  $include_type_list = " f.type IN('" . implode( "','", $include_type_list ) . "') ";

    $query = "SELECT f. * , f.id as field_id, c.title as cat_title, (SELECT count(*) FROM #__juser_extended_data WHERE field_id = f.id AND fvalue IS NOT NULL) as count_values"
    . "\n       FROM #__juser_extended_fields AS f"
   	. "\n  LEFT JOIN #__categories            AS c ON c.id = f.catid"
   	. "\n      WHERE 1 AND " . $include_type_list
    . "\n   ORDER BY c.ordering, f.ordering"
    ;

    $this->_db->setQuery($query);
		$this->_reportable_field_list = $this->_db->loadObjectList();
	}

	function &getReportableFiledList()
	{
	  return $this->_reportable_field_list;
	}

	function &getFieldListForReport()
	{
	  $field_array = array();
	  $include_field_list = JRequest::getVar('fields');
	  if( count($include_field_list) == 0 ) {return $field_array;}
	  $include_field_list = " f.id IN('" . implode( "','", $include_field_list ) . "') ";

    $query = "SELECT f. * , f.id as field_id, c.title as cat_title"
    . "\n       FROM #__juser_extended_fields AS f"
   	. "\n  LEFT JOIN #__categories            AS c ON c.id = f.catid"
   	. "\n      WHERE 1 AND " . $include_field_list
    . "\n   ORDER BY c.ordering, f.ordering"
    ;

    $this->_db->setQuery($query);
		$field_array =  $this->_db->loadObjectList();
		return $field_array;
	}

	function getRPForLastTwoMonth()
	{
	   $query = "SELECT count( id ) as users , YEAR(`registerDate`) as year, MONTHNAME(`registerDate`) as month, DAY(`registerDate`) as day "
           ."\n  FROM `jos_users`"
           ."\n WHERE YEAR(`registerDate`) >= YEAR(NOW() - INTERVAL 1 MONTH) AND MONTH(`registerDate`) >= MONTH(NOW() - INTERVAL 1 MONTH)"
           ."\n GROUP BY YEAR(`registerDate`), MONTH(`registerDate`), DAY( `registerDate` ) "
           ."\n ORDER BY `registerDate`"
           ;
    $this->_db->setQuery($query);
		return $this->_db->loadObjectList();
	}

	function getRPForLastYear()
	{
	   $query = "SELECT count( id ) as users , YEAR(`registerDate`) as year, MONTHNAME(`registerDate`) as monthname,  MONTH(`registerDate`) as month"
           ."\n  FROM `jos_users`"
           ."\n WHERE `registerDate` >= NOW() - INTERVAL 1 YEAR"
        ."\n GROUP BY YEAR(`registerDate`), MONTH(`registerDate`)"
        ."\n ORDER BY `year`, `month`"
           ;
    $this->_db->setQuery($query);
		return $this->_db->loadObjectList();
	}

	function getAPForLastYear()
	{
	   $query = "SELECT count( id ) as users , YEAR(`registerDate`) as year, MONTHNAME(`registerDate`) as monthname,  MONTH(`registerDate`) as month"
           ."\n  FROM `jos_users`"
           ."\n WHERE `registerDate` >= NOW() - INTERVAL 1 YEAR AND block = 0"
        ."\n GROUP BY YEAR(`registerDate`), MONTH(`registerDate`)"
        ."\n ORDER BY `year`, `month`"
           ;
    $this->_db->setQuery($query);
		return $this->_db->loadObjectList();
	}

	function &getData()
	{
		// Load the user data
		if ( !$this->_loadData() ){
		  $this->_initData();
		}
		$_data                = new stdClass();
		$_data->core_data     = $this->_core_data;
		$_data->extended_data = $this->_extended_data;
		return $_data;
	}

	function _loadData()
	{

		// Lets load the user data if it doesn't already exist
		if (empty($this->_data)){
			$query = "SELECT a.*, g.name AS groupname"
      ."\n        FROM      #__users                    AS a"
      ."\n  INNER JOIN #__core_acl_aro             AS aro ON aro.value = a.id"
      ."\n  INNER JOIN #__core_acl_groups_aro_map  AS gm  ON gm.aro_id = aro.id"
      ."\n  INNER JOIN #__core_acl_aro_groups      AS g   ON g.id      = gm.group_id"
      ."\n       WHERE a.id = ". $this->_id;
			$this->_db->setQuery($query);
			$this->_core_data = $this->_db->loadObject();
			$query = "SELECT f. * , f.id as field_id, c.title as cat_title, d.fvalue"
      . "\n       FROM #__juser_extended_fields AS f"
     	. "\n  LEFT JOIN #__juser_extended_data   AS d ON f.id = d.field_id AND d.user_id = " . (int) (isset($this->_core_data->id)?$this->_core_data->id:0)
     	. "\n  LEFT JOIN #__categories            AS c ON c.id = f.catid"
      . "\n   ORDER BY c.ordering, f.ordering"
      ;
			$this->_db->setQuery($query);
			$this->_extended_data = $this->_db->loadObjectList();
			return (boolean) $this->_core_data && (boolean) $this->_extended_data;
		}
		return true;
	}

	function saveExtendedData($user_ext_data)
  {
    $r     = true;
    $table = $this->getTable('usersdata');

    foreach($user_ext_data as $field_id => $field_data){
      $table->_bind( $this->_id, $field_id, $field_data );
      if(!$table->store()){
        $r = false;
      }
    }

    return $r;
  }

  function _initData()
	{
		// Lets load the content if it doesn't already exist
		if (empty($this->_data)){
			$user = new stdClass();

			$user->id             = 0;
      $user->name           = '';
      $user->username       = '';
      $user->email          = '';
      $user->password       = '';
      $user->usertype       = '';
      $user->block          = 0;
      $user->sendEmail      = 0;
      $user->gid            = 0;
      $user->registerDate   = '0000-00-00 00:00:00';
      $user->lastvisitDate  = '0000-00-00 00:00:00';
      $user->activation     = '';
      $user->params         = '';

			$this->_data					= $user;
			return (boolean)$this->_data;
		}
		return true;
	}
}
?>
