<?php
/**
 * $Id: user.php 7311 2011-08-19 11:18:02Z shitz $
 * $LastChangedDate: 2011-08-19 17:18:02 +0600 (Fri, 19 Aug 2011) $
 * $LastChangedBy: shitz $
 * MightyRegistration by Mighty Extensions
 * a component for Joomla! 1.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mightyextensions.com/
 * @copyright Copyright (C) 2006 - 2011 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/
defined('_JEXEC') or die('Restricted access');

jimport('joomla.application.component.model');

class JUserModelUser extends JModel
{
  var $_id = null;
  var $_core_data = null;
  var $_extended_data = null;

  function __construct()
  {

    parent::__construct();

  }

  function JSConstruct()
  {
    $array = JRequest::getVar('cid', array(0), '', 'array');
    $this->_id = (int)$array[0];
  }

  function &getData()
  {
    if( ! $this->_id){
      $this->JSConstruct();
    }

    // Load the user data
    if (!$this->_loadData()){
      $this->_initData();
    }
    $_data                = new stdClass();
    $_data->core_data     = $this->_core_data;
    $_data->extended_data = $this->_extended_data;

    return $_data;
  }

  function _loadData()
  {
    // Lets load the user data if it doesn't already exist
    if (empty($this->_data))
    {
      $query = "SELECT a.*, g.name AS groupname"
      ."\n        FROM      #__users                    AS a"
      ."\n  INNER JOIN #__core_acl_aro             AS aro ON aro.value = a.id"
      ."\n  INNER JOIN #__core_acl_groups_aro_map  AS gm  ON gm.aro_id = aro.id"
      ."\n  INNER JOIN #__core_acl_aro_groups      AS g   ON g.id      = gm.group_id"
      ."\n       WHERE a.id = ".(int) $this->_id;
      $this->_db->setQuery($query);
      $this->_core_data = $this->_db->loadObject();
			
      if(isset($this->_core_data))
      {
      	$separator_pos = strpos($this->_core_data->name, "\n");
      	if ($separator_pos > 0)
      	{
	      	$this->_core_data->first_name = substr($this->_core_data->name, 0,  $separator_pos );
	      	$this->_core_data->last_name =  substr($this->_core_data->name, $separator_pos + 1);
      	}
      	else
      	{
	      	$this->_core_data->first_name = $this->_core_data->name;
	      	$this->_core_data->last_name =  null;      		
      	}
        //$separated_name = explode ( " ", $this->_core_data->name );

      /*  $this->_core_data->first_name = isset($separated_name[0]) ? $separated_name[0] : '';
        $this->_core_data->last_name  = isset($separated_name[1]) ? $separated_name[1] : '';*/
      }

      $query = "SELECT f. * , f.id as field_id, c.title as cat_title, c.description as cat_description, d.fvalue"
      . "\n       FROM #__juser_extended_fields AS f"
       . "\n  LEFT JOIN #__juser_extended_data   AS d ON f.id = d.field_id AND d.user_id = " . (isset($this->_core_data->id) ? (int) $this->_core_data->id : 0 )
       . "\n  LEFT JOIN #__categories            AS c ON c.id = f.catid"
      . "\n   ORDER BY c.ordering, f.ordering"
      ;
      $this->_db->setQuery($query);
      $this->_extended_data = $this->_db->loadObjectList();
      return (boolean) $this->_core_data;
    }
    return true;
  }

  function saveExtendedData($user_ext_data)
  {
  	$r     = true;
	$table = $this->getTable('usersdata');
	foreach($user_ext_data as $field_id => $field_data){
		if ($field_data){
			$table->_bind( $this->_id, $field_id, $field_data );
			if(!$table->store()){
				$r = false;
			}
		}
		else{
			if($this->_id){
				$table->_delete($this->_id, $field_id);
			}
		}
	}
    return $r;
  }

  function _initData()
  {
    // Lets load the content if it doesn't already exist
    if (empty($this->_data)){
      $user = new stdClass();

      $user->id             = 0;
      $user->first_name     = '';
      $user->last_name      = '';
      $user->username       = '';
      $user->email          = '';
      $user->password       = '';
      $user->usertype       = '';
      $user->block          = 0;
      $user->sendEmail      = 0;
      $user->gid            = 0;
      $user->registerDate   = '0000-00-00 00:00:00';
      $user->lastvisitDate  = '0000-00-00 00:00:00';
      $user->activation     = '';
      $user->params         = '';

      $this->_core_data          = $user;
      return (boolean)$this->_core_data;
    }
    return true;
  }
}
?>
