<?php
/**
 * $Id: users.php 7311 2011-08-19 11:18:02Z shitz $
 * $LastChangedDate: 2011-08-19 17:18:02 +0600 (Fri, 19 Aug 2011) $
 * $LastChangedBy: shitz $
 * MightyRegistration by Mighty Extensions
 * a component for Joomla! 1.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mightyextensions.com/
 * @copyright Copyright (C) 2006 - 2011 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/
defined('_JEXEC') or die('Restricted access');

jimport('joomla.application.component.model');


class JUserModelUsers extends JModel
{

	var $_data = null;
	var $_total = null;
	var $_pagination = null;
	var $_extended_fields_left_joines = null;
	var $_where = null;

	function __construct()
	{
		parent::__construct();

		global $mainframe, $option;

		// Get the pagination request variables
		$limit		= $mainframe->getUserStateFromRequest( 'global.list.limit', 'limit', $mainframe->getCfg('list_limit'), 'int' );
		$limitstart	= $mainframe->getUserStateFromRequest( $option.'.users.limitstart', 'limitstart', 0, 'int' );

		$this->setState('limit', $limit);
		$this->setState('limitstart', $limitstart);
	}

	/**
	 * Method to get weblinks item data
	 *
	 * @access public
	 * @return array
	 */
	function getData()
	{
		// Lets load the content if it doesn't already exist
		if (empty($this->_data))
		{
			$query = $this->_buildQueryUserList();

			$this->_data = @$this->_getList($query, $this->getState('limitstart'), $this->getState('limit'));

			$n = count( $this->_data );
			$template = 'SELECT COUNT(s.userid)'
			. ' FROM #__session AS s'
			. ' WHERE s.userid = %d'
			;

			for ($i = 0; $i < $n; $i++)
			{
				$row = &$this->_data[$i];
				$query = sprintf( $template, intval( $row->id ) );
				$this->_db->setQuery( $query );
				$row->loggedin = $this->_db->loadResult();
				if( $GLOBALS['is_jcs_exist'] ){
					$query = "SELECT COUNT(*)  FROM #__jcs_user_subscr WHERE user_id = {$row->id}";
					$this->_db->setQuery($query);
					$row->jcs_s = $this->_db->loadResult();
				}
			}

			/*$jcs = '';
			 $jcs_value = '';
			 if( $GLOBALS['is_jcs_exist'] ){
			 $jcs = ' LEFT  JOIN #__jcs_user_subscr AS jcs ON jcs.user_id = a.id';
			 $jcs_value = ', if(jcs.user_id > 0, 1, 0) as jcs_s';
			 }*/
			/*print "<pre>";
			 print_r($this->_db->_sql);
			 print "</pre>";*/
		}
		return $this->_data;
	}

	/**
	 * Method to get the total number of weblink items
	 *
	 * @access public
	 * @return integer
	 */
	function getTotal()
	{
		global $mainframe, $option;
		/*$extended_fields = $this->getSearcheableExtendedFieldList();
		 $where		                   = $this->_buildUserWhere( $extended_fields) ;*/
		// Lets load the content if it doesn't already exist
		if (empty($this->_total))
		{
			$extended_fields = array();

			$extended_fields = $this->getSearcheableExtendedFieldList();
			$extended_fields_left_joines = $this->getExtendedFieldsLeftJoins( $extended_fields );


			$filter_logged = $mainframe->getUserStateFromRequest( "$option.filter_logged", 'filter_logged', 0,	 'int' );
			$loggedin = "";
			if ($filter_logged == 1 || $filter_logged == 2)
			{
				$loggedin = "\n INNER JOIN #__session AS s ON s.userid = a.id";
			}


			$where  = $this->_buildUserWhere( $extended_fields) ;
			$query = "SELECT COUNT(*)"
			. "\n FROM #__users AS a  "
			. "\n INNER JOIN #__core_acl_aro AS aro ON aro.value = a.id"
			. "\n INNER JOIN #__core_acl_groups_aro_map AS gm ON gm.aro_id = aro.id"
			. "\n INNER JOIN #__core_acl_aro_groups AS g ON g.id = gm.group_id"
			.$loggedin
			. "\n ".$extended_fields_left_joines
			. "\n ".$where
			;
			$this->_db->setQuery($query);
			/*exit;*/
			$this->_total = $this->_db->loadResult();
		}
		return $this->_total;
	}
	/**
	 * Method to get a pagination object for the weblinks
	 *
	 * @access public
	 * @return integer
	 */
	function getPagination()
	{
		// Lets load the content if it doesn't already exist
		if (empty($this->_pagination))
		{
			jimport('joomla.html.pagination');
			$this->_pagination = new JPagination( $this->getTotal(), $this->getState('limitstart'), $this->getState('limit') );
		}

		return $this->_pagination;
	}

	function _buildQueryUserList()
	{
		global $mainframe, $option;
		// Get the WHERE and ORDER BY clauses for the query
		$extended_fields = array();

		$extended_fields = $this->getSearcheableExtendedFieldList();
		$extended_fields_left_joines = $this->getExtendedFieldsLeftJoins( $extended_fields);
		//		print "<pre>";
		//		print_r($extended_fields_left_joines);
		//		print "</pre>";
		//		exit;
		$filter_logged = $mainframe->getUserStateFromRequest( "$option.filter_logged", 'filter_logged', 0,	 'int' );

		$where		                   = $this->_buildUserWhere( $extended_fields) ;
		$orderby	                   = $this->_buildUserOrderBy();

		$loggedin = "";
		if ($filter_logged == 1 || $filter_logged == 2)
		{
			$loggedin = "\n INNER JOIN #__session AS s ON s.userid = a.id";
		}

		if (JU_REGISTRATION_FORM_LAST_NAME_ENABLE)
		{
			$select_flname = "IF(LOCATE('\n', a.name) > 0, LEFT(a.name, LOCATE('\n', a.name)), a.name) AS first_name, IF(LOCATE('\n', a.name) > 0, SUBSTRING(a.name, (LOCATE('\n', a.name) + 1)), NULL) AS last_name,";
		}
		else
		{
			$select_flname = null;
		}

		$query = "SELECT $select_flname a.*, g.name AS groupname "//.$jcs_value
		. "\n FROM #__users AS a  "
		. "\n INNER JOIN #__core_acl_aro AS aro ON aro.value = a.id"
		. "\n INNER JOIN #__core_acl_groups_aro_map AS gm ON gm.aro_id = aro.id"
		. "\n INNER JOIN #__core_acl_aro_groups AS g ON g.id = gm.group_id"
		//. "\n ".$jcs
		.$loggedin
		. "\n ".$extended_fields_left_joines
		. "\n ".$where
		. "\n GROUP BY a.id"
		. "\n ".$orderby
		;
		return $query;

	}

	function _buildUserOrderBy()
	{
		global $mainframe, $option;

		$filter_order		= $mainframe->getUserStateFromRequest( $option.'.users.filter_order',		'filter_order',		'a.registerDate',	'cmd' );
		$filter_order_Dir	= $mainframe->getUserStateFromRequest( $option.'.users.filter_order_Dir',	'filter_order_Dir',	'DESC',			'word' );

		if ($filter_order){
			$orderby 	= ' ORDER BY '.$filter_order.' '.$filter_order_Dir.' ';
		}
		return $orderby;
	}

	function _buildUserWhere( $extended_fields = null )
	{

		global $mainframe, $option;
		$db				 = & JFactory::getDBO();
		$acl	         = & JFactory::getACL();
		$currentUser 	 = & JFactory::getUser();
		$filter_type	 = $mainframe->getUserStateFromRequest( "$option.filter_type",   'filter_type',   0,	 'string' );
		$filter_logged   = $mainframe->getUserStateFromRequest( "$option.filter_logged", 'filter_logged', 0,	 'int' );
		$search			 = $mainframe->getUserStateFromRequest( "$option.search",        'search', 			 '', 'string' );
		$search			 = JString::strtolower( $search );

		if (empty ($this->_where))
		{
			$where = array();

			//filter by usertype
			if ( $filter_type ){
				if ( $filter_type == 'Public Frontend' ){
					$where[] = ' a.usertype = \'Registered\' OR a.usertype = \'Author\' OR a.usertype = \'Editor\' OR a.usertype = \'Publisher\' ';
				}
				else if ( $filter_type == 'Public Backend' ){
					$where[] = 'a.usertype = \'Manager\' OR a.usertype = \'Administrator\' OR a.usertype = \'Super Administrator\' ';
				}
				else{
					$where[] = 'a.usertype = LOWER( '.$db->Quote($filter_type).' ) ';
				}
			}

			//filter by userlogged
			if ( $filter_logged == 1 ){
				$where[] = 's.userid = a.id';
			}
			else if ($filter_logged == 2){
				$where[] = 's.userid IS NULL';
			}

			//search by username, email, name
			if (isset( $search ) && $search != ''){
				$searchEscaped = $db->Quote('%'.$search.'%');
				$where[] = $this->makeConditionTextLike( $searchEscaped, $extended_fields );
			}

			$where[] = $this->makeConditionSelectLike( $extended_fields );


			if ( isset($filter_state) && $filter_state != NULL ) {
				if ( $filter_state == 'P' ) {
					$where[] = 'a.published = 1';
				} else if ($filter_state == 'U' ) {
					$where[] = 'a.published = 0';
				}
			}

			// exclude any child group id's for this user
			$pgids = $acl->get_group_children( $currentUser->get('gid'), 'ARO', 'RECURSE' );

			if (is_array( $pgids ) && count( $pgids ) > 0)
			{
				JArrayHelper::toInteger($pgids);
				$where[] = 'a.gid NOT IN (' . implode( ',', $pgids ) . ')';
			}

			$this->_where 		= ( count( $where ) ? ' WHERE '. implode( ' AND ', $where ) : '' );
		}
		return $this->_where;
	}

	function getSearcheableExtendedFieldList()
	{
		$query = "SELECT f.id as field_id, f.*, cc.id as key1"
		."\n      FROM #__juser_extended_fields AS f"
		."\n LEFT JOIN #__categories as cc ON cc.id = f.catid"
		."\n     WHERE f.params LIKE '%searcheable=1%' AND f.published = 1"
		."\n  GROUP BY f.id"
		."\n  ORDER BY cc.ordering, f.ordering";
		return $this->_data = $this->_getList( $query );
	}

	function makeConditionTextLike( $searchEscaped, $extended_fields )
	{
		if(!$searchEscaped) return '1';

		$result[] = "a.username LIKE ".$searchEscaped."";
		$result[] = "a.email    LIKE ".$searchEscaped."";
		$result[] = "a.name     LIKE ".str_replace(" ", "\n", $searchEscaped)."";

		$searcheableTypesLikeText = array( 'text','textarea' );

		foreach($extended_fields as $field){
			if(in_array($field->type, $searcheableTypesLikeText )){
				$result[] = "field_".$field->field_id.".fvalue LIKE ".$searchEscaped;
			}
		}

		return '('.implode( ' OR ', $result ).')';
	}

	function makeConditionSelectLike( $extended_fields )
	{
		$result = array();
		foreach($extended_fields as $field){
			$selected = $this->getFilterValue( $field->alias );

			if( !$selected ){ continue; }
			$selected = $this->_db->Quote($selected);
			switch($field->type){
				case 'select':
				case 'radio':
					$result[] = "field_".$field->field_id.".fvalue = ".$selected;
					break;
				case 'mult_select':
				case 'checkbox':
					$result[] = "CONCAT('\n',field_".$field->field_id.".fvalue,'\n') LIKE CONCAT('%\n',".$selected.",'\n%')";
					break;
			}

		}
		if (count ($result) > 0){
			return implode( ' AND ', $result );
		} else {
			return '1';
		}
	}

	function getFilterValue( $field_alias )
	{
		global $mainframe;
		if(!isset($_REQUEST['filter_'.$field_alias])){
			$result = $mainframe->getUserState( 'filter_'.$field_alias );
		} else {
			$result = JRequest::getVar('filter_'.$field_alias );
		}

		return $result;
	}

	function getExtendedFieldsLeftJoins( $extended_fields )
	{
		global $mainframe, $option;

		$result = array();

		foreach($extended_fields as $field){
			$params = new JParameter($field->params);

			$search = $mainframe->getUserStateFromRequest( "$option.search",        'search',        '', 'string' );
			if ( (($mainframe->getUserState( 'filter_'.$field->alias ) || (JRequest::getVar('filter_'.$field->alias)) &&  $params->get('searcheable', 0))) || (trim($search)!= '' && $params->get('searcheable', 0)))
			{
				$result[] = "\n LEFT JOIN #__juser_extended_data as field_".$field->field_id." ON a.id = field_".$field->field_id.".user_id AND field_".$field->field_id.".field_id = ".$field->field_id;
			}

		}
		//		$params  = $mainframe->getParams();
		//		if($params->get('zip_field', '') && $params->get('show_zip_filters', 0)){
		//			$result[] = "LEFT JOIN #__juser_extended_data AS field_".$params->get('zip_field')." ON field_".$params->get('zip_field').".user_id = a.id";
		//			$result[] = " LEFT JOIN #__juser_zip_code as zip ON field_".$params->get('zip_field').".fvalue = zip.zip_code";
		//		}
		return implode("\n",$result);
	}
	function delete($cid)
	{
		$db = &JFactory::getDBO();
		$sql = "DELETE FROM #__juser_extended_data WHERE `user_id` = ".(int)$cid;
		$db->setQuery($sql);
		$db->query();
	}

}
?>
