<?php
/**
 * $Id: fields.php 7311 2011-08-19 11:18:02Z shitz $
 * $LastChangedDate: 2011-08-19 17:18:02 +0600 (Fri, 19 Aug 2011) $
 * $LastChangedBy: shitz $
 * MightyRegistration by Mighty Extensions
 * a component for Joomla! 1.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mightyextensions.com/
 * @copyright Copyright (C) 2006 - 2011 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/
defined('_JEXEC') or die('Restricted access');

// Include library dependencies
jimport('joomla.filter.input');

/**
* JUser Table class
*
* @subpackage	Users_data
* @since 1.0
*/
class TableFields extends JTable
{
  /**
	 * Primary Key
	 *
	 * @var int(11)
	 */
  var $id = null;

  /**
	 * @var varchar(255)
	 */
  var $title = null;

  /**
	 * @var varchar(255)
	 */
  var $alias = null;


  /**
	 * @var varchar(255)
	 */
  var $name = null;

  /**
	 * @var varchar(255)
	 */
  var $type = null;

  /**
	 * @var int(11)
	 */
  var $access = null;

  /**
	 * @var int(6)
	 */
  var $ordering = null;

  /**
	 * @var tinyint(1)
	 */
  var $published = 1;

  /**
	 * @var varchar(250)
	 */
  var $description = null;

  /**
	 * @var int(11)
	 */
  var $catid = null;

  /**
	 * @var int(11)
	 */
  var $checked_out = null;

  /**
	 * @var datetime
	 */
  var $checked_out_time = null;

  /**
	 * @var text
	 */
  var $params = null;

	/**
	 * Constructor
	 *
	 * @param object Database connector object
	 * @since 1.0
	 */
	function __construct(& $db) {
		parent::__construct('#__juser_extended_fields', 'id', $db);
	}

  function bind($array, $ignore = '')
	{
		if (key_exists( 'params', $array ) && is_array( $array['params'] )) {
			$registry = new JRegistry();
			$registry->loadArray($array['params']);
			$array['params'] = $registry->toString();
		}

		return parent::bind($array, $ignore);
	}

	/**
	 * Overloaded check method to ensure data integrity
	 *
	 * @return boolean True on success
	 * @since 1.0
	 */
	function check()
	{
		return true;
	}
}
?>