<?php
/**
 * $Id: users.php 7311 2011-08-19 11:18:02Z shitz $
 * $LastChangedDate: 2011-08-19 17:18:02 +0600 (Fri, 19 Aug 2011) $
 * $LastChangedBy: shitz $
 * MightyRegistration by Mighty Extensions
 * a component for Joomla! 1.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mightyextensions.com/
 * @copyright Copyright (C) 2006 - 2011 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/
defined( '_JEXEC' ) or die( 'Restricted access' );

// Include library dependencies
jimport('joomla.filter.input');

/**
* JUser Table class
*/
class TableUsers extends JTable
{

	/**
	 * Primary Key
	 *
	 * @var int
	 */
	var $id = null;

	/**
	 * @var text
	 */
	var $name = null;

	/**
	 * @var varchar(150)
	 */
	var $username = null;

	/**
	 * @var varchar(100)
	 */
	var $email = null;

	/**
	 * @var varchar(100)
	 */
	var $password = null;

	/**
	 * @var varchar(75)
	 */
	var $usertype = null;

	/**
	 * @var tinyint(4)
	 */
	var $block = 0;

	/**
	 * @var tinyint(4)
	 */
	var $sendEmail = 0;

	/**
	 * @var tinyint(3)
	 */
	var $gid = 1;

	/**
	 * @var datetime
	 */
	var $registerDate = null;

	/**
	 * @var datetime
	 */
	var $lastvisitDate = null;

	/**
	 * @var varchar(100)
	 */
	var $activation = null;

	/**
	 * @var text
	 */
	var $params = null;


  /*var $error = '';
  var $password_clear = '';*/
  var $_params;

	/**
	 * Constructor
	 *
	 * @param object Database connector object
	 * @since 1.0
	 */
	function __construct(& $db) {
	  $this->_params = new JParameter( '' );
		parent::__construct('#__users', 'id', $db);
	}

  function _setError( $msg )
	{
		$this->_errorMsg .= $msg."\n";
	}

	/**
	* Overloaded bind function
	*
	* @param array $hash named array
	* @return null|string	null is operation was satisfactory, otherwise returns an error
	* @see JTable:bind
	*/
	function _bind($array)
	{
		jimport( 'joomla.user.helper' );
		jimport( 'joomla.utilities.array' );


		$array['name'] = $array['first_name'] ."\n". $array['last_name'];

		$this->id    = $array['cid'][0];

		// Lets check to see if the user is new or not
		if (empty($this->id) || $this->id == 0)
		{
			// Check the password and create the crypted password
			if (!$array['password']) {
				$array['password']  = JUserHelper::genRandomPassword();
				$array['password2'] = $array['password'];
			}

			if ($array['password'] != $array['password2']) {
					$this->_setError(JText::_( 'PASSWORD DO NOT MATCH.' ));
					return false;
			}

			//$this->password_clear = JArrayHelper::getValue( $array, 'password', '', 'string' );

			$salt  = JUserHelper::genRandomPassword(32);
			$crypt = JUserHelper::getCryptedPassword($array['password'], $salt);
			$array['password'] = $crypt.':'.$salt;

			// Set the registration timestamp
			$this->registerDate = date( 'Y-m-d H:i:s' );

			// Check that username is not greater than 25 characters
			$username = $this->username;
			if ( strlen($username) > 150 )
			{
				$username = substr( $username, 0, 150 );
				$this->username = $username;
			}

			// Check that password is not greater than 50 characters
			$password = $this->password;
			if ( strlen($password) > 100 )
			{
				$password = substr( $password, 0, 100 );
				$this->password = $password;
			}
		}
		else
		{
			// Updating an existing user
			if (!empty($array['password']))
			{
				if ( $array['password'] != $array['password2'] ) {
					$this->_setError( JText::_( 'PASSWORD DO NOT MATCH.' ) );
					return false;
				}


        //$this->password_clear = JArrayHelper::getValue( $array, 'password', '', 'string' );

				$salt = JUserHelper::genRandomPassword(32);
				$crypt = JUserHelper::getCryptedPassword($array['password'], $salt);
				$array['password'] = $crypt.':'.$salt;
			}
			else
			{
				$array['password'] = $this->password;
			}
		}

		// TODO: this will be deprecated as of the ACL implementation
		$db =& JFactory::getDBO();

		$gid	= array_key_exists('gid', $array ) ? $array['gid'] : $this->gid;

		$query = 'SELECT name'
		. ' FROM #__core_acl_aro_groups'
		. ' WHERE id = ' . (int) $gid
		;
		$db->setQuery( $query );
		$this->usertype = $db->loadResult();

		if ( array_key_exists('params', $array) )
		{
			$params	= '';
			$this->_params->bind($array['params']);
			if ( is_array($array['params']) ) {
				$params	= $this->_params->toString();
			} else {
				$params = $array['params'];
			}
			$this->params = $params;
		}
		// Bind the array
		/*if (!$this->_bind($array, 'aid guest')) {
			$this->_setError("Unable to bind array to user object");
			return false;
		}*/

		// Make sure its an integer
		$this->id = (int) $this->id;

		return parent::bind($array, 'params');
	}

  function _delete( $oid=null )
	{
		$acl =& JFactory::getACL();


		$k = $this->_tbl_key;
		if ($oid) {
			$this->$k = intval( $oid );
		}
		$aro_id = $acl->get_object_id( 'users', $this->$k, 'ARO' );
		$acl->del_object( $aro_id, 'ARO', true );

		$query = 'DELETE FROM '. $this->_tbl
		. ' WHERE '. $this->_tbl_key .' = '. (int) $this->$k
		;
		$this->_db->setQuery( $query );

		if ($this->_db->query()) {
			// cleanup related data

			// private messaging
			$query = 'DELETE FROM #__messages_cfg'
			. ' WHERE user_id = '. (int) $this->$k
			;
			$this->_db->setQuery( $query );
			if (!$this->_db->query()) {
				$this->_setError( $this->_db->getErrorMsg() );
				return false;
			}
			$query = 'DELETE FROM #__messages'
			. ' WHERE user_id_to = '. (int) $this->$k
			;
			$this->_db->setQuery( $query );
			if (!$this->_db->query()) {
				$this->_setError( $this->_db->getErrorMsg() );
				return false;
			}

			return true;
		} else {
			$this->_setError( $this->_db->getErrorMsg() );
			return false;
		}
	}

  function store( $updateNulls=false )
	{
		$acl =& JFactory::getACL();

		$section_value = 'users';
		$k = $this->_tbl_key;
		$key =  $this->$k;

		if ($key){
			// existing record
			$ret = $this->_db->updateObject( $this->_tbl, $this, $this->_tbl_key, $updateNulls );

			// syncronise ACL
			// single group handled at the moment
			// trivial to expand to multiple groups
			$object_id = $acl->get_object_id( $section_value, $this->$k, 'ARO' );

			$groups = $acl->get_object_groups( $object_id, 'ARO' );
			$acl->del_group_object( $groups[0], $section_value, $this->$k, 'ARO' );
			$acl->add_group_object( $this->gid, $section_value, $this->$k, 'ARO' );

			$acl->edit_object( $object_id, $section_value, $this->_db->getEscaped( $this->name ), $this->$k, 0, 0, 'ARO' );
		}
		else{
			// new record
			$ret = $this->_db->insertObject( $this->_tbl, $this, $this->_tbl_key );
			// syncronise ACL
			$acl->add_object( $section_value, $this->name, $this->$k, null, null, 'ARO' );
			$acl->add_group_object( $this->gid, $section_value, $this->$k, 'ARO' );
		}

		if( !$ret )
		{
			$this->setError( strtolower(get_class( $this ))."::". JText::_( 'store failed' ) ."<br />" . $this->_db->getErrorMsg() );
			return false;
		}
		else
		{
			return true;
		}
	}

  function save( $updateOnly = false )
	{
		jimport( 'joomla.utilities.array' );

		// Create the user table object
		/*$table 	=& JTable::getInstance( 'user');
		$table->bind(JArrayHelper::fromObject($this, false));

		// Check and store the object.
		if (!$table->check()) {
			$this->_setError($table->getError());
			return false;
		}*/

		// If user is made a Super Admin group and user is NOT a Super Admin
		$my =& JFactory::getUser();
		if ( $this->get('gid') == 25 && $my->get('gid') != 25 )
		{
			// disallow creation of Super Admin by non Super Admin users
			$this->_setError(JText::_( 'WARNSUPERADMINCREATE' ));
			return false;
		}

		if ($this->get('gid') == 24 && !($my->get('gid') == 25|| ($this->get('id') == $my->id && $my->get('gid') == 24)))
		{
			// disallow creation of Admin by non Super Admin users
			$this->_setError(JText::_( 'WARNSUPERADMINCREATE' ));
			return false;
		}
		//are we creating a new user
		$isnew = !$this->id;

		// If we aren't allowed to create new users return
		if ($isnew && $updateOnly) {
			return true;
		}

		// Get the old user
		$old = new JUser($this->id);

		// Fire the onBeforeStoreUser event.
		JPluginHelper::importPlugin( 'user' );
		$dispatcher =& jdispatcher::getInstance();
		$dispatcher->trigger( 'onBeforeStoreUser', array( $old->getPublicProperties(true), $isnew ) );

		//Store the user data in the database
		if (!$result = $this->store()) {
			$this->_setError($this->getError());
		}
		// Fire the onAftereStoreUser event
		$dispatcher->trigger( 'onAfterStoreUser', array( $this->getPublicProperties(true), $isnew, $result, $this->getError() ) );
		return $result;
	}

	/**
	 * Overloaded check method to ensure data integrity
	 *
	 * @access public
	 * @return boolean True on success
	 * @since 1.0
	 */
	function check()
	{
		return true;
	}
}
?>
