<?php
/**
 * $Id: view.html.php 7311 2011-08-19 11:18:02Z shitz $
 * $LastChangedDate: 2011-08-19 17:18:02 +0600 (Fri, 19 Aug 2011) $
 * $LastChangedBy: shitz $
 * MightyRegistration by Mighty Extensions
 * a component for Joomla! 1.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mightyextensions.com/
 * @copyright Copyright (C) 2006 - 2011 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/
defined('_JEXEC') or die('Restricted access');

jimport( 'joomla.application.component.view');

class JUserViewExport extends JView
{
	function display($tpl = null)
	{
		$layout = JRequest::getVar('layout', 'default');

		$this->{'_init'.$layout}();

		parent::display($tpl);
	}

	function _initXLSTable()
	{
		global $mainframe, $option;
        
		header("Content-type: application/vnd.ms-excel; charset=UTF-8");
        header("Content-Transfer-Encoding: binary");
        $udate = & JFactory::getDate();
		header("Content-Disposition: attachment; filename=userexport_".$udate->toFormat('%Y-%m-%d_%H:%M:%S').".xls");

		$uri 	  = & JFactory::getURI();

		$this->putInRequerstSerializedFilters( JRequest::getVar('serialized_filters') );

		$users           = $this->get('UserForExport');
		$extended_fields = $this->get('fieldShowList');
		$filter_order	  	= $mainframe->getUserStateFromRequest( $option.'.export.filter_order', 'filter_order', 'u.registerDate', 'cmd' );
		$filter_order_Dir	= $mainframe->getUserStateFromRequest( $option.'.export.filter_order_Dir', 'filter_order_Dir', '', 'word' );

		$this->assignRef('users', $users);
		$this->assignRef('extended_fields', $extended_fields);
		$this->assignRef('order_Dir', $filter_order_Dir);
		$this->assignRef('order', $filter_order);
	}

	function _initExport()
	{
		global $mainframe, $option;
		$uri 	  = & JFactory::getURI();

		JToolBarHelper::title(   JText::_( 'Export' ).': <small><small>[ '.JText::_('result').' ]</small></small>', 'archive.png' );
		JToolBarHelper::back();
		JToolBarHelper::custom('preview', 'preview.png', 'preview_f2.png', 'Print preview', false, false);
		$bar = & JToolBar::getInstance('toolbar');
		$bar->addButtonPath(JPATH_COMPONENT_ADMINISTRATOR.DS.'libraries'.DS.'button');
		$bar->appendButton( 'JSHelp',  'http://help.joomsuite.com/user/index.html?exporting_data_to_excel.htm', 1000, 500 );

		if(JRequest::getVar('serialized_filters')){
			$this->putInRequerstSerializedFilters( JRequest::getVar('serialized_filters') );
		}

		$filter_order	  	= $mainframe->getUserStateFromRequest( $option.'.export.filter_order',		 'filter_order',		 'u.registerDate',	'cmd' );
		$filter_order_Dir	= $mainframe->getUserStateFromRequest( $option.'.export.filter_order_Dir', 'filter_order_Dir', '',				    'word' );

		$total		  = & $this->get( 'Total' );
		$pagination = & $this->get( 'Pagination' );

		$users           = $this->get('UserForExport');
		$extended_fields = $this->get('fieldShowList');

		$serialized_filters = $this->getSerializedFilters();


		$this->assignRef('request_url',        $uri->toString());
		$this->assignRef('users',              $users);
		$this->assignRef('extended_fields',    $extended_fields);
		$this->assignRef('order_Dir',          $filter_order_Dir);
		$this->assignRef('order',		       $filter_order);
		$this->assignRef('pagination',         $pagination);
		$this->assignRef('serialized_filters', $serialized_filters);
		return;
	}

	function _initDefault()
	{
		$uri 	  = & JFactory::getURI();
		$lists = array();
		JToolBarHelper::title(   JText::_( 'Export' ).': <small><small>[ '.JText::_('configuration').' ]</small></small>', 'archive.png' );
		//JToolBarHelper::cancel();
		JToolBarHelper::apply();
		$bar = & JToolBar::getInstance('toolbar');
		$bar->addButtonPath(JPATH_COMPONENT_ADMINISTRATOR.DS.'libraries'.DS.'button');
		$bar->appendButton( 'JSHelp',  'http://help.joomsuite.com/user/index.html?exporting_data_to_excel.htm', 1000, 500 );
		$extended_fields = $this->get('ExportableFieldList');

		$extended_field_checkboxes = $this->extendedFieldCheckboxes($extended_fields);
		$core_field_checkboxes     = $this->coreFieldCheckboxes($extended_fields);
		$active_filter             = $this->activeFilter();
		$dateFromRangeFilter       = $this->dateFromRangeFilter();
		$dateToRangeFilter         = $this->dateToRangeFilter();

		if ($GLOBALS['is_jcs_exist'] )
		{
			$none = new StdClass();
			$none->text = JText::_("No Subscriptions");
			$none->value = '0';
			$subscriptions = $this->getJCSSubscriptions();
			array_unshift($subscriptions, $none);
			$lists['subscriptions'] = JHTML::_('select.genericlist',  $subscriptions, 'jcssubscr[]', 'class="inputbox" size="5" multiple="multiple"', 'value', 'text');

		}

		$this->assignRef('request_url',               $uri->toString());
		$this->assignRef('lists',               	  $lists);
		$this->assignRef('extended_fields',           $extended_fields);
		$this->assignRef('extended_field_checkboxes', $extended_field_checkboxes);
		$this->assignRef('core_field_checkboxes',     $core_field_checkboxes);
		$this->assignRef('active_filter',             $active_filter);
		$this->assignRef('dateFromRangeFilter',       $dateFromRangeFilter);
		$this->assignRef('dateToRangeFilter',         $dateToRangeFilter);
	}

	function extendedFieldCheckboxes($extended_fields)
	{
		$result  = '';
        $result .= '<a href="javascript: void(0);" onclick="set_all_values(\'ext_flds\', true )">';
		$result .= JText::_('Select all');
		$result .= '</a>';
		$result .= ' / ';
		$result .= '<a href="javascript: void(0);" onclick="set_all_values(\'ext_flds\', false )">';
		$result .= JText::_('Deselect all');
		$result .= '<table><tr>';
		$result .= '</a>';
		$result .= '<table><tr>';
		$column=1;
        $i = 0;
		foreach($extended_fields as $field){
			if($column > 5 ){
				$column = 1;
				$result .= "</tr><tr>";
			}
			$result .= '<td width="2%">';
			$result .= '<input type="checkbox" id="field_values_ext_flds_'.$i++.'" name="extended_fields_include[]" value="'.$field->field_id.'" checked >';
			$result .= '<td width="18%">'.$field->title.'</td>';
			$result .= '</td>';
			$column++;
		}
		$result .= '</tr></table>';
        $result .= '<input type="hidden" id="field_values_ext_flds_'.$i.'" value="_stop_karaul_ne_mogu_bolshe_">';
		return $result;
	}

	function coreFieldCheckboxes($extended_fields)
	{
		$result  = '';
        $result .= '<a href="javascript: void(0);" onclick="set_all_values(\'core_flds\', true )">';
		$result .= JText::_('Select all');
		$result .= '</a>';
		$result .= ' / ';
		$result .= '<a href="javascript: void(0);" onclick="set_all_values(\'core_flds\', false )">';
		$result .= JText::_('Deselect all');
		$result .= '<table><tr>';
		$result .= '</a>';
        if (JU_REGISTRATION_FORM_LAST_NAME_ENABLE){
            $result .= '<td width="2%"><input type="checkbox" id="field_values_core_flds_0" name="core_fields_include[]" value="first_name" checked="checked"></td><td width="18%">'.JText::_('First name').'</td>';
            $result .= '<td width="2%"><input type="checkbox" id="field_values_core_flds_1" name="core_fields_include[]" value="last_name" checked="checked"></td><td width="18%">'.JText::_('Last name').'</td>';
        }
        else{
            $result .= '<td width="2%"><input type="checkbox" id="field_values_core_flds_0" name="core_fields_include[]" value="name" checked="checked"></td><td width="18%">'.JText::_('Name').'</td>';
            $result .= '<input type="hidden" id="field_values_core_flds_1" value="do_fake">';
        }
		$result .= '<td width="2%"><input type="checkbox" id="field_values_core_flds_2" name="core_fields_include[]" value="username" checked="checked"></td><td width="18%">'.JText::_('User name (login)').'</td>';
		$result .= '<td width="2%"><input type="checkbox" id="field_values_core_flds_3" name="core_fields_include[]" value="email" checked="checked"></td><td width="18%">'.JText::_('Email').'</td>';
		$result .= '<td width="2%"><input type="checkbox" id="field_values_core_flds_4" name="core_fields_include[]" value="registerDate" checked="checked"></td><td width="18%">'.JText::_('Register date').'</td>';
		$result .= '<td width="2%"><input type="checkbox" id="field_values_core_flds_5" name="core_fields_include[]" value="block" checked="checked"></td><td width="18%">'.JText::_('Active').'</td>';
		$result .= '</tr></table>';
        $result .= '<input type="hidden" id="field_values_core_flds_6" value="_stop_karaul_ne_mogu_bolshe_">';
		return $result;
	}

	function activeFilter()
	{
		$result  = '';
		$result .= ' <input type="radio" name="active_filter" value="active" checked="checked">'.JText::_('Active only');
		$result .= ' <input type="radio" name="active_filter" value="blocked">'.JText::_('Blocked only');
		$result .= ' <input type="radio" name="active_filter" value="both">'.JText::_('Both');
		return $result;
	}

	function dateFromRangeFilter()
	{
		$date_month_ago = getdate( time() - 2678400 );
		$date_month_ago = $date_month_ago['year'].'-'.$date_month_ago['mon'].'-'.$date_month_ago['mday'];

		$result = JHTML::_('calendar', $date_month_ago, 'date_from', 'id_date_from', '%Y-%m-%d', array('class' => 'inputbox'));

		return $result;
	}

	function dateToRangeFilter()
	{
		$current_date   = getdate( time() );
		$current_date   = $current_date['year'].'-'.$current_date['mon'].'-'.$current_date['mday'];

		$result = JHTML::_('calendar', $current_date, 'date_to', 'id_date_to', '%Y-%m-%d', array('class' => 'inputbox'));

		return $result;
	}

	function fieldValuesFilter( $field )
	{
		switch($field->type){
			case 'text':
			case 'textarea':
				$result = $this->textFilter($field);
				break;
			case 'date':
			case 'calendar':
				$result = $this->dateFilter($field);
				break;
			case 'select':
			case 'radio':
			case 'mult_select':
			case 'checkbox':
				$result = $this->multivalueFilter($field);
				break;
			case 'phone':
				$result = $this->phoneFilter($field);
				break;
		}

		return $result;
	}

	function textFilter($field)
	{
		$result  = '';

		$result .= '<input type="text"   name="value_filter['.$field->field_id.'][condition]">';

		$result .= '<input type="hidden" name="value_filter['.$field->field_id.'][type]" value="'.$field->type.'">';

		return $result;
	}

	function dateFilter($field)
	{



		$result  = '';
		$result .= '<table><tr><td>';
		$result .= '<small>'.JText::_('From').'</small>';
		$result .= '</td><td>';
		$result .= JHTML::_('calendar', '', 'value_filter['.$field->field_id.'][condition][date_from]', 'id_date_from_'.$field->alias, '%Y-%m-%d', array('class' => 'inputbox'));
		$result .= '</td></tr><tr><td>';
		$result .= '<small>'.JText::_('To').'</small>';
		$result .= '</td><td>';
		$result .= JHTML::_('calendar', '', 'value_filter['.$field->field_id.'][condition][date_to]', 'id_date_to_'.$field->alias, '%Y-%m-%d', array('class' => 'inputbox'));
		$result .= '</td></tr></table>';

		$result .= '<input type="hidden" name="value_filter['.$field->field_id.'][type]" value="'.$field->type.'">';

		return $result;
	}

	function multivalueFilter($field)
	{
		JRequest::setVar('_field_', $field);
		$field_values = $this->get('FieldValues');

		$img  = '<a href="javascript: void(0);" onclick="switch_state_fieldset(\''.$field->alias.'\')">';
		$img .= '<img src="images/expandall.png" id="fieldset_switch_img_'.$field->alias.'">';
		$img .= '</a>';

		$result  = '';
		$result .= '<fieldset class="adminform" style="width:90%">';
		$result .= '<legend>'.JText::_( 'Values' ).' '.$img.'</legend>';
		$result .= '<div id="container_'.$field->alias.'" style="display:none">';
		$result .= '<a href="javascript: void(0);" onclick="set_all_values(\''.$field->alias.'\', true )">';
		$result .= JText::_('Select all');
		$result .= '</a>';
		$result .= ' / ';
		$result .= '<a href="javascript: void(0);" onclick="set_all_values(\''.$field->alias.'\', false )">';
		$result .= JText::_('Deselect all');
		$result .= '</a>';
		$result .= '<hr>';
		$result .= '<table><tr>';
		$column = 1;
		foreach($field_values as $key => $value){
			if($column > 4){
				$result .= '</tr><tr>';
				$column = 1;
			}
			$result .= '<td><input type="checkbox" name="value_filter['.$field->field_id.'][condition][]" id="field_values_'.$field->alias.'_'.$key.'" value="'.$value.'"> '.$value.'</td>';
			$column++;
		}
		$result .= '<input type="hidden" id="field_values_'.$field->alias.'_'.($key+1).'" value="_stop_karaul_ne_mogu_bolshe_">';
		$result .= '</tr></table>';
		$result .= '</div>';
		$result .= '</fieldset>';

		$result .= '<input type="hidden" name="value_filter['.$field->field_id.'][type]" value="'.$field->type.'">';

		return $result;
	}

	function phoneFilter($field)
	{
		$result = '';
		$result .= '<table><tr><td>';
		$result .= '<small>'.JText::_('Country code').'</small>';
		$result .= '</td><td>';
		$result .= '<small>'.JText::_('City code').'</small>';
		$result .= '</td><td>';
		$result .= '<small>'.JText::_('Phone').'</small>';
		$result .= '</td><td>';
		$result .= '<small>'.JText::_('Extention').'</small>';
		$result .= '</td></tr><tr><td>';
		$result .= '<input type="text" name="value_filter['.$field->field_id.'][condition][country]" size="7"> ';
		$result .= '</td><td>';
		$result .= '<input type="text" name="value_filter['.$field->field_id.'][condition][city]" size="5"> ';
		$result .= '</td><td>';
		$result .= '<input type="text" name="value_filter['.$field->field_id.'][condition][phone]" size="7"> ';
		$result .= '</td><td>';
		$result .= '<input type="text" name="value_filter['.$field->field_id.'][condition][extention]" size="5">';
		$result .= '</td></tr></table>';

		$result .= '<input type="hidden" name="value_filter['.$field->field_id.'][type]" value="'.$field->type.'">';

		return $result;
	}

	function showTableHead()
	{
		$core_fields     = JRequest::getVar('core_fields_include');
		$extended_fields = JRequest::getVar('extended_fields_include');

		$result = '';
		$result .= '<tr>';
		$result .= '<th width="2%" class="title">'.JText::_('#').'</th>';
	if (count($core_fields)){
		foreach( $core_fields as $field)
		{

			$result .= '<th class="title">';
			switch($field){
				case 'first_name':
					if(JRequest::getVar('layout') != 'xlstable'){
						$result .= JHTML::_('grid.sort', JText::_('First name'), 'first_name', $this->order_Dir, $this->order );
					} else {
						$result .= JText::_('First name');
					}
					break;
				case 'last_name':
					if(JRequest::getVar('layout') != 'xlstable'){
						$result .= JHTML::_('grid.sort', JText::_('Last name'), 'last_name', $this->order_Dir, $this->order );
					} else {
						$result .= JText::_('Last name');
					}
					break;
				case 'name':
					if(JRequest::getVar('layout') != 'xlstable'){
						$result .= JHTML::_('grid.sort', JText::_('Name'), 'u.name', $this->order_Dir, $this->order );
					} else {
						$result .= JText::_('Name');
					}
					break;
				default:
					if(JRequest::getVar('layout') != 'xlstable'){
						$result .= JHTML::_('grid.sort', JText::_($field), 'u.'.$field, $this->order_Dir, $this->order );
					} else {
						$result .= JText::_($field);
					}
					break;
			}
			$result .= '</th>';
		}
	}
	if (count($this->extended_fields)){
		foreach( $this->extended_fields as $field )
		{
			$result .= '<th class="title">';
			if(JRequest::getVar('layout') != 'xlstable'){
				$result .= JHTML::_('grid.sort', $field->title, 'field_'.$field->field_id, $this->order_Dir, $this->order );
			} else {
				$result .= $field->title;
			}
			$result .= '</th>';
		}
	}
		if (count(JRequest::getVar('jcssubscr')))
		{
			$result .= '<th>';
			if(JRequest::getVar('layout') != 'xlstable'){
			$result.=JText::_('Subscriptions');
			}
			else
			{
			$result .= JHTML::_('grid.sort', "Subscriptions", 'subscriptions', $this->order_Dir, $this->order );
			}
			$result .= '</th>';
		}
		$result .= '</tr>';
		return $result;
	}

	function showUser()
	{
		$core_fields     = JRequest::getVar('core_fields_include');
		$extended_fields = JRequest::getVar('extended_fields_include');
		$layout          = JRequest::getVar('layout');

		$result = '';
		$results = '';


		$k = 0;
		for ($i=0, $n=count( $this->users ); $i < $n; $i++) {
			if (count($core_fields)){
				foreach( $core_fields as $field)
				{
					$result .= '<td>';
					$result .= $this->users[$i]->{$field};
					$result .= '</td>';
				}
			}
			if (count($this->extended_fields)){
				foreach( $this->extended_fields as $field ){
					$result .= '<td>';
					$result .= $this->users[$i]->{"field_".$field->field_id};
					$result .= '</td>';
				}
			}
			if (count(JRequest::getVar('jcssubscr')))
			{
				$result .= '<td>';
				$result .= $this->users[$i]->subscriptions;
				$result .= '</td>';
			}
			$result .= '</tr>';
//			$empty_replace = array('<td class="ids">'.($i+1).'</td>', '<td class="ids">'.($i+1+$this->pagination->limitstart).'</td>');
//			$result_check = str_replace($empty_replace, null, $result);
			$result_check = strip_tags($result);
			
			if ($result_check){
//			var_dump($result_check);
			if($layout == 'xlstable' ){
				$result = '<td>'.($i+1).'</td>'.$result;
			} else {
				$result = '<td>'.($i+1+$this->pagination->limitstart).'</td>'.$result;
			}
			$result = '<tr class="row'.$k.'">'.$result;
			$results .= $result;
			$k = 1 - $k;
			}
			$result = '';
		}
		return $results;
	}

	function getSerializedFilters()
	{
		$result['core_fields_include']     = JRequest::getVar('core_fields_include');
		$result['extended_fields_include'] = JRequest::getVar('extended_fields_include');
		$result['active_filter']           = JRequest::getVar('active_filter');
		$result['date_from']               = JRequest::getVar('date_from');
		$result['date_to']                 = JRequest::getVar('date_to');
		$result['value_filter']            = JRequest::getVar('value_filter');
		$result['jcssubscr']            = JRequest::getVar('jcssubscr');

		return serialize($result);
	}
	function putInRequerstSerializedFilters( $serialized_filters )
	{
		$filters = unserialize($serialized_filters);

		JRequest::setVar('core_fields_include'    , $filters['core_fields_include'], "POST");
		JRequest::setVar('extended_fields_include', $filters['extended_fields_include'], "POST");
		JRequest::setVar('active_filter'          , $filters['active_filter'], "POST");
		JRequest::setVar('date_from'              , $filters['date_from'], "POST");
		JRequest::setVar('date_to'                , $filters['date_to'], "POST");
		JRequest::setVar('value_filter'           , $filters['value_filter'], "POST");
		JRequest::setVar('jcssubscr'           , $filters['jcssubscr'], "POST");
	}

	function getJCSSubscriptions()
	{
		$db = &JFactory::getDBO();
		$sql = "SELECT name AS text, id as value FROM #__jcs_plans WHERE published = 1 ";
		$db->setQuery($sql);
		$options = $db->loadObjectList();
		return $options;


	}

}
?>