<?php
/**
 * $Id: view.html.php 7311 2011-08-19 11:18:02Z shitz $
 * $LastChangedDate: 2011-08-19 17:18:02 +0600 (Fri, 19 Aug 2011) $
 * $LastChangedBy: shitz $
 * MightyRegistration by Mighty Extensions
 * a component for Joomla! 1.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mightyextensions.com/
 * @copyright Copyright (C) 2006 - 2011 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/
defined('_JEXEC') or die('Restricted access');

jimport( 'joomla.application.component.view');

include_once(JPATH_COMPONENT_ADMINISTRATOR.DS.'includes'.DS.'jpgraph'.DS.'jpgraph.php');
include_once(JPATH_COMPONENT_ADMINISTRATOR.DS.'includes'.DS.'jpgraph'.DS.'jpgraph_line.php');
include_once(JPATH_COMPONENT_ADMINISTRATOR.DS.'includes'.DS.'jpgraph'.DS.'jpgraph_bar.php');
include_once(JPATH_COMPONENT_ADMINISTRATOR.DS.'includes'.DS.'jpgraph'.DS.'jpgraph_pie.php');
include_once(JPATH_COMPONENT_ADMINISTRATOR.DS.'includes'.DS.'jpgraph'.DS.'jpgraph_canvas.php');
include_once(JPATH_COMPONENT_ADMINISTRATOR.DS.'includes'.DS.'jpgraph'.DS.'jpgraph_canvtools.php');

class JUserViewReport extends JView
{
  function getFieldValuesTable($field)
  {
    JRequest::setVar( '_field_', $field );
    $field = $this->get('ReportTableData');
    $result = '';
    if( JRequest::getVar('print_view','no') != 'yes' ){
      $result .= '<a target="_blank" href = "index3.php?option=com_juser&controller=report&view=report&layout=xlstable&field_id='.$field->field_id.'&noxajax=1&date_from='.$this->date_from.'&date_to='.$this->date_to.'&limit_value=no&mode=xls_file" >';
      $result .= JText::_('Download this Table as Microsoft &#174; Excel format').': ';
      $result .= '<img src="'.JURI::base().'components/com_juser/img/xls.png">';
      $result .= '</a>';
    }
    $result .= $this->fieldValuesTable($field);
    return $result;
  }

  function fieldValuesTable($field)
  {
    $result = '';
    $result .= '<table class="adminlist" style="width:800px">';
    $result .= '<thead>';
    $result .= '<tr>';
    $result .= '<th width="3%" class="title">'.JText::_('#').'</th><th width="5%" class="title">'.JText::_('Count').'</th><th  class="title">'.JText::_('Value').'</th>';
    $result .= '</tr>';
    $result .= '</thead>';
    $result .= '<tbody>';
    if( count( $field->statistic ) > 0 ){
      $k = 0;
      $i = 1;
      foreach( $field->statistic as $key => $value ){
        if( $value['y_value'] == 0 ){ continue; }
        $result .= '<tr class="row'.$k.'">';
        $result .= '<td>'.$i.'</td><td>'.$value['y_value'].'</td><td>'.$value['x_value'].'</td>';
        $result .= '</tr>';
        $k = 1 - $k;
        $i++;
      }
    }
    $result .= '</tbody>';
    $result .= '</table>';
    return $result;
  }

	function display($tpl = null)
  {
    $layout = JRequest::getVar('layout', 'default');
    $this->{'init'.$layout}();

    parent::display($tpl);
  }

  function initXLSTable()
  {
    $field_id = JRequest::getVar('field_id');
    JRequest::setVar( 'fields', array($field_id) );
    $field = $this->get( 'FieldListForReport' );

    JRequest::setVar( '_field_', $field[0] );
    $field = $this->get('ReportTableData');

    header("Content-type: application/xls");
	  header("Content-Disposition: attachment; filename=downloaded.xls");
    print $this->fieldValuesTable($field);
    exit;
  }

  function initFieldGraph()
  {
    $data_y  = array();
    $data_x  = array();

    $field = $this->get('field');

    if( count($field->statistic) == 0 ){
      $this->_layout = 'text_graph';
      $this->assignRef('text', JText::_('There is field not stored values for current date range'));
      return;
    }

    switch($field->type){
      case 'radio' :
      case 'text' :
      case 'select' :
	  case 'mult_select':
      case 'checkbox' :
        $graph_type = 'pie';

        foreach($field->statistic as $s){
          $data_y[]  = $s['y_value'];
          $data_x[]  = (!$s['x_value'] ? 'Not checked' : '').FFrame::str_limit( $s['x_value'], 55 ).' ('.$s['y_value'].')';
        }
        break;
      case 'date':
      case 'calendar':
        $graph_type = 'line';

        foreach($field->statistic as $s){
          $data_y[]  = $s['y_value'];
          $data_x[]  = $s['x_value'];
        }
        break;

    }

    //JRequest::setVar('layout', $graph_type.'_graph');
    $this->_layout = $graph_type.'_graph';

    $label = 'Graph for '.FFrame::str_limit($field->title,55);

    /*print_r($data_y);print'<br>';
    print_r($data_x);print'<br>';exit;*/
    $this->assignRef('data_x',   $data_x);
    $this->assignRef('data_y',   $data_y);
    $this->assignRef('legend',   $legend);
    $this->assignRef('label',    $label);
  }

  function initRegistrationProgressLTM()
  {
    $items		= & $this->get( 'RPForLastTwoMonth');
    $item_key = 0;

    $data_y  = array();
    $data_y2 = array();
    $data_x  = array();

    for( $i = 1; $i <= 31; $i++ ){
      if( isset($items[$item_key]) && $items[$item_key]->day == $i ){
        $data_y[] = $items[$item_key]->users;
        $y_legend = $items[$item_key]->year.' '.JText::_( $items[$item_key]->month );
        $item_key++;
      } else {
        $data_y[]  = 0;
      }
      $data_x[]  = $i;
    }

    for( $i = 1; $i <= 31; $i++ ){
      if( isset($items[$item_key]) &&  $items[$item_key]->day == $i ){
        $data_y2[] = $items[$item_key]->users;
        $y2_legend = $items[$item_key]->year.' '.JText::_( $items[$item_key]->month );
        $item_key++;
      } else {
        $data_y2[] = 0;
      }
      $data_x[]  = $i;
    }

    $this->assignRef('data_x',	  $data_x);
    $this->assignRef('data_y',	  $data_y);
    $this->assignRef('data_y2',	  $data_y2);
    $this->assignRef('y_legend',	$y_legend);
    $this->assignRef('y2_legend',	$y2_legend);
  }

  function initRegistrationProgressLY()
  {
    $items		 = & $this->get( 'RPForLastYear');
    $items2		 = & $this->get( 'APForLastYear');
    $item_key  = 0;
    $item_key2 = 0;

    $data_y  = array();
    $data_y2 = array();
    $data_x  = array();

    $current_date  = getdate (time());
    $m_names = array(JText::_('ALL_SHORT_MONTH_JANUARY'),
                     JText::_('ALL_SHORT_MONTH_FEBRUARY'),
                     JText::_('ALL_SHORT_MONTH_MARCH'),
                     JText::_('ALL_SHORT_MONTH_APRIL'),
                     JText::_('ALL_SHORT_MONTH_MAY'),
                     JText::_('ALL_SHORT_MONTH_JUNE'),
                     JText::_('ALL_SHORT_MONTH_JULY'),
                     JText::_('ALL_SHORT_MONTH_AUGUST'),
                     JText::_('ALL_SHORT_MONTH_SEPTEMBER'),
                     JText::_('ALL_SHORT_MONTH_OCTOBER'),
                     JText::_('ALL_SHORT_MONTH_NOVEMBER'),
                     JText::_('ALL_SHORT_MONTH_DECEMBER'));


    for( $i = $current_date['mon']+1; $i <= 12; $i++ ){
    	if( $items[$item_key]->month == $i ){
        $data_y[] = $items[$item_key]->users;
        $item_key++;
      } else {
        $data_y[]  = 0;
      }

      if( $items2[$item_key2]->month == $i ){
        $data_y2[] = $items2[$item_key2]->users;
        $item_key2++;
      } else {
        $data_y2[]  = 0;
      }

      $data_x[]  = $m_names[$i-1];
    }

    for( $i = 1; $i <= $current_date['mon']; $i++ ){
      if( isset($items[$item_key]->month) && $items[$item_key]->month == $i ){
        $data_y[] = $items[$item_key]->users;
        $item_key++;
      } else {
        $data_y[]  = 0;
      }

      if( isset($items[$item_key]->month) && $items2[$item_key2]->month == $i ){
        $data_y2[] = $items2[$item_key2]->users;
        $item_key2++;
      } else {
        $data_y2[]  = 0;
      }

      $data_x[]  = $m_names[$i-1];
    }

    foreach($data_y as $key => $item){ $data_y[$key] = $data_y[$key] - $data_y2[$key]; }

    $y_legend  = JText::_('Activated users');
    $y2_legend = JText::_('Not activated users');


    $this->assignRef('data_x',	  $data_x);
    $this->assignRef('data_y',	  $data_y);
    $this->assignRef('data_y2',	  $data_y2);
    $this->assignRef('y_legend',	$y_legend);
    $this->assignRef('y2_legend',	$y2_legend);
  }

  function initReport()
  {
    JToolBarHelper::title( JText::_( 'Report' ), 'stats.png' );
    JToolBarHelper::back();
    JToolBarHelper::custom('preview', 'preview.png', 'preview_f2.png', 'Print preview', false, false);

    $field_list = & $this->get( 'FieldListForReport' );

    $this->assignRef('field_list', $field_list);
    $this->assignRef('date_from',  JRequest::getVar('date_from'));
    $this->assignRef('date_to',    JRequest::getVar('date_to'));
  }

  function initDefault()
  {

    JToolBarHelper::title( JText::_( 'Report Config' ), 'stats.png' );
    //JToolBarHelper::cancel();
    JToolBarHelper::apply();

		$uri	 = & JFactory::getURI();

		$items = & $this->get( 'Data');

  	$current_date   = getdate( time() + 60*60*24 );
		$date_month_ago = getdate( time() - 2678400 );
    $date_month_ago = $date_month_ago['year'].'-'.$date_month_ago['mon'].'-'.$date_month_ago['mday'];
    $current_date   = $current_date['year'].'-'.$current_date['mon'].'-'.$current_date['mday'];

    $checkbox_field_list = $this->fieldCheckboxList();
    $select_all_controll = $this->selectAllControll();

    $lists   = array();

    $lists['calendar_date_from'] = JHTML::_('calendar', $date_month_ago, 'date_from', 'id_date_from', '%Y-%m-%d', array('class' => 'inputbox', 'readonly' => 'readonly'));
    $lists['calendar_date_to']   = JHTML::_('calendar', $current_date, 'date_to', 'id_date_to', '%Y-%m-%d', array('class' => 'inputbox', 'readonly' => 'readonly'));

    $this->assignRef('lists',	              $lists);
    $this->assignRef('request_url',         $uri->toString());
		$this->assignRef('checkbox_field_list', $checkbox_field_list);
		$this->assignRef('select_all_controll', $select_all_controll);
  }

  function fieldCheckboxList()
  {
    $result  = '';
    $field_list = & $this->get( 'ReportableFiledList' );

    foreach($field_list as $field){
      $result .= '<div>';
      $result .= '<input type="checkbox" name = "fields['.$field->alias.']" id="id_field_'.$field->alias.'" '.($field->count_values == 0 ? ' disabled ' : '').' value="'.$field->field_id.'"> ';
      $result .= $field->title;
      $result .= $field->count_values == 0 ? ' ('.JText::_('there is not stored values').')' : '';
      $result .= '</div>';
    }
    return $result;
  }
  function selectAllControll()
  {
    $fields = & $this->get( 'ReportableFiledList' );

    $t = true;
    $field_list = '';
    foreach($fields as $field){
      if( $field->count_values != 0 ){
        $field_list .= $t ? '' : ',';
        $t = false;
        $field_list .= '"id_field_'.$field->alias.'"';
      }
    }

    ob_start();
    ?>
    <div>
      <a href="javascript: void(0);" onclick="ju_select_all();">
      <?php print JText::_('Select all fields'); ?>
    </a>
    </div><div>
      <a href="javascript: void(0);" onclick="ju_deselect_all();">
      <?php print JText::_('Deselect all fields');?>
    </a>
    </div>

    <script language="javascript">
      var fields = new Array(<?php print $field_list; ?>);
      function ju_select_all()
      {
        for(i = 0; i<fields.length; i++){
          document.getElementById(fields[i]).checked = true;
        }
      }
      function ju_deselect_all()
      {
        for(i = 0; i<fields.length; i++){
          document.getElementById(fields[i]).checked = false;
        }
      }
    </script>
    <?php
    $result = ob_get_contents ( );
    ob_end_clean();

    return $result;
  }
}
?>