<?php
/**
 * $Id: view.html.php 7311 2011-08-19 11:18:02Z shitz $
 * $LastChangedDate: 2011-08-19 17:18:02 +0600 (Fri, 19 Aug 2011) $
 * $LastChangedBy: shitz $
 * MightyRegistration by Mighty Extensions
 * a component for Joomla! 1.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mightyextensions.com/
 * @copyright Copyright (C) 2006 - 2011 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/
defined('_JEXEC') or die('Restricted access');
jimport( 'joomla.application.component.view');

class JUserViewUser extends JView
{
  function display($tpl = null)
  {
     JToolBarHelper::title(   JText::_( 'List' ), 'generic.png' );

     $this->_displayForm($tpl);

     parent::display($tpl);
  }

  function _displayForm($tpl)
  {
    global $mainframe, $option;

    $db     = & JFactory::getDBO();
    $acl    = & JFactory::getACL();
    $uri    = & JFactory::getURI();
    $myuser = & JFactory::getUser();
    $model  = & $this->getModel();

    $lists = array();

    //get the user
    $user_data  =& $this->get('data');
    $user_core_data     = & $user_data->core_data;
    $user_extended_data = & $user_data->extended_data;

    $isNew = (!isset($user_core_data->id) || $user_core_data->id < 1);

    JToolBarHelper::title(   JText::_( 'User' ).': <small><small>[ ' .JText::_( 'Edit' ).' ]</small></small>', 'user.png' );
    JToolBarHelper::save();
    JToolBarHelper::apply();
    if ($isNew)  {
      JToolBarHelper::cancel();
    } else {
      // for existing users the button is renamed `close`
      JToolBarHelper::cancel( 'cancel', 'Close' );
    }

    $bar = & JToolBar::getInstance('toolbar');
	$bar->addButtonPath(JPATH_COMPONENT_ADMINISTRATOR.DS.'libraries'.DS.'button');
	$bar->appendButton( 'JSHelp',  'http://help.joomsuite.com/user/editing_a_user.htm', 1000, 500 );

    //clean weblink data
    jimport('joomla.filter.output');
    JFilterOutput::objectHTMLSafe( $user_core_data, ENT_QUOTES );

    $param_file  = JPATH_COMPONENT.DS.'views'.DS.'user'.DS.'user_params.xml';
    $params     = new JParameter( $user_core_data->params, $param_file );

    $block_list_or_msg   = $this->canUserBeBlocked( $user_core_data, 'com_user', 'block user');
    $canEmailEvents = $acl->acl_check( 'workflow', 'email_events', 'users', $acl->get_group_name( $user_core_data->gid, 'ARO' ) );

    $lvisit = $user_core_data->lastvisitDate;
    if ($lvisit == "0000-00-00 00:00:00") {
      $lvisit = "Never";
    }

    $lists['groups'] = $this->getGroupList( $user_core_data, $myuser, $acl );
    // build the html select list
    $lists['block']   = JHTML::_('select.booleanlist',  'block', 'class="inputbox" size="1"', $user_core_data->block );
     // build the html select list
    $lists['sendEmail'] = JHTML::_('select.booleanlist',  'sendEmail_', 'class="inputbox" size="1"', $user_core_data->sendEmail );

    if ( $user_core_data->id ){
      $query = 'SELECT *'
      . ' FROM #__contact_details'
      . ' WHERE user_id = '.(int)$user_core_data->id
      ;
      $db->setQuery( $query );
      $contact = $db->loadObjectList();
    }
    else{
      $contact   = NULL;
      // Get the default group id for a new user
      $config    = &JComponentHelper::getParams( 'com_users' );
      $newGrp    = $config->get( 'new_usertype' );
      $user_core_data->gid = $acl->get_group_id( $newGrp, null, 'ARO' );
    }

		$document = &JFactory::getDocument();
		$document->addScript('components/com_juser/includes/email_validation.js');
    $this->assignRef('lists',              $lists);
    $this->assignRef('core_data',          $user_core_data);
    $this->assignRef('extended_data',      $user_extended_data);
    $this->assignRef('params',            $params);
    $this->assignRef('request_url',        $uri->toString());
    $this->assignRef('block_list_or_msg',  $block_list_or_msg);
    $this->assignRef('canEmailEvents',    $canEmailEvents);
    $this->assignRef('lvisit',            $lvisit);
    $this->assignRef('contact',           $contact);
  }
  function getGroupList( & $user, & $myuser, & $acl )
  {
    $userObjectID   = $acl->get_object_id( 'users', $user->id, 'ARO' );
    $userGroups   = $acl->get_object_groups( $userObjectID, 'ARO' );
    $userGroupName   = strtolower( $acl->get_group_name( $userGroups[0], 'ARO' ) );

    $myObjectID   = $acl->get_object_id( 'users', $myuser->get('id'), 'ARO' );
    $myGroups     = $acl->get_object_groups( $myObjectID, 'ARO' );
    $myGroupName   = strtolower( $acl->get_group_name( $myGroups[0], 'ARO' ) );

    if ( $userGroupName == $myGroupName && $myGroupName == 'administrator' )
    {
      // administrators can't change each other
      $list_gid  = '<input type="hidden" name="gid" value="'.$user->gid.'" />';
      $list_gid .= '<strong>'. JText::_( 'Administrator' ) .'</strong>';
    }
    else
    {
      $gtree = $acl->get_group_children_tree( null, 'USERS', false );
      $list_gid   = JHTML::_('select.genericlist',   $gtree, 'gid', 'size="10"', 'value', 'text', $user->gid );
    }
    return $list_gid;
  }

  function canUserBeBlocked( &$user)
  {

    $db           =& JFactory::getDBO();
    $acl          =& JFactory::getACL();
    $currentUser   =& JFactory::getUser();

    $objectID   = $acl->get_object_id( 'users', $user->id, 'ARO' );
    $groups   = $acl->get_object_groups( $objectID, 'ARO' );

    $this_group = strtolower( $acl->get_group_name( $groups[0], 'ARO' ) );

    $msg='';

    if ( $user->id == $currentUser->get( 'id' ) ){
      $msg = JText::_( 'You cannot block Yourself!' );
    }
    else if ( ( $this_group == 'administrator' ) && ( $currentUser->get( 'gid' ) == 24 ) ){
      $msg = JText::_( 'WARNBLOCK' );
    }
    else{
      if ( $user->gid == 25 ){
        // count number of active super admins
        $query = 'SELECT COUNT( id )'
        . ' FROM #__users'
        . ' WHERE gid = 25'
        . ' AND block = 0'
        ;
        $db->setQuery( $query );
        $count = $db->loadResult();

        if ( $count <= 1){
          $msg = "You cannot block this Super Administrator as it is the only active Super Administrator for your site";
        }
      }
    }
    return $msg;
  }
}
?>