<?php
/**
 * $Id: view.html.php 7311 2011-08-19 11:18:02Z shitz $
 * $LastChangedDate: 2011-08-19 17:18:02 +0600 (Fri, 19 Aug 2011) $
 * $LastChangedBy: shitz $
 * MightyRegistration by Mighty Extensions
 * a component for Joomla! 1.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mightyextensions.com/
 * @copyright Copyright (C) 2006 - 2011 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/
defined('_JEXEC') or die('Restricted access');
jimport( 'joomla.application.component.view');

class JUserViewUsers extends JView
{
	function display($tpl = null)
	{
		global $mainframe, $option;
		JToolBarHelper::title(   JText::_( 'User Manager' ), 'user.png' );
		if($GLOBALS['is_jcacl_exist']){
			JToolBarHelper::custom( 'setrights', 'back.png', 'back_f2.png', 'Set permissions' );
		}
		if($GLOBALS['is_jcs_exist']){
			JToolBarHelper::custom( 'addsubsciptions', 'back.png', 'back_f2.png', 'Set subscriptions' );
		}
		JToolBarHelper::custom( 'logout', 'cancel.png', 'cancel_f2.png', 'Logout' );
		if($GLOBALS['is_jcacl_exist']){
			JToolBarHelper::custom('showmove', 'move', '',"Move", true);
		}
		JToolBarHelper::deleteList();
		JToolBarHelper::editListX();
		JToolBarHelper::addNewX();
		$bar = & JToolBar::getInstance('toolbar');
		$bar->addButtonPath(JPATH_COMPONENT_ADMINISTRATOR.DS.'libraries'.DS.'button');
		$bar->appendButton( 'JSHelp',  'http://help.joomsuite.com/user/index.html?user_manager.htm', 1000, 500 );
		$filter_order		  = $mainframe->getUserStateFromRequest( $option.'.users.filter_order',		  'filter_order',		  'a.registerDate',	'cmd' );
		$filter_order_Dir	= $mainframe->getUserStateFromRequest( $option.'.users.filter_order_Dir',	'filter_order_Dir',	'',				        'word' );
		$filter_type		  = $mainframe->getUserStateFromRequest( $option.'.filter_type',		        'filter_type', 		  0,			          'string' );
		$filter_logged		= $mainframe->getUserStateFromRequest( $option.'.filter_logged',		      'filter_logged', 	  0,			          'int' );
		$search				    = $mainframe->getUserStateFromRequest( $option.'.search',			            'search', 			    '',			          'string' );

		$uri	      =& JFactory::getURI();
		$users      = & $this->get('data');
		$items		  = & $this->get( 'Data');
		$total		  = & $this->get( 'Total');
		$pagination = & $this->get( 'Pagination' );

		$lists['type'] = $this->getUserTypeList($filter_type);

		// get list of Log Status for dropdown filter
		$logged[] = JHTML::_('select.option',  0, '- '. JText::_( 'Select Log Status' ) .' -');
		$logged[] = JHTML::_('select.option',  1, JText::_( 'Logged In' ) );


		$lists['logged'] = JHTML::_('select.genericlist',   $logged, 'filter_logged', 'class="inputbox" size="1" onchange="document.adminForm.submit( );"', 'value', 'text', "$filter_logged" );

		$lists['extended_fields_filters'] = $this->getExtendedFieldsFilters();

		$this->assignRef('users',	      $users);
		$this->assignRef('lists',		    $lists);
		$this->assignRef('pagination',	$pagination);
		$this->assignRef('request_url',	$uri->toString());
		$this->assignRef('search',	    $search);
		$this->assignRef('order_Dir',	  $filter_order_Dir);
		$this->assignRef('order',	      $filter_order);

		parent::display($tpl);
	}

	function getUserTypeList($currentValue='')
	{
		$db				=& JFactory::getDBO();
		$query = 'SELECT name AS value, name AS text'
		. ' FROM #__core_acl_aro_groups'
		. ' WHERE name != "ROOT"'
		. ' AND name != "USERS"'
		;
		$db->setQuery( $query );
		$types[] 		= JHTML::_('select.option',  '0', '- '. JText::_( 'Select Group' ) .' -' );
		foreach( $db->loadObjectList() as $obj ){
			$types[] = JHTML::_('select.option',  $obj->value, JText::_( $obj->text ) );
		}
		$type_list = JHTML::_('select.genericlist',   $types, 'filter_type', 'class="inputbox" size="1" onchange="document.adminForm.submit( );"', 'value', 'text', "$currentValue" );
		return $type_list;
	}

	function getExtendedFieldsFilters()
	{
		global $mainframe;

		$fields = $this->get('SearcheableExtendedFieldList');
		$field_types_for_searchlist = array('select', 'mult_select', 'checkbox', 'radio');
		$result = array();
		foreach ( $fields as $field ){
			if( in_array( $field->type, $field_types_for_searchlist ) ){

				if(!isset($_REQUEST['filter_'.$field->alias])){
					$selected = $mainframe->getUserState( 'filter_'.$field->alias );
				} else {
					$selected = JRequest::getVar('filter_'.$field->alias );
				}

				$mainframe->setUserState( 'filter_'.$field->alias, $selected );

				$result[] = $this->getFilterSelectList( $field, $selected );

			}
		}
		return implode (' ', $result);
	}

	function getFilterSelectList( $field, $selected = '' )
	{
		$params     = new JParameter( $field->params);

		$values = explode( "\n", str_replace( "\r" , "" , $params->get('values') ) );

		$options[] = JHTML::_('select.option', '',JText::_("- select")." ".FFrame::str_limit($field->title, 30)." -");

		foreach($values as $value){
			$options[] = JHTML::_('select.option', $value, FFrame::str_limit($value, 30) );
		}
		return JHTML::_('select.genericlist', $options, 'filter_'.$field->alias, 'class="inputbox" size="1" onchange="document.adminForm.submit( );"', 'value', 'text', $selected );
	}
}
?>