1<?php

	defined('_JEXEC') or die('Restricted Access');

	/**
	 * Image Resizer. 
	 * @author : Harish Chauhan
	 * @copyright : Freeware
	 * About :This PHP script will resize the given image and can show on the fly or save as image file.
	 *
	 */
	

	if (!defined("HAR_AUTO_NAME"))
		define("HAR_AUTO_NAME",1);
	
	class JS_Image_Resizer
	{
		var $imgFile="";
		var $imgWidth=0;
		var $imgHeight=0;
		var $imgType="";
		var $imgAttr="";
		var $type=NULL;
		var $_img=NULL;
		var $_error="";
		
		var $_border = null;
		
		var $chunkGifs 		= true;
		var $transparentGif = false;
		
		var $tempDir = null;
		
		/**
		 * Constructor
		 *
		 * @param [String $imgFile] Image File Name
		 * @return RESIZEIMAGE (Class Object)
		 */
		
		function JS_Image_Resizer($imgFile="", $tempDir = JPATH_CACHE)
		{
			if (!function_exists("imagecreate"))
			{
				$this->_error="Error: GD Library is not available.";
				return false;
			}

			$this->type=Array(1 => 'GIF', 2 => 'JPG', 3 => 'PNG', 4 => 'SWF', 5 => 'PSD', 6 => 'BMP', 7 => 'TIFF', 8 => 'TIFF', 9 => 'JPC', 10 => 'JP2', 11 => 'JPX', 12 => 'JB2', 13 => 'SWC', 14 => 'IFF', 15 => 'WBMP', 16 => 'XBM');
			if(!empty($imgFile))
				$this->setImage($imgFile);
				
			$this->tempDir = $tempDir;
		}
		/**
		 * Error occured while resizing the image.
		 *
		 * @return String 
		 */
		function error()
		{
			return $this->_error;
		}
		
		/**
		 * Set image border (look at picture plugin :))
		 * @param $border string | gd resource Image file 
		 * @return boolean
		 */
		function setBorder($border = null) {
			// unset border
			if (is_null($border)) {
				if (is_resource($this->_border)) {
					@imagedestroy($this->_border);
				}
				return true;
			}
			
			if (is_resource($border)) {
				$this->_border = $border;
				return true;
			}
			
			if (file_exists($border)) {
				$this->_border = $this->_readImageToGD($border);
				return true;
			}
			
			return false;
		}
		
		/**
		 * Set image file name
		 *
		 * @param String $imgFile
		 * @return void
		 */
		function setImage($imgFile)
		{
			$this->imgFile = $imgFile;
			return $this->_createImage();
		}
		
		/**
		 * 
		 * @return void
		 */
		function close()
		{
			if (is_resource($this->_border))
				@imagedestroy($this->_border);
			
			return @imagedestroy($this->_img);
		}
		/**
		 * Resize a image to given width and height and keep it's current width and height ratio
		 * 
		 * @param Number $imgwidth
		 * @param Numnber $imgheight
		 * @param String $newfile
		 */
		function resize_limitwh($imgwidth,$imgheight,$newfile=NULL)
		{
			$image_per = 100;
			list($width, $height, $type, $attr) = @getimagesize($this->imgFile);
			if($width > $imgwidth && $imgwidth > 0)
				$image_per = (double)(($imgwidth * 100) / $width);

			if(floor(($height * $image_per)/100)>$imgheight && $imgheight > 0)
				$image_per = (double)(($imgheight * 100) / $height);

			$this->resize_percentage($image_per,$newfile);

		}
		/**
		 * Resize an image to given percentage.
		 *
		 * @param Number $percent
		 * @param String $newfile
		 * @return Boolean
		 */
		function resize_percentage($percent=100,$newfile=NULL)
		{
			$newWidth=($this->imgWidth*$percent)/100;
			$newHeight=($this->imgHeight*$percent)/100;
			return $this->resize($newWidth,$newHeight,$newfile);
		}
		/**
		 * Resize an image to given X and Y percentage.
		 *
		 * @param Number $xpercent
		 * @param Number $ypercent
		 * @param String $newfile
		 * @return Boolean
		 */
		function resize_xypercentage($xpercent=100,$ypercent=100,$newfile=NULL)
		{
			$newWidth=($this->imgWidth*$xpercent)/100;
			$newHeight=($this->imgHeight*$ypercent)/100;
			return $this->resize($newWidth,$newHeight,$newfile);
		}
		
		/**
		 * Resize an image to given width and height
		 *
		 * @param Number $width
		 * @param Number $height
		 * @param String $newfile
		 * @return Boolean
		 */
		function resize($width,$height,$newfile=NULL)
		{
			if(empty($this->imgFile))
			{
				$this->_error="File name is not initialised.";
				return false;
			}
			if($this->imgWidth<=0 || $this->imgHeight<=0)
			{
				$this->_error="Could not resize given image";
				return false;
			}
			if($width<=0)
				$width=$this->imgWidth;
			if($height<=0)
				$height=$this->imgHeight;
				
			return $this->_resize($width,$height,$newfile);
		}
		
		/**
		 * Get the image attributes
		 * @access Private
		 * 		
		 */
		function _getImageInfo()
		{
			@list($this->imgWidth,$this->imgHeight,$type,$this->imgAttr)=@getimagesize($this->imgFile);
			$this->imgType=$this->type[$type];
		}
		
		/**
		 * Create the image resource 
		 * @access Private
		 * @return Boolean
		 */
		function _createImage()
		{
			$this->_getImageInfo($this->imgFile);
			$this->_img = $this->_readImageToGD($this->imgFile);

			
			if(!$this->_img || !@is_resource($this->_img))
			{
				$this->_error="Error loading ".$this->imgFile;
				return false;
			}
			return true;
		}
		
		/**
		 * Read file into GD resource
		 * @param $file string Path to file
		 * @return resource|boolean
		 */
		function _readImageToGD($file) {
			@list($width, $height, $type, $attr) = @getimagesize($file);
			$imgType = $this->type[$type];
			
			$resource = null;
			
			if($imgType == 'GIF')
			{
				$resource = @imagecreatefromgif($file);
			}
			elseif($imgType == 'JPG')
			{
				$resource = @imagecreatefromjpeg($file);
			}
			elseif($imgType == 'PNG')
			{
				$resource = @imagecreatefrompng($file);
				
			}
			
			if(!$resource || !@is_resource($resource))
			{
				$this->_error="Error loading ".$file;
				return false;
			}
			
			return $resource;
		}
		
		/**
		 * Function is used to resize the image
		 * 
		 * @access Private
		 * @param Number $width
		 * @param Number $height
		 * @param String $newfile
		 * @return Boolean
		 */
		function _resize($width,$height,$newfile=NULL)
		{
			if (!function_exists("imagecreate"))
			{
				$this->_error="Error: GD Library is not available.";
				return false;
			}

			
			if ($this->imgType=='GIF' && $this->chunkGifs) {
				return $this->_resizeAnimatedGif($width, $height, $newfile);
			}
			
			$newimg = @imagecreatetruecolor($width,$height);

			if ($this->imgType=='PNG')
			{
				imagealphablending($newimg, false);
        		$color = imagecolortransparent($newimg, imagecolorallocatealpha($newimg, 0, 0, 0, 127));
        		imagefill($newimg, 0, 0, $color);
        		imagesavealpha($newimg, true);
			}
			
			@imagecopyresampled ( $newimg, $this->_img, 0,0,0,0, $width, $height, $this->imgWidth, $this->imgHeight);
			
			// take care about border :)
			if (is_resource($this->_border)) {
				@imagecopyresampled ( $newimg, $this->_border, 0,0,0,0, $width, $height, imagesx($this->_border), imagesy($this->_border));
			}
			
			$this->_storeFile($newimg, $newfile);

			
			@imagedestroy($newimg);
		}
		
		/**
		 * Resize the animated gif's by splitting it to frames, and resizing each frame.
		 * @param $width
		 * @param $height
		 * @param $newfile
		 * @return array
		 */
		function _resizeAnimatedGif($width, $height, $newfile = NULL) {
			// jimport('joomla.filesystem.file');
			
			$libDir = JPATH_ROOT.DS.'media'.DS.'mightyextensions'.DS.'libraries'.DS.'image_processing';
			
			require_once $libDir.DS.'GIFDecoder.class.php';
			require_once $libDir.DS.'GIFEncoder.class.php';
			
			// Create gif decoder.
			// $gifDecoder = new GIFDecoder(JFile::read($this->imgFile));
			$gifDecoder = new GIFDecoder(file_get_contents($this->imgFile));
			
			// Write the frames to disk.
			$files = array();
			
			foreach ($gifDecoder->GIFGetFrames( ) as $k => $frame) {
				// store the current frame to disk.
				// $filename = JPath::clean($this->tempDir.DS.uniqid('resize_', true));
				
				$img	= imagecreatefromstring($frame);
				$newimg = @imagecreatetruecolor($width,$height);
				if ($this->transparentGif)
				{
					$colorcount = imagecolorstotal($img);
					if ($colorcount == 0) 
						$colorcount = 256;
					imagetruecolortopalette($newimg, true, $colorcount);
					imagepalettecopy($newimg, $img);
					$transparentcolor = imagecolortransparent($img);
					imagefill($newimg, 0, 0, $transparentcolor);
					imagecolortransparent($newimg, $transparentcolor);
				}
				 
				@imagecopyresampled($newimg, $img, 0, 0, 0, 0, $width, $height, $this->imgWidth, $this->imgHeight);
				
				// take care about border :)
				if (is_resource($this->_border)) {
					@imagecopyresampled ( $newimg, $this->_border, 0,0,0,0, $width, $height, imagesx($this->_border), imagesy($this->_border));
				}

				ob_start();
				imagegif($newimg);
				$files [] = ob_get_clean();
				
				// free some memory
				@imagedestroy($newimg);
				@imagedestroy($img);
				
				unset($frame);
				unset($gifDecoder->GIF_arrays[ $k ]);
			}
			
			// Create encoder
			$gifEncoder = new GIFEncoder(
				$files, 
				$gifDecoder->GIFGetDelays(), 
				$gifDecoder->GIFGetLoop(), 
				$gifDecoder->GIFGetDisposal(), 
				$gifDecoder->GIFGetTransparentR(), 
				$gifDecoder->GIFGetTransparentG(), 
				$gifDecoder->GIFGetTransparentB(),
				'bin'// 'url'
			);
			
			unset($gifDecoder);
			
			foreach ($files as $f) {
				@unlink($f);
			}
			
			if (!empty($newfile)) {
				//JFile::write($newfile, $gifEncoder->getAnimation());
				file_put_contents($newfile, $gifEncoder->getAnimation());
			}
			else {
				@header("Content-type: image/gif");
				echo $gifEncoder->getAnimation();
			}
		}
		
		/**
		 * 
		 * @param $newimg GD resource
		 * @param $newfile string filename
		 * @return unknown_type
		 */
		function _storeFile($newimg, $newfile) {
			//jimport ('joomla.filesystem.file');
			
			//$newfile = JPath::check($newfile);
			
			if($this->imgType=='GIF')
			{
				if(!empty($newfile))
					@imagegif($newimg,$newfile);
				else
				{
					@header("Content-type: image/gif");
					@imagegif($newimg);
				}
			}
			elseif($this->imgType=='JPG')
			{
				if(!empty($newfile))
					@imagejpeg($newimg,$newfile);
				else
				{
					@header("Content-type: image/jpeg");
					@imagejpeg($newimg);
				}
			}
			elseif($this->imgType=='PNG')
			{
				if(!empty($newfile))
					@imagepng($newimg,$newfile);
				else
				{
					@header("Content-type: image/png");
					@imagepng($newimg);
				}
			}
		}
	}