<?php
/**
 * $Id: api.php 7311 2011-08-19 11:18:02Z shitz $
 * $LastChangedDate: 2011-08-19 17:18:02 +0600 (Fri, 19 Aug 2011) $
 * $LastChangedBy: shitz $
 * MightyRegistration by Mighty Extensions
 * a component for Joomla! 1.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mightyextensions.com/
 * @copyright Copyright (C) 2006 - 2011 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/

defined('_JEXEC') or die('Restricted access');
require_once(JPATH_ROOT.DS.'components'.DS.'com_juser'.DS.'includes'.DS.'helper.php');
class JSUserApi
{
	/**
	 * This function returns a value of a given field or a collection of
	 * fields
	 *	$field_id can be either an integer or an array.
	 * 	returns array of values with a field ID as an indexes
	 * @param int $uid
	 * @param mixed $field_id
	 */
	function getFieldValue($uid, $field_id = array(), $all_fields = array())
	{

		$result = array();
		if ($uid < 1){return $result;}
		if (!is_array($field_id))
		{
			$field_id = array((int)$field_id);
		}
		if(is_array($field_id))
		{
			if (count($field_id) > 0)
			{
				$db = &JFactory::getDBO();
				$sql = "SELECT jef.id,jef.title,jef.type, jed.fvalue AS fvalue, jef.params, cc.title as category FROM #__juser_extended_data AS jed"
				//."\n LEFT JOIN #__juser_extended_data AS jed ON jed.user_id = u.id "
				."\n INNER JOIN #__juser_extended_fields AS jef ON jef.id = jed.field_id "
				."\n INNER JOIN #__categories AS cc ON jef.catid = cc.id "
				."\n WHERE 1 AND jef.published = 1 AND jef.id IN (".implode(" , ", $field_id).") AND jed.user_id = ".(int)$uid
				."\n ORDER BY cc.ordering, jef.ordering";

				$db->setQuery($sql);
				$dbresult = $db->loadObjectList();
				foreach ($dbresult as $fld)
				{
					$field_params = new JParameter($fld->params);
					$result[$fld->id]['title'] = $fld->title;
					$result[$fld->id]['category'] = $fld->category;
					if ($fld->type != 'javascript' && $field_params->get('allow_raw', 0) == 0)
					{
						$result[$fld->id]['value'] =JSUserFrontHelper::renderFieldForPrint($uid, $fld);
					}
					else
					{
						$result[$fld->id]['value'] = JSUserFrontHelper::renderFieldForPrint($uid, $fld, true);
					}
				}
				$preseved_res = $result;
				reset($preseved_res);
				$cnt = 0;
				foreach ($all_fields as $key=>$one_field){
					$current = key($preseved_res);
					if ($one_field->type == 'separator'){
						//$sep['title'] = $one_field->title;
						$sep['category'] = $one_field->cat_title;
						$sep['value'] = JSUserFrontHelper::renderFieldForPrint($uid, $one_field, true);
						array_splice($result, $cnt, 0, 'sep');
						$result[$cnt] = $sep;
					}
					if ($current){
						if($current == $one_field->id){
							$cnt++;
							next($preseved_res);
						}
					}
					else{
						$cnt = count($result);
					}
				}
			}

		}
		return $result;

	}

	function getAvatarPath($uid)
	{
		$user = &JFactory::getUser($uid);
		if ($user->get("id")< 1)
		{
			return false;
		}

		$username = $user->get('username');
		jimport('joomla.filesystem.file');

		$ini = JFile::read(JPATH_ADMINISTRATOR.DS.'components'.DS.'com_juser'.DS.'config.ini');
		$params = new JParameter($ini);
		$path = $params->get('general::avatars_dir');
		$path = $path.'/'.strtolower($username).'.jpg';

		if (JFile::exists(JPATH_ROOT.DS.$path))
		{
			return JURI::root().$path;
		}
		else
		{
			return JURI::root().'components/com_juser/images/default_avatar.png';

		}
	}

}
?>