<?php
/**
 * $Id: user.php 7311 2011-08-19 11:18:02Z shitz $
 * $LastChangedDate: 2011-08-19 17:18:02 +0600 (Fri, 19 Aug 2011) $
 * $LastChangedBy: shitz $
 * MightyRegistration by Mighty Extensions
 * a component for Joomla! 1.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mightyextensions.com/
 * @copyright Copyright (C) 2006 - 2011 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/

defined('_JEXEC') or die('Restricted access');
jimport('joomla.application.component.controller');
include_once JPATH_COMPONENT.'/includes/helper.php';
class JUserControllerUser extends JUserController
{
	function __construct()
	{
		parent::__construct();
		$this->registerTask('renderCaptcha', 'renderCaptcha');
		$this->registerTask('register_save', 'register_save');
		$this->registerTask('remove', 'removeAccount');
		defined('JU_GENERAL_EMAIL_ACTIVATION') or define('JU_GENERAL_EMAIL_ACTIVATION' , 1);
	}

	function display() {
		global $mainframe;
		$user	 =& JFactory::getUser();

		if(JRequest::getVar('view', '') == "register"){
			$usersConfig = &JComponentHelper::getParams( 'com_users' );
			if (!$usersConfig->get( 'allowUserRegistration' )) {
				JError::raiseError( 403, JText::_( 'Access Forbidden' ));
				return;
			}

			JRequest::setVar('layout', 'register');
		}
		parent::display();
	}
	function user_update()
	{
		global $mainframe;
		JRequest::checkToken() or jexit( 'Invalid Token' );

		$user	 =& JFactory::getUser();
		$userid = JRequest::getVar( 'id', 0, 'post', 'int' );

		// preform security checks
		if ($user->get('id') == 0 || $userid == 0 || $userid <> $user->get('id')) {
			JError::raiseError( 403, JText::_('Access Forbidden') );
			return;
		}

		$isCoreFieldValid          = true;
		$isExtendedFieldValid      = true;
		$isRegistrationPolicyValid = true;

		$save_error = false;

		$model = $this->getModel('user');

		$model->_id = $userid;

		$user_data  = & $model->getData();

		$post = JRequest::get( 'post' );
		$post['username']	  = JRequest::getVar('username', '', 'post', 'username');
		$post['password']	  = JRequest::getVar('password', '', 'post', 'string', JREQUEST_ALLOWRAW);
		$post['password2']	= JRequest::getVar('password2', '', 'post', 'string', JREQUEST_ALLOWRAW);

		$post['name'] = @$post['first_name']."\n".@$post['last_name'];

		if(JU_REGISTRATION_FORM_EMAIL_AS_NAME)
		{
			$post['name'] = $post['email'];
			$post['first_name'] = $post['email'];
			$post['last_name'] = $post['email'];
		}
		if(JU_REGISTRATION_FORM_EMAIL_AS_LOGIN)
		{
			$post['username'] = $post['email'];
		}
		$user_ext_data = JUFrame::getUserPostData($post);
		if( !JUFrame::validateCoreFields( $user_data->core_data, $post )){
			$isCoreFieldValid          = false;
		}

		if( !JUFrame::validateExtendedField( $user_ext_data, $user_data->extended_data, $userid )){
			$isExtendedFieldValid      = false;
		}


		if( !$isCoreFieldValid || !$isExtendedFieldValid){
			JError::raiseWarning('', JText::_('Some fields filled incorrect') );
		}
		if( !$isCoreFieldValid || !$isExtendedFieldValid || !$isRegistrationPolicyValid){
			$this->myDetails( $user_data, 1 );
			return false;
		}

		if ($model->storeCoreData($post)) {
			$msg	= JText::_( 'Your settings have been saved.' );

			JUFrame::putFiles($user_ext_data, $userid,$post);

			if(!$model->saveExtendedData($user_ext_data)){
				$msg	= JText::_('Error extended field data not saved');
				$save_error = true;
			}
			else
			{
				JPluginHelper::importPlugin('user');
				$dispatcher = &JDispatcher::getInstance();
				$dispatcher->trigger('onAfterJUserStore', array($user,  JUFrame::getFieldsForPluginEvent($user_ext_data), false));
			}
		} else {
			$msg	= $model->getError();
			$save_error = true;
		}
		if($save_error){
			JError::raiseError( 403, $msg);
		}
		else
		{
			$mainframe->enqueueMessage( $msg );
			//registering event here
			if (JU_COMMUNITY_EDIT_ACTIVITY && $this->_checkComponent('community_activity')){
				$this->_editActivity($user->id);
			}

		}
		if (JU_GENERAL_EMAIL_ALERTS_ON_EDIT)
		{
			$this->_sendEmails($user, '', 'edit_alert');

		}
		$this->myDetails();
		if(JU_REGISTRATION_FORM_UPDATE_REDIRECT_URL)
		{
			$return = JRequest::getVar('return');
			$returnstring = '';
			if ($return)
			{
				$returnstring = '&return='.$return;
			}
			$db = &JFactory::getDBO();
			$sql = "SELECT * FROM #__menu WHERE `id` = ".JU_REGISTRATION_FORM_UPDATE_REDIRECT_URL;
			$db->setQuery($sql);
			$link = $db->loadObject();
			$url = $link->link.'&Itemid='.$link->id.$returnstring;
			$mainframe->redirect($url);
		}
	}

	function register_save()
	{
		global $mainframe;
		defined('JU_REGISTRATION_FORM_AUTOLOGIN') or define ('JU_REGISTRATION_FORM_AUTOLOGIN', 0);
		defined('JU_GENERAL_USER_REGISTRATION') or define ('JU_GENERAL_USER_REGISTRATION', 1);
		JRequest::checkToken() or jexit( 'Invalid Token' );
		$session    = &JFactory::getSession();
		$user 		  = new JUser();
		$pathway 	  = &$mainframe->getPathway();
		$config		  = &JFactory::getConfig();
		$authorize	= &JFactory::getACL();
		$document   = &JFactory::getDocument();

		$model	    = &$this->getModel('user');

		$post       = JRequest::get('post');
		$usersConfig = &JComponentHelper::getParams( 'com_users' );
		$post['username']	  = JRequest::getVar( 'username',  '', 'post', 'username');
		$post['password']	  = JRequest::getVar( 'password',  '', 'post', 'string', JREQUEST_ALLOWRAW);
		$post['password2']	= JRequest::getVar( 'password2', '', 'post', 'string', JREQUEST_ALLOWRAW);


		if (JU_GENERAL_USER_REGISTRATION == '0') {
			JError::raiseError( 403, JText::_( 'Access Forbidden' ));
			return;
		}
		$post['name'] = @$post['first_name']."\n".@$post['last_name'];

		if(JU_REGISTRATION_FORM_EMAIL_AS_NAME)
		{
			$post['name'] = $post['email'];
			$post['first_name'] = $post['email'];
			$post['last_name'] = $post['email'];
		}
		if(JU_REGISTRATION_FORM_EMAIL_AS_LOGIN)
		{
			$post['username'] = $post['email'];
		}

		$isCoreFieldValid     = true;
		$isExtendedFieldValid = true;
		$isRegistrationPolicyValid = true;

		$newUsertype = $usersConfig->get( 'new_usertype' );
		if (!$newUsertype) {
			$newUsertype = 'Registered';
		}
		$user_ext_data = JUFrame::getUserPostData($post);
		$user_data  = & $model->getData();

		$isRegistrationPolicyValid = JUFrame::validateRegistrationPolicy( );
		$isCoreFieldValid          = JUFrame::validateCoreFields( $user_data->core_data, $post );
		$isExtendedFieldValid      = JUFrame::validateExtendedField( $user_ext_data,$user_data->extended_data);

		if(!$isRegistrationPolicyValid){
			JError::raiseWarning(100, JText::_('You must be agree with registration policy for registration.') );
		}

		if( !$isCoreFieldValid || !$isExtendedFieldValid){
			JError::raiseWarning(101, JText::_('Some fields filled incorrect') );
		}


		$isCaptchaValid = true;
		if (JU_GENERAL_ENABLE_CAPTCHA)
		{
			require_once (JPATH_COMPONENT_SITE.DS.'includes'.DS.'securimage.php');
			$img = new securimage();

			if ($img->check(JRequest::getVar('captcha_text')) == false)
			{
				JError::raiseNotice(100, JText::_('Security spam protection code do not match'));
				$isCaptchaValid = false;
			}
		}
		if( !$isCoreFieldValid || !$isExtendedFieldValid || !$isRegistrationPolicyValid || !$isCaptchaValid){
			$this->register( $user_data, 1 );
			return false;
		}



		if (!$user->bind( $post, 'usertype' )) {
			JError::raiseError( 500, $user->getError());
			$isCoreFieldValid = false;
		}

		$user->set('id', 0);
		$user->set('usertype', $newUsertype );

		$user->set('gid', $authorize->get_group_id( '', $newUsertype, 'ARO' ));

		// TODO: Should this be JDate?
		$user->set('registerDate', date('Y-m-d H:i:s'));
		$user->set('lastvisitDate', '0000-00-00 00:00:00');

		// If user activation is turned on, we need to set the activation information
		$useractivation = JU_GENERAL_USER_ACTIVATION;
		if ($useractivation){
			jimport('joomla.user.helper');
			$user->set('activation', md5( JUserHelper::genRandomPassword()) );
		}
		if ($useractivation == '1' || $useractivation == '3' || $useractivation == '4') //normal, admin and combined (admin and than background)
		{
			$user->set('block', '1');
		}
		else //background and no activation
		{
			$user->set('block', '0');
		}


		//now we save user
		if ( !$user->save() ){
			JError::raiseWarning('', JText::_( $user->getError()));
			$isCoreFieldValid = false;
		}



		$model->_id = $user->id;

		JUFrame::putFiles($user_ext_data, $user->id,$post);

		if(!$model->saveExtendedData($user_ext_data)){
			JError::raiseWarning('', JText::_('Error extended field data not saved') );
			$this->register($user_data, 1);
			return false;
		}
		else
		{
			JPluginHelper::importPlugin('user');
			$dispatcher = &JDispatcher::getInstance();
			$dispatcher->trigger('onAfterJUserStore', array($user,  JUFrame::getFieldsForPluginEvent($user_ext_data), true));
		}
		if (JU_COMMUNITY_JOIN_ACTIVITY && $this->_checkComponent('community_activity')){
				$this->_joinActivity($user->get('id'));
			}

		// Send registration confirmation mail
		$password = JRequest::getString('password', '', 'post', JREQUEST_ALLOWRAW);
		$password = preg_replace('/[\x00-\x1F\x7F]/', '', $password); //Disallow control chars in the email
		$this->_sendEMails($user, $password, 'user');
		$this->_sendEMails($user, $password, 'reg_alert');
		//exit;
		// Everything went fine, set relevant message depending upon user activation state and display message
		$document->setTitle( JText::_( 'REG_COMPLETE_TITLE' ) );
		$pathway->addItem( JText::_( 'REG_COMPLETE_TITLE' ));
		$message->title = JText::_( 'REG_COMPLETE_TITLE' );
		switch ($useractivation){
			case 0://none registration complete message
				$message->text = JText::_( 'REG_COMPLETE' );
				if (JU_COMMUNITY_JOIN_ACTIVITY && $this->_checkComponent('community_activity')){
					$this->_joinActivity($user->get('id'));
				}
			break;
			case 1://normal activation
				$document->setTitle( JText::_( 'REG_COMPLETE_ACTIVATE_TITLE' ) );
				$pathway->addItem( JText::_( 'REG_COMPLETE_ACTIVATE_TITLE' ));
				$message->title = JText::_( 'REG_COMPLETE_ACTIVATE_TITLE' );
				$message->text = JText::_( 'REG_COMPLETE_ACTIVATE' );
			break;
			case 2: //background
				$message->text = JText::_( 'REG_COMPLETE' );
			break;
			case 3: //admin
			case 4: //admin + background
				$message->text = JText::_( 'REG_COMPLETE_ADMIN' );
			break;
		}

		//TODO :: this needs to be replace by raiseMessage
		//JError::raiseNotice('', $message->title);
		//JError::raiseNotice('', $message->text);
		if (JU_REGISTRATION_FORM_AUTOLOGIN && ($useractivation == 0 || $useractivation == 2))//autologin only for not blocked activations!
		{
			$usersipass['username'] = $user->get('username');
			$usersipass['password'] = $password;
			$mainframe->login($usersipass);

			$message->title = JText::_( 'REG_COMPLETE_TITLE' );
			$message->text = JText::_( 'Thanks for registering.' );
		}

		defined('JU_REGISTRATION_FORM_SYSMSG') or define('JU_REGISTRATION_FORM_SYSMSG', 1 );
		if (JU_REGISTRATION_FORM_SYSMSG == 1){
			$mainframe->enqueueMessage( $message->title );
			$mainframe->enqueueMessage( $message->text );
		}

		if(JU_REGISTRATION_FORM_REDIRECT_URL){
			$return = JRequest::getVar('return');
			$returnstring = '';
			if ($return)
			{
				$returnstring = '&return='.$return;
			}
			$db = &JFactory::getDBO();
			$sql = "SELECT * FROM #__menu WHERE `id` = ".JU_REGISTRATION_FORM_REDIRECT_URL;
			$db->setQuery($sql);
			$link = $db->loadObject();
			$url = $link->link.'&Itemid='.$link->id.$returnstring;
			$mainframe->redirect($url);
		}
		$this->setRedirect('index.php');
	}

	function register( $user_data = '', $repeat = '' )
	{
		//$usersConfig = &JComponentHelper::getParams( 'com_users' );
		/*if (!$usersConfig->get( 'allowUserRegistration' )) {
		JError::raiseError( 403, JText::_( 'Access Forbidden' ));
		return;
		}*/

		JRequest::setVar( 'user_data', $user_data );
		JRequest::setVar('view', 'user');
		JRequest::setVar('layout', 'register');
		JRequest::setVar( 'repeat',    $repeat );

		parent::display();
	}

	function myDetails( $user_data = '' , $repeat = '')
	{

		JRequest::setVar( 'user_data', $user_data );
		JRequest::setVar( 'view',      'user' );
		JRequest::setVar( 'layout',    'mydetails' );
		JRequest::setVar( 'repeat',    $repeat );
		JRequest::setVar('Itemid', JRequest::getVar('Itemid'));
		parent::display();
	}

	/*function _sendMail(&$user, $password)
	 {
		global $mainframe;

		$db =& JFactory::getDBO();

		$name     = $user->get('name');
		$string = strtok($name,"\n");
		$name ='';
		while ($string) {
		$name .= ' '.$string;
		$string = strtok("\n");
		}
		$email    = $user->get('email');
		$username = $user->get('username');


		$sitename       = $mainframe->getCfg( 'sitename' );
		$useractivation = JU_GENERAL_EMAIL_ACTIVATION;
		$mailfrom       = $mainframe->getCfg( 'mailfrom' );
		$fromname       = $mainframe->getCfg( 'fromname' );
		$siteURL        = JURI::base();



		$subject 	=  JText::_( 'Successfully registered' );
		$subject 	= html_entity_decode($subject, ENT_QUOTES);
		defined('JU_GENERAL_ITEMID') or define('JU_GENERAL_ITEMID', 0 );
		// Preparing the message to send
		//======================================================================
		if ( $useractivation == 1 ){
		$message = JText::_( 'SEND_MSG_ACTIVATE' );
		$message = str_replace(array('[name]', '[NAME]'), $name, $message);
		$message = str_replace(array('[sitename]', '[SITENAME]'), $sitename, $message);
		$message = str_replace(array('[activation]', '[ACTIVATION]'), $siteURL."index.php?option=com_juser&controller=user&task=activate&activation=".$user->get('activation').'&Itemid='.JU_GENERAL_ITEMID, $message);
		$message = str_replace(array('[username]', '[USERNAME]'),$username , $message);
		$message = str_replace(array('[password]', '[PASSWORD]'),$password , $message);
		$message = str_replace(array('[siteurl]', '[SITEURL]'),$siteURL , $message);
		//$message = sprintf ( JText::_( 'SEND_MSG_ACTIVATE' ), $name, $sitename, $siteURL."index.php?option=com_user&task=activate&activation=".$user->get('activation').'&Itemid='.JU_GENERAL_ITEMID, $siteURL, $username, $password);
		} else {
		$message = JText::_( 'SEND_MSG' );
		$message = str_replace(array('[name]', '[NAME]'), $name, $message);
		$message = str_replace(array('[sitename]', '[SITENAME]'), $sitename, $message);
		//$message = str_replace(array('[activation], [ACTIVATION]'), $siteURL."index.php?option=com_user&task=activate&activation=".$user->get('activation').'&Itemid='.JU_GENERAL_ITEMID, $message);
		$message = str_replace(array('[username]', '[USERNAME]'),$username , $message);
		$message = str_replace(array('[password]', '[PASSWORD]'),$password , $message);
		$message = str_replace(array('[siteurl]', '[SITEURL]'),$siteURL , $message);
		//$message = sprintf ( JText::_( 'SEND_MSG' ), $name, $sitename, $siteURL, $username, $password);
		}

		if(JU_REGISTRATION_FORM_ADMIN_ACTIV){
		$message = JText::_( 'SEND_MSG_NOT_ACTIVATE' );
		$message = str_replace(array('[name]', '[NAME]'), $name, $message);
		$message = str_replace(array('[sitename]', '[SITENAME]'), $sitename, $message);
		$message = str_replace(array('[username]', '[USERNAME]'),$username , $message);
		$message = str_replace(array('[password]', '[PASSWORD]'),$password , $message);
		$message = str_replace(array('[siteurl]', '[SITEURL]'),$siteURL , $message);

		}
		//======================================================================
		$message = html_entity_decode($message, ENT_QUOTES);

		//get all super administrator
		$query = 'SELECT id, name, email, sendEmail' .
		' FROM #__users' .
		' WHERE LOWER( usertype ) = "super administrator"' .
		' LIMIT 0, 1';
		$db->setQuery( $query );
		$rows = $db->loadObjectList();

		// Send email to user
		if ($mailfrom == "" && $fromname == "") {
		$fromname = $rows[0]->name;
		$mailfrom = $rows[0]->email;
		}
		//print " FROM  ".$mailfrom."FROM NAME".$fromname."EMAIL<b> $email</b>"." SUBJECT".$subject."<br>".$message ;
		JUtility::sendMail($mailfrom, $fromname, $email, $subject, $message, $this->isHtmlMessage($message));

		$model              = &$this->getModel('user');
		$model->_id         = $user->id;
		$user_data          = &$model->getData();
		$user_extended_data = & $user_data->extended_data;

		$extended_fields = array();

		foreach( $user_extended_data as $field ){

		if( !$field->published){ continue; }
		$extended_fields[] =  $field->title.' : '.str_replace(array("\n","\r"), array(' ', ''), $field->fvalue);
		}
		$extended_fields = implode("\n", $extended_fields);
		if(JU_REGISTRATION_FORM_ADMIN_ACTIV){
		$message3 = JText::_( 'SEND_MSG_ADMIN_FOR_ACTIVATE' );
		$message3 = str_replace(array('[name]', '[NAME]'), $name, $message3);
		$message3 = str_replace(array('[sitename]', '[SITENAME]'), $sitename, $message3);
		$message3 = str_replace(array('[username]', '[USERNAME]'),$username , $message3);
		$message3 = str_replace(array('[siteurl]', '[SITEURL]'),$siteURL , $message3);
		$message3 = str_replace(array('[EMAIL]', '[EMAIL]'),$email , $message3);
		$message3 = str_replace(array('[ADDITIONAL]', '[additional]'),$extended_fields , $message3);
		$subject3 = sprintf ( JText::_( 'Account details for activate %s at %s' ), $name, $sitename);
		//$message3 = sprintf ( JText::_( 'SEND_MSG_ADMIN_FOR_ACTIVATE' ), $sitename, str_replace("\n"," ", str_replace("\r", '', $name)), $email, $username, $extended_fields);
		$subject3 = html_entity_decode($subject3, ENT_QUOTES);
		$message3 = html_entity_decode($message3, ENT_QUOTES);
		JUtility::sendMail($mailfrom, $fromname, $mailfrom, $subject3, $message3, $this->isHtmlMessage($message3));
		}
		// Send notification to all administrators
		$subject2 = sprintf ( JText::_( 'Account details for %s at %s' ), $name, $sitename);
		$message2 = JText::_( 'SEND_MSG_ADMIN' );
		$message2 = str_replace(array('[name]', '[NAME]'), $name, $message2);
		$message2 = str_replace(array('[sitename]', '[SITENAME]'), $sitename, $message2);
		$message2 = str_replace(array('[username]', '[USERNAME]'),$username , $message2);
		$message2 = str_replace(array('[siteurl]', '[SITEURL]'),$siteURL , $message2);
		$message2 = str_replace(array('[EMAIL]', '[EMAIL]'),$email , $message2);
		$message2 = str_replace(array('[ADDITIONAL]', '[additional]'),$extended_fields , $message2);
		$subject2 = html_entity_decode($subject2, ENT_QUOTES);
		$message2 = html_entity_decode($message2, ENT_QUOTES);
		defined('JU_GENERAL_REGISTRATION_ALERT_EMAILS') or define('JU_GENERAL_REGISTRATION_ALERT_EMAILS','');
		$registration_alert_emails = explode(',', str_replace(array("\n", "\r", ' '), ',', JU_GENERAL_EMAIL_ALERTS));




		foreach ( $registration_alert_emails as $alert_email ){
		if (trim($alert_email)==''){continue;}

		JUtility::sendMail($mailfrom, $fromname, trim($alert_email), $subject2, $message2, $this->isHtmlMessage($message2));
		}
		}
		*/

	function _sendEmails($user, $password = null, $mode = 'user')
	{
		global $mainframe;

		$db =& JFactory::getDBO();
		$name     = $user->get('name');
		$string = strtok($name,"\n");
		$name ='';
		while ($string) {
			$name .= ' '.$string;
			$string = strtok("\n");
		}
		$email    = $user->get('email');
		$username = $user->get('username');

		$sitename       = $mainframe->getCfg( 'sitename' );
		$useractivation = JU_GENERAL_USER_ACTIVATION;
		$mailfrom       = $mainframe->getCfg( 'mailfrom' );
		$fromname       = $mainframe->getCfg( 'fromname' );
		$siteURL        = JURI::base();

		$model              = &$this->getModel('user');
		$model->_id         = $user->id;
		$user_data          = &$model->getData();
		$user_extended_data = & $user_data->extended_data;

		$extended_fields = array();

		if ($mailfrom == "" && $fromname == "") {
			//get all super administrator
			$query = 'SELECT id, name, email, sendEmail' .
						' FROM #__users' .
						' WHERE LOWER( usertype ) = "super administrator"' .
						' LIMIT 0, 1';
			$db->setQuery( $query );
			$rows = $db->loadObjectList();
			// Fisrt super admin
			$fromname = $rows[0]->name;
			$mailfrom = $rows[0]->email;
		}

		foreach( $user_extended_data as $field ){

			if( !$field->published || trim($field->fvalue == '')){ continue; }
			$extended_fields[] =  $field->title.": ".JSUserFrontHelper::renderFieldForPrint($user->id, $field);
			//$field->title.' : '.str_replace(array("\n","\r"), array(' ', ''), $field->fvalue);
		}
		$extended_fields = implode('<br />', $extended_fields);
		$user->get('activation')? $activation = $siteURL."index.php?option=com_juser&controller=user&task=activate&activation=".$user->get('activation'): null;

		$replace = array('[NAME]', '[SITENAME]', '[USERNAME]', '[SITEURL]', '[EMAIL]', '[ADDITIONAL]');
		$replace_values = array($name, $sitename, $username, $siteURL, $email, $extended_fields,);
		//defined('JU_GENERAL_ITEMID') or define('JU_GENERAL_ITEMID', 0 );
		switch($mode)
		{
			case 'user':
				$subject 	=  JText::_( 'Successfully registered' );
				
				switch ($useractivation){
					case 1: //normal
						$message_lang = JText::_( 'SEND_MSG_ACTIVATE' );
						$message = str_replace(array('[PASSWORD]','[ACTIVATION]') , array($password,$activation) , $message_lang);
						//$message = sprintf ( JText::_( 'SEND_MSG_ACTIVATE' ), $name, $sitename, $siteURL."index.php?option=com_user&task=activate&activation=".$user->get('activation').'&Itemid='.JU_GENERAL_ITEMID, $siteURL, $username, $password);
					break;
					case 2://background
						$message_lang = JText::_( 'SEND_MSG_CONFIRM' );
						$message = str_replace(array('[PASSWORD]','[ACTIVATION]') , array($password,$activation) , $message_lang);
					break;
					case 3: //admin
					case 4: //admin plus background
						if ($password){//got this meant save user
							$message_lang = JText::_( 'SEND_MSG_NOT_ACTIVATE' );
							$message = str_replace('[PASSWORD]', $password , $message_lang);

							//say admin he should to activate user
							$message2_lang = str_replace('[ACTIVATION]', $activation, JText::_( 'SEND_MSG_ADMIN_FOR_ACTIVATE' ));
							$subject2 = sprintf ( JText::_( 'Account details for activate %s at %s' ), $name, $sitename);
						}
						else{//other way send confirm email message
							$subject = JText::_('SEND_MSG_ACTIVATED_BY_ADMIN');
							if ($useractivation == 3){
								$message = JText::_( 'SEND_MSG_CONFIRM_ADMIN' );
							}
							else{
								$message_lang = JText::_( 'SEND_MSG_CONFIRM_AFTER_ADMIN' );
								$message = str_replace('[ACTIVATION]', $activation, $message_lang);
							}
						}
					break;
				}
				
			break;
			case 'reg_alert':
				$subject2 = sprintf ( JText::_( 'Account details for %s at %s' ), $name, $sitename);
				$message2_lang = JText::_( 'SEND_MSG_ADMIN' );
			break;
			case 'edit_alert':
				$subject2 = sprintf ( JText::_( 'User %s edited profile at %s' ), $name, $sitename);
				$message2_lang = JText::_( 'SEND_MSG_ADMIN_EDIT_ALERT' );
			break;
			case 'remove':
				$subject2 = sprintf ( JText::_( 'User %s has removed his/her account at %s' ), $name, $sitename);
				$message2_lang = JText::_( 'SEND_MSG_ADMIN_REMOVE_ALERT' );
			break;
		}

		if($message && $subject){ //send to ordinary user
			$message = str_replace($replace, $replace_values, $message);
			if($this->isHtmlMessage($message_lang)){
				$message = nl2br($message);
			}
			else{
				//@todo think over implementations to other HTML code wich may be passed with extended fields
				$message = str_replace(array('<br>','<br/>','</br>','<br />','</ br>'), "\n", $message);
			}
			$message = html_entity_decode($message, ENT_QUOTES);
			$subject 	= html_entity_decode($subject, ENT_QUOTES);
			JUtility::sendMail($mailfrom, $fromname, $email, $subject, $message, $this->isHtmlMessage($message));
		}
		//send notes to superadmins
		if($message2_lang && $subject2){
            $message2 = str_replace($replace, $replace_values, $message2_lang);
            if($this->isHtmlMessage($message2_lang)){
                $message2 = nl2br($message2);
            }
            else{
                //@todo think over implementations to other HTML code wich may be passed with extended fields
                $message2 = str_replace(array('<br>','<br/>','</br>','<br />','</ br>'), "\n", $message2);
            }

            $subject2 = html_entity_decode($subject2, ENT_QUOTES);
            $message2 = html_entity_decode($message2, ENT_QUOTES);
            defined('JU_GENERAL_REGISTRATION_ALERT_EMAILS') or define('JU_GENERAL_REGISTRATION_ALERT_EMAILS','');
            $registration_alert_emails = explode(',', str_replace(array("\n", "\r", ' '), ',', JU_GENERAL_EMAIL_ALERTS));
            if($registration_alert_emails)
            {
                foreach ( $registration_alert_emails as $alert_email )
                {
                    if (trim($alert_email)=='')
                    {
                        continue;
                    }
                    JUtility::sendMail($mailfrom, $fromname, trim($alert_email), $subject2, $message2, $this->isHtmlMessage($message2));
                }
            }
            else
            {
                JUtility::sendMail($mailfrom, $fromname, $mailfrom, $subject2, $message2, $this->isHtmlMessage($message2));
            }
        }
	}

	/*function activate($activation)
	 {
		global $mainframe;

		// Initialize some variables
		$db					=& JFactory::getDBO();
		$user 			=& JFactory::getUser();
		$document   =& JFactory::getDocument();

		$usersConfig = &JComponentHelper::getParams( 'com_users' );
		$userActivation			= $usersConfig->get('useractivation');
		$allowUserRegistration	= $usersConfig->get('allowUserRegistration');
		jimport('joomla.user.helper');

		// Check to see if they're logged in, because they don't need activating!
		if ($user->get('id')) {
		// They're already logged in, so redirect them to the home page
		$mainframe->redirect( 'index.php' );
		}

		$activation = $db->getEscaped( $activation );

		// Lets activate this user
		jimport('joomla.user.helper');
		if (JUserHelper::activateUser($activation))
		{
		return true;
		}
		else
		{
		return false;
		}

		}*/
	function activate()
	{
		//@todo too much IF hard to read!

		// Do we even have an activation string?

		global $mainframe;
		// Initialize some variables
		$db			=& JFactory::getDBO();
		$activation = $db->getEscaped(JRequest::getVar('activation', '', '', 'alnum' ));
		if (empty( $activation ) || $activation == '1'){
			// do nothing if no activation or already passed
			JError::raiseWarning( "500", JText::_('REG_ACTIVATE_NOT_VALID'));
			$mainframe->redirect( 'index.php' );
			return;
		}

		$me 		=& JFactory::getUser();
		$document   =& JFactory::getDocument();
		$pathway 	=& $mainframe->getPathWay();
		defined('JU_REGISTRATION_FORM_ACTIVATION_REDIRECT_URL') or define('JU_REGISTRATION_FORM_ACTIVATION_REDIRECT_URL', '');

		$useractivation	= JU_GENERAL_USER_ACTIVATION;
		$allowUserRegistration	= JU_GENERAL_USER_REGISTRATION;
		$silent_act = array(2, 4);
		$admins_gid = array(24, 25); //little bit hack, could we relay on this?


//		$path_er = null; //initially we allow to confirm to everyone But gone to check next @ todo
		//complicated secure checks
		//Check logged in users and skip unless email confirmation is used
//		if (!in_array($me->get('gid'), $admins_gid)){ //if you are admin or super, always welcome! skip secure check
//			($me->get('id') && !in_array($useractivation, $silent_act))? $path_er = 'ALRDY_LOGGED_IN':null; //allow confrm for logged in if only silent email confirmation
//		}

		if (!($allowUserRegistration && $useractivation)){
			//no registration no access, sorry
			JError::raiseWarning( 403, JText::_('NO_REG_OR_ACT'));
			$mainframe->redirect( 'index.php' );
			return;
		}

		$message = new stdClass();

		//get user id from activation link
		$query = 'SELECT id'.
		' FROM #__users'.
		' WHERE activation = '.$db->Quote($activation);

		$db->setQuery( $query );
		$user_id = $db->loadResult();
		//var_dump($user_id);die;
		if (!$user_id) return JError::raiseNotice( 500, JText::_('REG_ACTIVATE_NOT_FOUND'));
		$user = JFactory::getUser($user_id);
		if($user->activation == '1' || !$user->activation) return;//stupid double check

		switch ($useractivation){
			case 1: //normal
				if ($user->block == '1' && ($user->lastvisitDate == '0000-00-00 00:00:00' || $user->lastvisitDate == '')):
					$user->set('activation', '1');
					$user->set('block', '0');
					if ($user->save()){
						JUserModelUser::activateSucess(false);
						//$this->_sendEmails($user);//it just send email to user about he/she confirmed email
						if (JU_COMMUNITY_JOIN_ACTIVITY && $this->_checkComponent('community_activity')){
							$this->_joinActivity($user->get('id'));
						}
					}
					else{
						JError::raiseWarning( "SOME_ERROR_CODE", $user->getError() );
						return false;
					}
				else:
					JUserModelUser::activateNotFound(false);
				endif;
			break;
			case 2: //background
				if ($user->block == 0){
					$user->set('activation', '1');
					if ($user->save()){
						JUserModelUser::activateSucess(false, 'MAIL_CONFIRM');
					}
					else{
						JError::raiseWarning( "SOME_ERROR_CODE", $user->getError() );
						return false;
					}
				}
			break;
			case 3: //by admin
			case 4: //combinated andmin and than background
				if($user->block == '1'){ //this user not activated yet? probably this is not secure check.
					if (!in_array($me->gid, $admins_gid)){// if activation by only admin check logged in user
						JError::raiseWarning( 403, JText::_('REG_ACTIVATE_HAVE_TO_BE_ADMIN'));
						$mainframe->redirect( 'index.php' );
						return;
					}
					jimport('joomla.user.helper');
					$user->set('activation', md5( JUserHelper::genRandomPassword())); //activation by admin not meant email confirmation so regenerate string and send letter to user if need it
					$user->set('block', '0');
					//save changes
					if ($user->save()){
						JUserModelUser::activateSucess(false);
						if (JU_COMMUNITY_JOIN_ACTIVITY && $this->_checkComponent('community_activity')){
							$this->_joinActivity($user->get('id'));
						}
						$this->_sendEmails($user);//it just send email to user about he/she was activated
					}
					else{
						JError::raiseWarning( "SOME_ERROR_CODE", $user->getError() );
						return false;
					}
				}
				else if($user->block == '0' && $useractivation == 4){ //so it is user already activated by admin and not blocked, need to send email about confirm it, in case useractivation required this
					$user->set('activation', '1');
					//save changes
					if ($user->save()){
						JUserModelUser::activateSucess(false, 'MAIL_CONFIRM');
					}
					else{
						JError::raiseWarning( "SOME_ERROR_CODE", $user->getError() );
						return false;
					}
				}
			break;

		}

		if (JU_REGISTRATION_FORM_ACTIVATION_REDIRECT_URL)
		{
			$db = &JFactory::getDBO();
			$sql = "SELECT * FROM #__menu WHERE `id` = ".JU_REGISTRATION_FORM_ACTIVATION_REDIRECT_URL;
			$db->setQuery($sql);
			$link = $db->loadObject();
			$url = $link->link.'&Itemid='.$link->id;
			$mainframe->redirect(JRoute::_($url, false));
		}
		else{
			$this->setRedirect('index.php');
		}
	}
	function login()
	{
		// Check for request forgeries
		JRequest::checkToken('request') or jexit( 'Invalid Token' );

		global $mainframe;

		if ($return = JRequest::getVar('return', '', 'method', 'base64')) {
			$return = base64_decode($return);
			if (strpos( $return, 'http' ) !== false && strpos( $return, JURI::base() ) !== 0) {
				$return = '';
			}
		}

		$options = array();
		$options['remember'] = JRequest::getBool('remember', false);
		$options['return'] = $return;

		$credentials = array();
		$credentials['username'] = JRequest::getVar('username', '', 'method', 'username');
		$credentials['password'] = JRequest::getString('passwd', '', 'post', JREQUEST_ALLOWRAW);

		//preform the login action
		$error = $mainframe->login($credentials, $options);

		if(!JError::isError($error))
		{
			// Redirect if the return url is not registration or login
			if ( ! $return ) {
				$return	= 'index.php';
			}

			$mainframe->redirect( $return );
		}
		else
		{
			// Facilitate third party login forms
			//$return	= 'index.php?option=com_juser&view=user&layout=login&Itemid='.JRequest::getInt('Itemid');
			$mainframe->redirect( $return );
			// Redirect to a login form
			$mainframe->redirect( $return );
		}
	}

	function logout()
	{
		global $mainframe;

		//preform the logout action
		$error = $mainframe->logout();

		if(!JError::isError($error))
		{
			if ($return = JRequest::getVar('return', '', 'method', 'base64')) {
				$return = base64_decode($return);
				if (strpos( $return, 'http' ) !== false && strpos( $return, JURI::base() ) !== 0) {
					$return = '';
				}
			}

			// Redirect if the return url is not registration or login
			if ( $return && !( strpos( $return, 'com_juser' )) )
			{
				$mainframe->redirect( $return );
			}
		}
		else
		{
			$mainframe->redirect('index.php');
		}
	}


	function renderCaptcha()
	{
		$text = md5(microtime());
		$text = substr($text, 0, 6);
		$text = preg_replace("/0|o/Ui", "b", $text);
		$session = &JFactory::getSession();
		//header('Content-type: image/jpeg');
		$session->set('jsUserCaptcha',$text);
		include_once(JPATH_COMPONENT_ADMINISTRATOR.DS.'includes'.DS.'jpgraph'.DS.'jpgraph.php');
		include_once(JPATH_COMPONENT_ADMINISTRATOR.DS.'includes'.DS.'jpgraph'.DS.'jpgraph_antispam.php');

		$antispam = new AntiSpam($text);
		header('Content-type: image/jpeg');
		$antispam->Stroke();
		exit;
	}

	function removeAccount()
	{
		defined('JU_GENERAL_ACCOUNT_REMOVAL') or define('JU_GENERAL_ACCOUNT_REMOVAL', 0);
		$user = &JFactory::getUser();
		if (!JU_GENERAL_ACCOUNT_REMOVAL || $user->get('id') < 1)
		{
			JError::raiseError(403, JText::_('Access Forbidden!'));
			return;
		}

		jimport( 'joomla.user.authentication');
		if($user->get('gid') == 25)
		{
			JError::raiseNotice(403, JText::_('Super Administrators never die!'));
			return;

		}
		if ($return = JRequest::getVar('return', '', 'method', 'base64')) {
			$return = base64_decode($return);
			if (!JURI::isInternal($return)) {
				$return = '';
			}
		}
		$options = array();
		$options['remember'] = false;
		$options['return'] = $return;

		$credentials = array();
		$credentials['username'] = $user->get("username");
		$credentials['password'] = JRequest::getString('password', '', 'post', JREQUEST_ALLOWRAW);

		$authenticate = & JAuthentication::getInstance();
		$response	  = $authenticate->authenticate($credentials, $options);

		if ($response->status === JAUTHENTICATE_STATUS_SUCCESS)
		{
			$user->delete();
			$user_id = $user->get('id');
			$db = &JFactory::getDBO();
			$sql = "DELETE FROM #__juser_extended_data WHERE user_id = ".(int) $user->get('id');
			$db->setQuery($sql);
			$db->query();
//			if (JU_COMMUNITY_REM_ACTIVITY && $this->_checkComponent('community_activity'))
//			$this->_removeActivity($user);
			$this->_cleanUp($user);
			$ses = & JFactory::getSession();
			$ses->destroy();
			$this->setRedirect( (bool) $return ? $return : "index.php", JText::_("Your account is now deleted"));
			$this->_sendEmails($user, '', 'remove');
		}
		else
		{
			$this->setRedirect('index.php?option=com_juser&view=user&layout=remove', JText::_('The specified password is incorrect!'), 'notice');

		}

	}



	function isHtmlMessage($message)
	{
		if ( JString::strlen($message) != JString::strlen(strip_tags($message)))
		{
			return 1;
		}
		return 0;

	}

//////Activity for Mighty Community (PeopleTouch)//
//////////////////////////////////////////////////
	function _editActivity($user_id)
	{
		if (JFile::exists(JPATH_ROOT.DS.'components'.DS.'com_community'.DS.'api.php')){
			require_once (JPATH_ROOT.DS.'components'.DS.'com_community'.DS.'api.php');
			$msg = JText::_('Updated Profile');
			JSCommunityApi::registerActivity(0, 'has edited his/her details', $user_id, 'components/com_juser/images/changedetails.png','user',  null, 'com_juser', '', $msg);
		}
	}

//	function _removeActivity($user)
//	{
//		$db = &JFactory::getDBO();
//		$user_id = $user->get('id');
//		$name = $user->get('username');
//		require_once (JPATH_ROOT.DS.'components'.DS.'com_community'.DS.'api.php');
//		JSCommunityApi::registerActivity(0, $name.' has removed his/her details', $user_id, 'components/com_juser/images/removeaccount.png','user',  null, 'com_juser', '', 'Profile Update');
//	}

	function _joinActivity($user_id)
	{
		if (JFile::exists(JPATH_ROOT.DS.'components'.DS.'com_community'.DS.'api.php')){
			require_once (JPATH_ROOT.DS.'components'.DS.'com_community'.DS.'api.php');
			$msg = JText::_('Has Registered');
			JSCommunityApi::registerActivity(0, JText::_('has just registered'), $user_id, 'components/com_juser/images/register.png','user',  null, 'com_juser', '', $msg);
		}
	}

//Check component by its table name without Joomla's prefix
	function _checkComponent($table){
		$db = &JFactory::getDBO();
		$config =& JFactory::getConfig();
		$pref = $config->getValue( 'config.dbprefix' );
		$sql = "SHOW TABLES LIKE '{$pref}{$table}'";
		$db->setQuery($sql);
		$check = $db->loadResult();
		if ($check) return true;
		else return false;
	}

	function _cleanUp ($user){
			$db = &JFactory::getDBO();
			$user_id = $user->get('id');
			$username = $user->get('username');
		if (JU_COMMUNITY_CLEAN_ACTIVITY && $this->_checkComponent('community_activity')) {
			$sql = "DELETE FROM #__community_activity WHERE user_id = $user_id";
			$db->setQuery($sql);
			$db->query();
		}
		if (JU_COMMUNITY_CLEAN_RESOURCE && $this->_checkComponent('js_res_record')) {
			//@todo move this function to Resource's API or helper and also probably add this to admin user removal
			//cleanup content and user categories
				$sql = "DELETE rec.*, val.*, ucat.* FROM #__js_res_record AS rec\n".
				"LEFT JOIN #__js_res_record_values AS val ON val.record_id = rec.id\n".
				"LEFT JOIN #__js_res_category_user AS ucat ON ucat.id = rec.ucatid\n".
				"WHERE rec.user_id = $user_id;\n";
				$db->setQuery($sql);
				$db->query();
			//cleanup comments
				$sql = "DELETE FROM #__js_res_comments WHERE user_id = $user_id;";
				$db->setQuery($sql);
				$db->query();
			//cleanup files
				require_once (JPATH_ROOT.DS.'administrator'.DS.'components'.DS.'com_resource'.DS.'controllers'.DS.'config.php');
				ResControllerConfig::initialyze();
				if(JFolder::exists(RES_GENERAL_UPLOAD.DS.$user_id)) JFolder::delete(RES_GENERAL_UPLOAD.DS.$user_id);
				if(JFolder::exists(RES_GENERAL_UPLOAD.DS.'file'.DS.$user_id)) JFolder::delete(RES_GENERAL_UPLOAD.DS.'file'.DS.$user_id);
				if(JFolder::exists(RES_GENERAL_UPLOAD.DS.'picture'.DS.$user_id)) JFolder::delete(RES_GENERAL_UPLOAD.DS.'picture'.DS.$user_id);
		}
		if (JU_COMMUNITY_CLEAN_CONTENT) {
			//cleanup content from core tables created by user
				$sql = "DELETE FROM #__content WHERE created_by = $user_id;";
				$db->setQuery($sql);
				$db->query();
		}
		if (JU_COMMUNITY_CLEAN_SUBSCR && $this->_checkComponent('jcs_user_subscr')) {
			//cleanup subsriptions and assosiated info from Member component
				$sql = "DELETE `sub`.*, alr.* FROM #__jcs_user_subscr AS `sub`\n".
				"LEFT JOIN #__jcs_exp_alerts AS alr ON alr.user_subscription_id = `sub`.`id`\n".
				"WHERE `sub`.`user_id` = $user_id;";
				$db->setQuery($sql);
				$db->query();
			//cleanup subsription usage history
				$sql = "DELETE FROM #__jcs_history WHERE user_id = $user_id;";
				$db->setQuery($sql);
				$db->query();
		}
		if (JU_COMMUNITY_CLEAN_INBOX && $this->_checkComponent('js_inbox_sent')) {
			//cleanup Inbox messages and assosiated info from Member component
				$sql = "DELETE mes.*, snt.*, drf.*, jnk.* FROM #__js_inbox_messages AS mes\n".
				"LEFT JOIN #__js_inbox_sent AS snt ON snt.message_id = mes.id\n".
				"LEFT JOIN #__js_inbox_draft AS drf ON drf.message_id = mes.`id`\n".
				"LEFT JOIN #__js_inbox_junk AS jnk ON jnk.message_id = mes.`id`\n".
				"WHERE mes.user_id = $user_id;";
				$db->setQuery($sql);
				$db->query();
			//cleanup user's folders
				$sql = "DELETE FROM #__js_inbox_folders WHERE user_id = $user_id AND global = 0;";
				$db->setQuery($sql);
				$db->query();
			//cleanup user's address book
				$sql = "DELETE FROM #__js_inbox_address_book WHERE user_id_from = $user_id;";
				$db->setQuery($sql);
				$db->query();
			//cleanup user's history
				$sql = "DELETE FROM #__js_inbox_history WHERE who = $user_id OR whom = $user_id;";
				$db->setQuery($sql);
				$db->query();
			//cleanup files
//				require_once (JPATH_ROOT.DS.'administrator'.DS.'components'.DS.'com_jsinbox'.DS.'controllers'.DS.'cnf.php');
//				InboxControllerCnf::initialyze();
				if(JFile::exists(JPATH_ROOT.DS.'components'.DS.'com_jsinbox'.DS.'user_options'.DS.$user_id.'_'.$username))
					JFile::delete(JPATH_ROOT.DS.'components'.DS.'com_jsinbox'.DS.'user_options'.DS.$user_id.'_'.$username);
				if(JPATH_ROOT.DS.'components'.DS.'com_jsinbox'.DS.'user_options'.DS.$user_id)
					JFile::delete(JPATH_ROOT.DS.'components'.DS.'com_jsinbox'.DS.'user_options'.DS.$user_id);
		}


	}
}

?>