<?php
/**
 * $Id: helper.php 7311 2011-08-19 11:18:02Z shitz $
 * $LastChangedDate: 2011-08-19 17:18:02 +0600 (Fri, 19 Aug 2011) $
 * $LastChangedBy: shitz $
 * MightyRegistration by Mighty Extensions
 * a component for Joomla! 1.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mightyextensions.com/
 * @copyright Copyright (C) 2006 - 2011 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/

defined('_JEXEC') or die('Restricted access');
require_once(JPATH_ADMINISTRATOR.DS.'components'.DS.'com_juser'.DS.'includes'.DS.'helper.php');
class JSUserFrontHelper
{
	function renderFieldForPrint($uid, $field, $escaped = false)
	{
		$output = "";
		//$user = JFactory::getUser($uid);
		$db = &JFactory::getDBO();
		$params = new JParameter($field->params);
		switch($field->type)
		{
			case 'radio':
			case 'checkbox':
			case 'select':
			case 'mult_select':
			case 'text':
			case 'textarea':
				if ($params->get('allow_raw', 0))
				{
					$output.= str_replace("\n", "", str_replace("\r\n", "\n" ,$field->fvalue));
				}
				else
				{
					$output.= str_replace("\n", "<br/>", str_replace("\r\n", "\n" ,$field->fvalue));
				}
				break;
			case 'phone':
				$output.= str_replace("\n", ' ', $field->fvalue);
				break;
			case 'date':
			case 'calendar':
				if ($field->type == 'date' && $params->get('make_dynamic', 0))
				{
					$output.= JSUserHelper::countDateInterval($field->fvalue).' '.JText::_("Years");
				}
				else
				{
					$date = new JDate($field->fvalue);
					$output.= $date->toFormat(JText::_('DATE_FORMAT_LC1'));
				}
				break;
			case 'file':
				$output.= "<a target='_blank' href='".JURI::root().$params->get('path_to_upload')."/{$field->fvalue}'>{$field->fvalue}</a>";
				break;

			case 'link':
				if ($params->get('track_parent') && $field->fvalue == '')
				{
					$field->fvalue = JSUserFrontHelper::getParentLinkRecursively($field->id1, $uid);
				}
				$linkArray = explode("^", $field->fvalue);
				$linkUrl = @$linkArray[0];
				$linkTitle = (isset($linkArray[1]) && @$linkArray[1])? @$linkArray[1]:@$linkArray[0];
				$output.="<a href='{$linkUrl}' target='_blank' title='{$linkTitle}' />$linkTitle</a>";
				break;
			case 'javascript':
				//$escaped = true;
				$output = $field->fvalue;
				break;
			case 'separator':
				$contents = $params->get('contents');
				if ($contents){
					$output = "<div class=".$params->get('class', 'jusep').">".$contents."</div>";
				}
				break;
			default:
		}
		if ($escaped)
		{
			return $db->getEscaped($output);
		}
		else
		{
			return $output;
		}

	}

	function getParentLinkRecursively($field_id, $uid)
	{
		$db = &JFactory::getDBO();
		$sql = "SELECT pid FROM #__idev_jsintegration WHERE uid = ".(int)$uid;
		$db->setQuery($sql);
		$pid = $db->loadResult();
		$sql = "SELECT jed.fvalue FROM #__users AS u"
				."\n LEFT JOIN #__juser_extended_data AS jed ON jed.user_id = u.id "
				."\n INNER JOIN #__juser_extended_fields AS jef ON jef.id = jed.field_id "
				."\n WHERE 1 AND jef.published = 1 AND jef.id = {$field_id} AND jed.user_id = ".(int)$pid
				."\n ORDER BY jef.ordering";
		$db->setQuery($sql);
		$result = $db->loadResult();
		if (trim($result) == '' && $pid)
		{
			$result = JSUserFrontHelper::getParentLinkRecursively($field_id, $pid);
		}
		return $result;

	}
}
?>