<?php
/**
 * $Id: user.php 7311 2011-08-19 11:18:02Z shitz $
 * $LastChangedDate: 2011-08-19 17:18:02 +0600 (Fri, 19 Aug 2011) $
 * $LastChangedBy: shitz $
 * MightyRegistration by Mighty Extensions
 * a component for Joomla! 1.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mightyextensions.com/
 * @copyright Copyright (C) 2006 - 2011 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/

defined('_JEXEC') or die('Restricted access');

jimport('joomla.application.component.model');

class JUserModelUser extends JModel
{
	var $_id = null;
	var $_core_data = null;
	var $_extended_data = null;

	function __construct()
	{
		if( ! $this->_id){
			$array = JRequest::getVar('cid', array(0), '', 'array');
			$this->_id    = (int)$array[0];
		}
		parent::__construct();
	}

	function &getData()
	{

		// Load the user data
		if (!$this->_loadData()){
			$this->_initData();
		}
		$_data                = new stdClass();
		$_data->core_data     = & $this->_core_data;
		$_data->extended_data = & $this->_extended_data;

		return $_data;
	}

	function _loadData()
	{
		$layout = JRequest::getVar( 'layout' );

		if($layout == "mydetails"){
			$field_where[] = "f.params LIKE '%show_at_my_details_form=1%'";
		}
		else{
			$field_where[] = "f.params LIKE '%show_at_reg_form=1%'";
		}

		$field_where[] = "f.published = 1";

		// Lets load the user data if it doesn't already exist
		if (empty($this->_data)){
			$query = "SELECT a.id as key1, a.*,g.id as key2, g.name AS groupname"
			."\n        FROM      #__users                    AS a"
			."\n  INNER JOIN #__core_acl_aro             AS aro ON aro.value = a.id"
			."\n  INNER JOIN #__core_acl_groups_aro_map  AS gm  ON gm.aro_id = aro.id"
			."\n  INNER JOIN #__core_acl_aro_groups      AS g   ON g.id      = gm.group_id"
			."\n       WHERE a.id = ".(int) $this->_id;
			$this->_db->setQuery($query);
			$this->_core_data = $this->_db->loadObject();

			/*if(@$this->_core_data->name){
				$separated_name = explode ( " ", $this->_core_data->name);
				}	*/
			if (!empty($this->_core_data->name))
			{
				$separator_pos = strpos($this->_core_data->name, "\n");

			if ($separator_pos > 0){
	      	$this->_core_data->first_name = substr($this->_core_data->name, 0,  $separator_pos );
	      	$this->_core_data->last_name =  substr($this->_core_data->name, $separator_pos + 1);
	      	}
	      	else{
	      	$this->_core_data->first_name = $this->_core_data->name;
	      	$this->_core_data->last_name =  null;      		
      		}
			}

			/*$this->_core_data->first_name = isset($separated_name[0]) ? $separated_name[0] : '';
			 $this->_core_data->last_name  = isset($separated_name[1]) ? $separated_name[1] : '';*/

			$query = "SELECT f.id as field_id, f. * , c.id as key1, c.title as cat_title,  c.description as cat_description, d.id as key2,  d.fvalue"
			. "\n       FROM #__juser_extended_fields  AS f"
			. "\n  LEFT JOIN #__juser_extended_data   AS d ON f.id = d.field_id AND d.user_id = " . (int) $this->_id
			. "\n  LEFT JOIN #__categories            AS c ON c.id = f.catid"
			. "\n      WHERE 1 AND c.published = 1 ". (count($field_where) ? ' AND '.implode( ' AND ', $field_where) : '')
			. "\n GROUP BY f.id ORDER BY c.ordering, f.ordering"
			;

			$this->_db->setQuery($query);
			$this->_extended_data = $this->_db->loadObjectList();


			return (boolean) $this->_core_data && (boolean) $this->_extended_data;
		}
		return true;
	}

	function saveExtendedData($user_ext_data)
	{
		$r     = true;
		$table = $this->getTable('usersdata');
		foreach($user_ext_data as $field_id => $field_data){
			if ($field_data
			){
				$table->_bind( $this->_id, $field_id, $field_data );
				if(!$table->store())
				{
					$r = false;
				}
			}
			else
			{
				if($this->_id)
				{
					$table->_delete($this->_id, $field_id);
				}
			}
		}

		return $r;
	}

	function storeCoreData($data)
	{
		$user    = JFactory::getUser();
		$username  = $user->get('username');

		$data['name'] = trim($data['first_name'])."\n".trim($data['last_name']);
		// Bind the form fields to the user table
		if (!$user->bind($data)) {
			$this->setError($this->_db->getErrorMsg());
			return false;
		}

		// Store the web link table to the database
		if (!$user->save()) {
			$this->setError( $user->getError() );
			return false;
		}

		$session =& JFactory::getSession();
		$session->set('user', $user);

		// check if username has been changed
		if ( $username != $user->get('username') )
		{
			$table = $this->getTable('session', 'JTable');
			$table->load($session->getId());
			$table->username = $user->get('username');
			$table->store();

		}

		return true;
	}

	function &getPage()
	{
		$query = "SELECT c.id as id, c.*"
		."\n        FROM #__content AS c"
		."\n       WHERE c.id = ".JU_REGISTRATION_FORM_REGISTRATON_POLICY;
		$this->_db->setQuery($query);
		$page = $this->_db->loadObject();
		return $page;
	}

	function _initData()
	{
		// Lets load the content if it doesn't already exist
		if (empty($this->_data)){
			$user = new stdClass();

			$user->id             = 0;
			$user->name           = '';
			$user->username       = '';
			$user->email          = '';
			$user->password       = '';
			$user->usertype       = '';
			$user->block          = 0;
			$user->sendEmail      = 0;
			$user->gid            = 1;
			$user->registerDate   = '0000-00-00 00:00:00';
			$user->lastvisitDate  = '0000-00-00 00:00:00';
			$user->activation     = '';
			$user->params         = '';

			$this->_data          = $user;
			return (boolean)$this->_data;
		}
		return true;
	}
	function activateNotFound($redirect = true){
			global $mainframe;
			$document = &JFactory::getDocument();
			$pathway 	=& $mainframe->getPathWay();		
			// Page Title
			$document->setTitle( JText::_( 'REG_ACTIVATE_NOT_FOUND_TITLE' ) );
			// Breadcrumb
			$pathway->addItem( JText::_( 'REG_ACTIVATE_NOT_FOUND_TITLE' ));

			$message->title = JText::_( 'REG_ACTIVATE_NOT_FOUND_TITLE' );
			$message->text = JText::_( 'REG_ACTIVATE_NOT_FOUND' );
			$mainframe->enqueueMessage( $message->title );
			$mainframe->enqueueMessage( $message->text );
			if ($redirect)	$this->setRedirect('index.php?option=com_juser&task=register');	
	}
	
	function activateSucess($redirect = true, $type = 'REG_ACTIVATE'){
			global $mainframe;
			$document = &JFactory::getDocument();
			$pathway 	=& $mainframe->getPathWay();		
			// Page Title
			$document->setTitle( JText::_( $type.'_COMPLETE_TITLE' ) );
			// Breadcrumb
			$pathway->addItem( JText::_( $type.'_COMPLETE_TITLE' ));

			$message->title = JText::_( $type.'_COMPLETE_TITLE' );
			$message->text = JText::_( $type.'_COMPLETE' );
			$mainframe->enqueueMessage( $message->title );
			$mainframe->enqueueMessage( $message->text );
			if ($redirect)
				$this->setRedirect('index.php?option=com_juser&view=user&layout=login');	
	}
}
?>