<?php
/**
 * $Id: userlist.php 7311 2011-08-19 11:18:02Z shitz $
 * $LastChangedDate: 2011-08-19 17:18:02 +0600 (Fri, 19 Aug 2011) $
 * $LastChangedBy: shitz $
 * MightyRegistration by Mighty Extensions
 * a component for Joomla! 1.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mightyextensions.com/
 * @copyright Copyright (C) 2006 - 2011 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/

defined('_JEXEC') or die('Restricted access');

jimport('joomla.application.component.model');

class JUserModelUserlist extends JModel
{
	var $_published_extended_fields;
	var $_total = null;
	var $_pagination = null;
	var $_extended_fields;
	function __construct()
	{
		global $mainframe, $option;
		parent::__construct();

		$limit		= $mainframe->getUserStateFromRequest( 'global.list.limit', 'limit', JU_LIST_LIMIT, 'int' );
		$limitstart	= JRequest::getVar('limitstart', 0, '', 'int');

		$this->setState( 'limit',      (int)$limit);
		$this->setState( 'limitstart', $limitstart );
		$this->_extended_fields = $this->getExtendedFields();

	}

	function getUserForProfile()
	{
		global $ju_current_user;

		$user_id = JRequest::getVar('id');
		if( !$user_id ){
			$user_id = $ju_current_user->core_data->id;
		}

		$query = "SELECT a.*,g.id AS key2, g.name AS groupname "//.$field_otput_list
		. "\n       FROM #__users AS a"
		. "\n INNER JOIN #__core_acl_aro AS aro ON aro.value = a.id"
		. "\n INNER JOIN #__core_acl_groups_aro_map AS gm ON gm.aro_id = aro.id"
		. "\n INNER JOIN #__core_acl_aro_groups AS g ON g.id = gm.group_id"
		//. "\n LEFT  JOIN #__session AS s ON s.userid = a.id"
		//. "\n ".$extended_fields_left_joines
		//. "\n WHERE a.id = ".$user_id
		. "\n GROUP BY a.id";
		//. "\n ".$orderby;


		if ($user_id)
		{
			$user = &JFactory::getUser($user_id);
		}
		return $user;
	}



	function getProfileFieldOutputList()
	{
		$result = array();
		foreach($this->_extended_fields as $field){
			$parameters = new JParameter( $field->params);
			if($parameters->get('show_at_userlist_profile') == 1){
				$result[] = $field->id;
			}
		}

		return $result;//count($result) ? ', '.implode(', ', $result ) : '';
	}

	function getUserListForCards()
	{
		global $mainframe;
		$query = $this->_buildQueryUsersCards();
		$user_list = $this->_getList($query, $this->getState('limitstart'), $this->getState('limit'));
		for($i = 0; $i < count($user_list); $i++)
		{
			$user = &$user_list[$i];
			$user->additional_data = $this->getAdditionalFields($user->id,'card');
		}
		return $user_list;
	}

	function getTotalCards()
	{
		global $mainframe, $option;
		if (empty($this->_total))
		{
			$extended_fields             = $this->getSearcheableExtendedFields();
			$all_extended_fields         = $this->getExtendedFields();
			//$field_otput_list            = $this->getCardFieldOutputList( $all_extended_fields );
			$extended_fields_left_joines = $this->getCardExtendedFieldsLeftJoins( $all_extended_fields);
			$where                       = $this->_buildUsersCardsWhere( $extended_fields );
			$filter_logged = $mainframe->getUserStateFromRequest( "$option.filter_logged", 'filter_logged', 0,  'int' );
			$filter_logged = $mainframe->getUserStateFromRequest( "$option.filter_logged", 'filter_logged', 0,  'int' );
			/*$loggedin = '(SELECT COUNT(s.userid)'
			 . '   FROM #__session AS s'
			 . '  WHERE s.userid = a.id)';*/
			$loggedin = "";
			if ($filter_logged == 1 || $filter_logged == 2)
			{
				$loggedin = "\n INNER JOIN #__session AS s ON s.userid = a.id";
			}

			$query = "SELECT COUNT(*) "
			. "\n       FROM #__users AS a"
			. "\n INNER JOIN #__core_acl_aro AS aro ON aro.value = a.id"
			. "\n INNER JOIN #__core_acl_groups_aro_map AS gm ON gm.aro_id = aro.id"
			. "\n INNER JOIN #__core_acl_aro_groups AS g ON g.id = gm.group_id"
			.$loggedin
			. "\n " . $extended_fields_left_joines
			. "\n " . $where
			;
			$this->_db->setQuery($query);
			$this->_total = $this->_db->loadResult();
			//$query = $this->_buildQueryUsersCards();

		}


		return $this->_total;
	}

	/*function getPagination()
	 {
		jimport('joomla.html.pagination');
		return new JPagination( $this->getTotalCards(), $this->getState('limitstart'), $this->getState('limit') );
		}*/
	function &getPagination()
	{
		// Lets load the content if it doesn't already exist
		if (empty($this->_pagination))
		{
			jimport('joomla.html.pagination');
			$this->_pagination = new JPagination( $this->getTotalCards(), $this->getState('limitstart'), $this->getState('limit') );
		}

		return $this->_pagination;
	}


	function _buildQueryUsersCards()
	{
		global $mainframe, $option;
		$extended_fields             = $this->getSearcheableExtendedFields();
		$all_extended_fields         = $this->getExtendedFields();
		//$field_otput_list          = $this->getCardFieldOutputList( $all_extended_fields );
		$extended_fields_left_joines = $this->getCardExtendedFieldsLeftJoins( $all_extended_fields);
		$where                       = $this->_buildUsersCardsWhere( $extended_fields );
		$orderby                     = $this->_buildUsersCardsOrderBy();
		$filter_logged 				 = $mainframe->getUserStateFromRequest( "$option.filter_logged", 'filter_logged', 0,  'int' );
		/*$loggedin = '(SELECT COUNT(s.userid)'
		 . '   FROM #__session AS s'
		 . '  WHERE s.userid = a.id)';*/
		$loggedin = "";
		if ($filter_logged == 1 || $filter_logged == 2)
		{
			$loggedin = "\n INNER JOIN #__session AS s ON s.userid = a.id";
		}
		if (JU_REGISTRATION_FORM_LAST_NAME_ENABLE)
		{
			$select_flname = "IF(LOCATE('\n', a.name) > 0, LEFT(a.name, LOCATE('\n', a.name)), a.name) AS first_name, IF(LOCATE('\n', a.name) > 0, SUBSTRING(a.name, (LOCATE('\n', a.name) + 1)), NULL) AS last_name,";
		}
		else
		{
			$select_flname = null;
		}

		$query = "SELECT a.id AS key1, $select_flname a.*, g.id AS key2,  g.name AS groupname "//$field_otput_list
		. "\n FROM #__users AS a"
		. "\n INNER JOIN #__core_acl_aro AS aro ON aro.value = a.id"
		. "\n INNER JOIN #__core_acl_groups_aro_map AS gm ON gm.aro_id = aro.id"
		. "\n INNER JOIN #__core_acl_aro_groups AS g ON g.id = gm.group_id"
		.$loggedin
		. "\n ".$extended_fields_left_joines
		. "\n " . $where
		. "\n   GROUP BY a.id"
		. "\n  ".$orderby;

		return $query;
	}
	function getFieldsForOrdering()
	{
		global $mainframe, $option;
		$extended_fields             = $this->getSearcheableExtendedFields();

		$options = array();
		$options[] = JHTML::_('select.option', "a.registerDate", JText::_("Registration Date"));
		$options[] = JHTML::_('select.option', "a.lastvisitDate", JText::_("Last visit date"));
		$options[] = JHTML::_('select.option', "a.name", JText::_("Name"));
		$options[] = JHTML::_('select.option', "a.username", JText::_("Username"));
		//$options[] = JHTML::_('select.option', "loggedin", JText::_("Logged in"));
		$options[] = JHTML::_('select.option', "a.usertype", JText::_("Usertype"));
		$filter_order    = $mainframe->getUserStateFromRequest( $option.'.userlist.filter_order',    'filter_order',    'a.registerDate',  'cmd' );
		$filter_order_Dir  = $mainframe->getUserStateFromRequest( $option.'.userlist.filter_order_Dir',  'filter_order_Dir',  'DESC',        'word' );

		/*	foreach ($extended_fields as $field)
		 {
			$params = new JParameter($field->params);
			if ($params->get('show_at_userlist_card', 0))
			{
			$options[] = JHTML::_('select.option', 'field_'.$field->id.'.fvalue', $field->title );
			}
			}*/
		$type = array();
		$type[] = JHTML::_('select.option', "ASC", JText::_("ASC"));
		$type[] = JHTML::_('select.option', "DESC", JText::_("DESC"));


		$lists['order'] = JHTML::_('select.genericlist', $options, "filter_order", "class='inputbox'" , 'value', 'text', $filter_order);
		$lists['order_Dir'] = JHTML::_('select.genericlist', $type, "filter_order_Dir", "class='inputbox'" , 'value', 'text', $filter_order_Dir);
		return $lists;



	}
	function _buildUsersCardsOrderBy()
	{
		$orderby = '';
		global $mainframe, $option;

		$filter_order    = $mainframe->getUserStateFromRequest( $option.'.userlist.filter_order',    'filter_order',    'a.registerDate',  'cmd' );
		$filter_order_Dir  = $mainframe->getUserStateFromRequest( $option.'.userlist.filter_order_Dir',  'filter_order_Dir',  '',        'word' );
		if ($filter_order){
			$orderby   = ' ORDER BY '.$filter_order.' '.$filter_order_Dir.' ';
		}
		return $orderby;
	}



	function getCardExtendedFieldsLeftJoins( $extended_fields)
	{
		global $mainframe, $option;
		$mparams  = $mainframe->getParams();
		$result = array();
		$incl = true;

		foreach($extended_fields as $field){
			$params = new JParameter($field->params);
				
			$search        = $mainframe->getUserStateFromRequest( "$option.search",        'search',        '', 'string' );
			if ( (($mainframe->getUserState( 'filter_'.$field->alias ) || (JRequest::getVar('filter_'.$field->alias)) &&  $params->get('searcheable', 0))) || (trim($search)!= '' && $params->get('searcheable', 0)))
			{
				$result[] = "\n LEFT JOIN #__juser_extended_data as field_".$field->field_id." ON a.id = field_".$field->field_id.".user_id AND field_".$field->field_id.".field_id = ".$field->field_id;
			}
			
			if ($field->field_id == $mparams->get('zip_field') && count($result)){
				$incl = false;
			}
		}
		if($mparams->get('zip_field', '') && $mparams->get('show_zip_filters', 0)){
			if ($incl){
				$result[] = "LEFT JOIN #__juser_extended_data AS field_".$mparams->get('zip_field')." ON field_".$mparams->get('zip_field').".user_id = a.id AND field_".$mparams->get('zip_field').".field_id = ".$mparams->get('zip_field');
			}
			$result[] = " LEFT JOIN #__juser_zip_code as zip ON field_".$mparams->get('zip_field').".fvalue = zip.zip_code";
		}
		return implode("\n",$result);
	}

	function _buildUsersCardsWhere( $extended_fields )
	{
		global $mainframe, $option, $ju_current_user;
		$allowed_groups = defined("JU_LIST_ALLOWGROUPS") ? explode("\n", JU_LIST_ALLOWGROUPS):null;
		$db          = & JFactory::getDBO();
		$acl         = & JFactory::getACL();
		$currentUser = & JFactory::getUser();
		$params      = & $mainframe->getParams();

		$search_zip_distance  = $mainframe->getUserStateFromRequest( $option.'.search_zip_distance',	'search_zip_distance',  '0',  'string' );
		$search_self_zip_code = $mainframe->getUserStateFromRequest( $option.'.search_self_zip_code', 'search_self_zip_code', '',  'string' );
		$search_zip_point     = $mainframe->getUserStateFromRequest( $option.'.search_zip_point',     'search_zip_point',     'm', 'string' );

		$filter_type   = $mainframe->getUserStateFromRequest( "$option.filter_type",   'filter_type',   0,  'string' );
		$filter_logged = $mainframe->getUserStateFromRequest( "$option.filter_logged", 'filter_logged', 0,  'int' );
		$search        = $mainframe->getUserStateFromRequest( "$option.search",        'search',        '', 'string' );
		$search        = JString::strtolower( $search );



		$where = array();


		if( $search_zip_distance && $search_self_zip_code && $params->get('zip_field') && $params->get('show_zip_filters')){

			$query = "SELECT zip.*"
			."\n      FROM #__juser_zip_code AS zip, #__juser_extended_data as f_val"
			."\n      WHERE f_val.user_id = ".(int)$ju_current_user->core_data->id." AND f_val.field_id = ".$params->get('zip_field')." AND zip.zip_code = f_val.fvalue";
			;
			$zip_param = $this->_getList( $query );
			if (count($zip_param))
			{
				$zip_param = $zip_param[0];
				$multiplier = array('m' => 1, 'k' => 1.609344, 'n' => 0.8684);
				$where[] = '(DEGREES(acos(sin(RADIANS(zip.lat)) * sin(RADIANS('.$zip_param->lat.')) +  cos(RADIANS(zip.lat)) * cos(RADIANS('.$zip_param->lat.')) * cos(RADIANS(zip.lon - ('.$zip_param->lon.'))))) * 60 * 1.1515) <= '.$search_zip_distance * $multiplier[$search_zip_point];
			}
			/*else
			 {
				JError::raiseNotice(400, JText::_('Please login to use distance search'));
				}*/
		}

		//filter by usertype
		if ( $filter_type ){
			if ( $filter_type == 'Public Frontend' ){
				$where[] = ' a.usertype = \'Registered\' OR a.usertype = \'Author\' OR a.usertype = \'Editor\' OR a.usertype = \'Publisher\' ';
			}
			else if ( $filter_type == 'Public Backend' ){
				$where[] = 'a.usertype = \'Manager\' OR a.usertype = \'Administrator\' OR a.usertype = \'Super Administrator\' ';
			}
			else{
				$where[] = 'a.usertype = LOWER( '.$db->Quote($filter_type).' ) ';
			}
		}

		//filter by userlogged
		if ( $filter_logged == 1 ){
			$where[] = 's.userid = a.id';
		}
		else if ($filter_logged == 2){
			$where[] = 's.userid IS NULL';
		}

		//search by username, email, name
		if (isset( $search ) && $search != ''){
			$searchEscaped = $db->Quote('%'.$search.'%');
			$where[] = $this->makeConditionTextLike( $searchEscaped, $extended_fields );
		}

		$where[] = $this->makeConditionSelectLike( $extended_fields );

		if ( isset($filter_state) && $filter_state ) {
			if ( $filter_state == 'P' ) {
				$where[] = 'a.published = 1';
			} else if ($filter_state == 'U' ) {
				$where[] = 'a.published = 0';
			}
		}

		// exclude any child group id's for this user
		/*$pgids = $acl->get_group_children( $currentUser->get('gid'), 'ARO', 'RECURSE' );

		if (is_array( $pgids ) && count( $pgids ) > 0)
		{
		JArrayHelper::toInteger($pgids);
		$where[] = 'a.gid NOT IN (' . implode( ',', $pgids ) . ')';
		}*/
		$where [] = " a.block = 0 ";
		$allowed_groups = defined("JU_LIST_ALLOWGROUPS") ? explode("\n", JU_LIST_ALLOWGROUPS) : array(18);

		if (!empty($allowed_groups))
		{
			$where[] = " a.gid IN (".implode(' , ', $allowed_groups).") ";

		}
		if (count($where))
		{
			$where     = ( count( $where ) ? ' WHERE '. implode( ' AND ', $where ) : '' );
		}

		return $where;
	}

	function getSearcheableExtendedFields()
	{
		$query = "SELECT f.id as field_id, f.*, cc.id as key1"
		."\n      FROM #__juser_extended_fields AS f"
		."\n LEFT JOIN #__categories as cc ON cc.id = f.catid"
		."\n     WHERE f.params LIKE '%searcheable=1%' AND f.published = 1"
		."\n  GROUP BY f.id"
		."\n  ORDER BY cc.ordering, f.ordering";
		return $this->_data = $this->_getList( $query );
	}

	function getExtendedFields()
	{
		if( !count($this->_published_extended_fields) ){
			$query = "SELECT  f.id as field_id, f.*, cc.id as key2, cc.title as cat_title"
			."\n      FROM #__juser_extended_fields AS f"
			."\n LEFT JOIN #__categories as cc ON cc.id = f.catid"
			."\n     WHERE f.published = 1"
			."\n  GROUP BY f.id"
			."\n  ORDER BY cc.ordering, f.ordering"
			;
			$this->_published_extended_fields = $this->_getList( $query );
		}
		return $this->_published_extended_fields;
	}

	function makeConditionTextLike( $searchEscaped, $extended_fields )
	{
		if(!$searchEscaped) return '1';

		$result[] = "a.username LIKE ".$searchEscaped."";
		$result[] = "a.email    LIKE ".$searchEscaped."";
		$result[] = "a.name     LIKE ".str_replace(" ", "\n", $searchEscaped)."";

		$searcheableTypesLikeText = array( 'text','textarea' );

		foreach($extended_fields as $field){
			if(in_array($field->type, $searcheableTypesLikeText )){
				$result[] = "field_".$field->field_id.".fvalue LIKE ".$searchEscaped;
			}
		}

		return '('.implode( ' OR ', $result ).')';
	}

	function makeConditionSelectLike( $extended_fields )
	{
		$result = array();

		foreach($extended_fields as $field){
			$selected = $this->getFilterValue( $field->alias );

			if( !$selected ){ continue; }
			$selected = $this->_db->Quote($selected);
			switch($field->type){
				case 'select':
				case 'radio':
					$result[] = "field_".$field->field_id.".fvalue = ".$selected;
					break;
				case 'mult_select':
				case 'checkbox':
					$result[] = "CONCAT(' ',field_".$field->field_id.".fvalue,' ') LIKE CONCAT('%',".$selected.",'%')";
					break;
			}

		}
		if (count ($result) > 0){
			return implode( ' AND ', $result );
		} else {
			return '1';
		}
	}

	function getFilterValue( $field_alias )
	{
		global $mainframe;
		if(!isset($_REQUEST['filter_'.$field_alias])){
			$result = $mainframe->getUserState( 'filter_'.$field_alias );
		} else {
			$result = JRequest::getVar('filter_'.$field_alias );
		}

		return $result;
	}

	function getAdditionalFields($uid, $type = 'card')
	{
		static $access = null;
		if(empty($access))
		{
			$current_user = &JFactory::getUser();
			$access = $current_user->get("aid");
		}
		$typewhere = "";
		switch($type)
		{
			case 'card':
				$typewhere = "\n AND f.params LIKE '%show_at_userlist_card=1%'";
				break;
			case 'profile':
				$typewhere = "\n AND f.params LIKE '%show_at_userlist_profile=1%'";
				break;
		}
		$sql = "SELECT fv.fvalue, cc.id AS catid, cc.title AS cattitle, f.id AS fieldid, f.title, f.type, f.params FROM #__juser_extended_data AS fv"
		."\n INNER JOIN #__juser_extended_fields AS f ON fv.field_id = f.id"
		."\n INNER JOIN #__categories AS cc ON cc.id = f.catid "
		."\n WHERE fv.user_id = {$uid} AND f.published = 1 AND f.access <= $access AND cc.published = 1"
		.$typewhere
		."\n ORDER BY cc.ordering, f.ordering"
		."";
		$this->_db->setQuery($sql);

		$fields = $this->_db->loadObjectList();
		return $fields;

	}
}
?>
