<?php
/**
 * $Id: view.html.php 7311 2011-08-19 11:18:02Z shitz $
 * $LastChangedDate: 2011-08-19 17:18:02 +0600 (Fri, 19 Aug 2011) $
 * $LastChangedBy: shitz $
 * MightyRegistration by Mighty Extensions
 * a component for Joomla! 1.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mightyextensions.com/
 * @copyright Copyright (C) 2006 - 2011 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/

defined('_JEXEC') or die('Restricted access');
jimport( 'joomla.application.component.view');

class JUserViewUserlist extends JView
{
	function display($tpl = null)
	{

		$layout = JRequest::getVar('layout', 'default');
		if (!$this->{'_init'.$layout}())
		{
			return;
		}

		parent::display($tpl);
	}

	function _initDefault()
	{
		global $mainframe, $option, $ju_current_user;
		defined("JU_LIST_ACCESS") or define('JU_LIST_ACCESS', 0);
		$listAccess = (int)JU_LIST_ACCESS;
		$user = JFactory::getUser();
		$uri  = & JFactory::getURI();
		switch($listAccess)
		{
			case 1:
				if ($user->get('aid') < 1)
				{
					JError::raiseWarning(301, JText::_("Please login to access this page"));
					$mainframe->redirect(JRoute::_("index.php?option=com_juser&view=user&layout=login&return=".base64_encode($uri->toString()), false));
				}
				break;
			case 2:
				if ($user->get('aid') < 2)
				{
					JError::raiseError(404, JText::_("You have not enough rights to access this page"));
				}
				break;
			case 0:
			default:
				break;
		}

		$users                = $this->get('UserListForCards');
		$pagination           = &$this->get('Pagination');
		//$pathway	            = & $mainframe->getPathway();
		$params               = & $mainframe->getParams();
		//$pathway->addItem( JText::_('User list') );

		jimport('joomla.utilities.date');
		//$default_self_zip_code = $ju_current_user->extended_data
		$default_self_zip_code = '';
		if($params->get('zip_field')){
			foreach($ju_current_user->extended_data as $field) {
				if($field->field_id == $params->get('zip_field')){
					$default_self_zip_code = $field->fvalue;
					break;
				}
			}
		}

		$search_zip_distance  = $mainframe->getUserStateFromRequest( $option.'.search_zip_distance',	'search_zip_distance',  '0',  'string' );
		$search_self_zip_code = $mainframe->getUserStateFromRequest( $option.'.search_self_zip_code', 'search_self_zip_code', $default_self_zip_code,  'string' );
		$search_zip_point     = $mainframe->getUserStateFromRequest( $option.'.search_zip_point',     'search_zip_point',     'm', 'string' );

		$filter_type   = $mainframe->getUserStateFromRequest( $option.'.userlist.filter_type',		'filter_type',   0,  'string' );
		$filter_logged = $mainframe->getUserStateFromRequest( $option.'.userlist.filter_logged',	'filter_logged', 0,  'int' );

		$lists['order']		= $mainframe->getUserStateFromRequest( $option.'.list.filter_order',		'filter_order',		'a.registerDate',	'cmd' );
		$lists['order_Dir']	= $mainframe->getUserStateFromRequest( $option.'.list.filter_order_Dir',	'filter_order_Dir',	'DESC',	'word' );

		$search        = $mainframe->getUserStateFromRequest( $option.'.search',			  'search', 			 '', 'string' );

		$lists['type'] = $this->getUserTypeList($filter_type);

		// get list of Log Status for dropdown filter
		$logged[] = JHTML::_('select.option',  0, '- '. JText::_( 'Select Log Status' ) .' -');
		$logged[] = JHTML::_('select.option',  1, JText::_( 'Logged In' ) );

		$lists['logged'] = JHTML::_('select.genericlist',   $logged, 'filter_logged', 'class="inputbox" size="1" onchange="document.adminForm.submit( );"', 'value', 'text', "$filter_logged" );

		$lists['extended_fields_filters'] = $this->getExtendedFieldsFilters();



		//$sorting = $this->get("FieldsForOrdering");
		$limit		  = $mainframe->getUserStateFromRequest('com_content.userlist.limit', 'limit', 5, 'int');
		$limitstart	= JRequest::getVar('limitstart', 0, '', 'int');

		/*jimport('joomla.html.pagination');
		$pagination = new JPagination( $this->get('TotalCards'), $limitstart, $limit );*/




		$diatance_points[] = JHTML::_('select.option',  'm', JText::_( 'Miles' ) );
		$diatance_points[] = JHTML::_('select.option',  'k', JText::_( 'Kilometers' ) );
		$diatance_points[] = JHTML::_('select.option',  'n', JText::_( 'Nautical miles' ) );

		$lists['search_zip_point'] = JHTML::_('select.genericlist',   $diatance_points, 'search_zip_point', 'class="inputbox" size="1" ', 'value', 'text', "$search_zip_point" );


		$this->assignRef('search_zip_point',	   $search_zip_point);
		$this->assignRef('search_zip_distance',	   $search_zip_distance);
		$this->assignRef('search_self_zip_code',   $search_self_zip_code);
		$this->assignRef('users',	               $users);
		$this->assignRef('lists',		           $lists);
		$this->assignRef('search',	               $search);
		$this->assignRef('action',                 $uri->toString());
		$this->assignRef('pagination',             $pagination);

		$this->assignRef('jdate_',                 $jdate_);
		$this->assignRef('params',		           $params);
		//$this->assignRef('sort',		             $sorting);
		return true;
	}

	function _initProfile()
	{
		global $mainframe, $ju_current_user;
		$uri = &JFactory::getURI();
		require_once(JPATH_COMPONENT_SITE.DS.'api.php');
		if( !JRequest::getVar( 'id', '' ) && !$ju_current_user->core_data->id){
			JError::raiseNotice('345', JText::_('This page is not available'));
			return false;
		}
		defined("JU_CARD_ACCESS") or define('JU_CARD_ACCESS', 0);
		$listAccess = (int)JU_CARD_ACCESS;
		$currentUser = &JFactory::getUser();
		switch($listAccess)
		{
			case 1:
				if ($currentUser->get('aid') < 1)
				{
					JError::raiseWarning(301, JText::_("Please login to access this page"));
					$mainframe->redirect(JRoute::_("index.php?option=com_juser&view=user&layout=login&return=".base64_encode($uri->toString()), false));
				}
				break;
			case 2:
				if ($currentUser->get('aid') < 2)
				{
					JError::raiseError(404, JText::_("You have not enough rights to access this page"));
				}
				break;
			case 0:
			default:
				break;


		}

		$pathway	             = & $mainframe->getPathway();
		$user                    = $this->get('UserForProfile');
		$fields                  = $this->get('ProfileFieldOutputList');
		$all_fields 			 = $this->get('ExtendedFields');
		$params                  = & $mainframe->getParams();
		$additionalData          = JSUserApi::getFieldValue($user->id, $fields, $all_fields);

		$pathway->addItem( JText::_('User Profile') );

		jimport('joomla.utilities.date');
		//if(!$card_extended_fields){ $card_extended_fields = array(); }

		$this->assignRef('user',	                  $user);
		//$this->assignRef('profile_extended_fields', $profile_extended_fields);
		$this->assignRef('params',		              $params);
		$this->assignRef('additionalData',		    $additionalData);
		return true;
	}

	function getAvatarPath( & $user )
	{
		$is_file_exist = false;
		jimport('joomla.filesystem.folder');

		$files = JFolder::files(JPATH_ROOT.DS.JU_GENERAL_AVATARS_DIR);

		foreach ($files as $file)
		{
			if(substr($file,0,(strlen($file)-strlen(strrchr($file,'.')))) == $user->username ){
				$is_file_exist = true;
				$extention = substr( strrchr( $file, '.' ), 1 );
			}
		}

		$avurlpath = JURI::root().str_replace('\\', '/',JU_GENERAL_AVATARS_DIR).'/';
		if($is_file_exist){
			$path = $avurlpath.$user->username.'.'.$extention;
		} else {
			$path = JURI::root().'components/com_juser/images/default_avatar.png';
		}
		return $path;
	}

	function getFirstName( & $user ){
		if($user->name){
			$t = explode( "\n", $user->name );
		}
		if(isset($t[0])){
			return $t[0];
		} else {
			return '';
		}
	}

	function getLastName( & $user ){
		if($user->name){
			$t = explode( "\n", $user->name );
		}
		if(isset($t[1])){
			return $t[1];
		} else {
			return '';
		}
	}

	function getUserTypeList($currentValue='')
	{
		$allowed_groups = defined("JU_LIST_ALLOWGROUPS") ? explode("\n", JU_LIST_ALLOWGROUPS) : array(18);
		$where = '';
		if (!empty($allowed_groups))
		{
			$where = " AND `id` IN (".implode(' , ', $allowed_groups).") ";

		}

		$db				=& JFactory::getDBO();
		$query = 'SELECT name AS value, name AS text'
		. ' FROM #__core_acl_aro_groups'
		. ' WHERE name != "ROOT"'
		. ' AND name != "USERS"'
		. $where
		;
		$db->setQuery( $query );
		$types[] 		= JHTML::_('select.option',  '0', '- '. JText::_( 'Select Group' ) .' -' );
		foreach( $db->loadObjectList() as $obj ){
			$types[] = JHTML::_('select.option',  $obj->value, JText::_( $obj->text ) );
		}
		$type_list = JHTML::_('select.genericlist',   $types, 'filter_type', 'class="inputbox" size="1" onchange="document.adminForm.submit( );"', 'value', 'text', "$currentValue" );
		return $type_list;
	}

	function getExtendedFieldsFilters()
	{
		global $mainframe;

		$fields = $this->get('SearcheableExtendedFields');
		$field_types_for_searchlist = array('select', 'mult_select', 'checkbox', 'radio');

		$result = array();
		foreach ( $fields as $field ){
			if( in_array( $field->type, $field_types_for_searchlist ) ){

				if(!isset($_REQUEST['filter_'.$field->alias])){
					$selected = $mainframe->getUserState( 'filter_'.$field->alias );
				} else {
					$selected = JRequest::getVar('filter_'.$field->alias );
				}

				$mainframe->setUserState( 'filter_'.$field->alias, $selected );

				$result[] = $this->getFilterSelectList( $field, $selected );

			}
		}
		return implode (' ', $result);
	}

	function getFilterSelectList( $field, $selected = '' )
	{
		$params     = new JParameter( $field->params);

		$values = explode( "\n", str_replace( "\r" , "" , $params->get('values') ) );

		$options[] = JHTML::_('select.option', '',JText::_("- select")." ".FFrame::str_limit($field->title, 30)." -");

		foreach($values as $value){
			$options[] = JHTML::_('select.option', $value, FFrame::str_limit($value, 30) );
		}
		return JHTML::_('select.genericlist', $options, 'filter_'.$field->alias, 'class="inputbox" size="1" onchange="document.adminForm.submit( );"', 'value', 'text', $selected );
	}

}
?>